/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(SUBTLE_CRYPTO)

#include "JSAesCbcCfbParams.h"

#include "JSDOMConvertBufferSource.h"
#include "JSDOMConvertStrings.h"
#include "JSDOMConvertUnion.h"
#include <runtime/JSCInlines.h>
#include <wtf/Variant.h>

using namespace JSC;

namespace WebCore {

#if ENABLE(SUBTLE_CRYPTO)

template<> CryptoAlgorithmAesCbcCfbParams convertDictionary<CryptoAlgorithmAesCbcCfbParams>(ExecState& state, JSValue value)
{
    VM& vm = state.vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&state, throwScope);
        return { };
    }
    CryptoAlgorithmAesCbcCfbParams result;
    JSValue nameValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "name"));
    if (!nameValue.isUndefined()) {
        result.name = convert<IDLDOMString>(state, nameValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "name", "AesCbcCfbParams", "DOMString");
        return { };
    }
    JSValue ivValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "iv"));
    if (!ivValue.isUndefined()) {
        result.iv = convert<IDLUnion<IDLArrayBufferView, IDLArrayBuffer>>(state, ivValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "iv", "AesCbcCfbParams", "(ArrayBufferView or ArrayBuffer)");
        return { };
    }
    return result;
}

#endif

} // namespace WebCore

#endif // ENABLE(SUBTLE_CRYPTO)
