/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSBasicCredential.h"

#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvertStrings.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMWrapperCache.h"
#include <runtime/FunctionPrototype.h>
#include <runtime/JSCInlines.h>
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

// Attributes

JSC::EncodedJSValue jsBasicCredentialConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSBasicCredentialConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);
JSC::EncodedJSValue jsBasicCredentialId(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsBasicCredentialType(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);

class JSBasicCredentialPrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSBasicCredentialPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSBasicCredentialPrototype* ptr = new (NotNull, JSC::allocateCell<JSBasicCredentialPrototype>(vm.heap)) JSBasicCredentialPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSBasicCredentialPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSBasicCredentialConstructor = JSDOMConstructorNotConstructable<JSBasicCredential>;

template<> JSValue JSBasicCredentialConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSBasicCredentialConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSBasicCredential::prototype(vm, globalObject), DontDelete | ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String(ASCIILiteral("Credential"))), ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), ReadOnly | DontEnum);
}

template<> const ClassInfo JSBasicCredentialConstructor::s_info = { "Credential", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSBasicCredentialConstructor) };

/* Hash table for prototype */

static const HashTableValue JSBasicCredentialPrototypeTableValues[] =
{
    { "constructor", DontEnum, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsBasicCredentialConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSBasicCredentialConstructor) } },
    { "id", ReadOnly | CustomAccessor | DOMAttribute, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsBasicCredentialId), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "type", ReadOnly | CustomAccessor | DOMAttribute, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsBasicCredentialType), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
};

const ClassInfo JSBasicCredentialPrototype::s_info = { "CredentialPrototype", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSBasicCredentialPrototype) };

void JSBasicCredentialPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSBasicCredential::info(), JSBasicCredentialPrototypeTableValues, *this);
}

const ClassInfo JSBasicCredential::s_info = { "Credential", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSBasicCredential) };

JSBasicCredential::JSBasicCredential(Structure* structure, JSDOMGlobalObject& globalObject, Ref<BasicCredential>&& impl)
    : JSDOMWrapper<BasicCredential>(structure, globalObject, WTFMove(impl))
{
}

void JSBasicCredential::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSBasicCredential::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSBasicCredentialPrototype::create(vm, &globalObject, JSBasicCredentialPrototype::createStructure(vm, &globalObject, globalObject.objectPrototype()));
}

JSObject* JSBasicCredential::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSBasicCredential>(vm, globalObject);
}

JSValue JSBasicCredential::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSBasicCredentialConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

void JSBasicCredential::destroy(JSC::JSCell* cell)
{
    JSBasicCredential* thisObject = static_cast<JSBasicCredential*>(cell);
    thisObject->JSBasicCredential::~JSBasicCredential();
}

template<> inline JSBasicCredential* IDLAttribute<JSBasicCredential>::cast(ExecState& state, EncodedJSValue thisValue)
{
    return jsDynamicDowncast<JSBasicCredential*>(state.vm(), JSValue::decode(thisValue));
}

EncodedJSValue jsBasicCredentialConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicDowncast<JSBasicCredentialPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSBasicCredential::getConstructor(state->vm(), prototype->globalObject()));
}

bool setJSBasicCredentialConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicDowncast<JSBasicCredentialPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return prototype->putDirect(state->vm(), state->propertyNames().constructor, JSValue::decode(encodedValue));
}

static inline JSValue jsBasicCredentialIdGetter(ExecState& state, JSBasicCredential& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUSVString>(state, impl.id());
    return result;
}

EncodedJSValue jsBasicCredentialId(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSBasicCredential>::get<jsBasicCredentialIdGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "id");
}

static inline JSValue jsBasicCredentialTypeGetter(ExecState& state, JSBasicCredential& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDOMString>(state, impl.type());
    return result;
}

EncodedJSValue jsBasicCredentialType(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSBasicCredential>::get<jsBasicCredentialTypeGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "type");
}

bool JSBasicCredentialOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSBasicCredentialOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsBasicCredential = static_cast<JSBasicCredential*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsBasicCredential->wrapped(), jsBasicCredential);
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7BasicCredential@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore15BasicCredentialE[]; }
#endif
#endif

JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject* globalObject, Ref<BasicCredential>&& impl)
{

#if ENABLE(BINDING_INTEGRITY)
    void* actualVTablePointer = *(reinterpret_cast<void**>(impl.ptr()));
#if PLATFORM(WIN)
    void* expectedVTablePointer = reinterpret_cast<void*>(__identifier("??_7BasicCredential@WebCore@@6B@"));
#else
    void* expectedVTablePointer = &_ZTVN7WebCore15BasicCredentialE[2];
#endif

    // If this fails BasicCredential does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    static_assert(std::is_polymorphic<BasicCredential>::value, "BasicCredential is not polymorphic");

    // If you hit this assertion you either have a use after free bug, or
    // BasicCredential has subclasses. If BasicCredential has subclasses that get passed
    // to toJS() we currently require BasicCredential you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    return createWrapper<BasicCredential>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, BasicCredential& impl)
{
    return wrap(state, globalObject, impl);
}

BasicCredential* JSBasicCredential::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicDowncast<JSBasicCredential*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
