/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSCache.h"

#include "JSCacheQueryOptions.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvertDictionary.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMConvertSequences.h"
#include "JSDOMConvertStrings.h"
#include "JSDOMConvertUnion.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMOperation.h"
#include "JSDOMOperationReturningPromise.h"
#include "JSDOMWrapperCache.h"
#include "JSFetchRequest.h"
#include "JSFetchResponse.h"
#include <runtime/FunctionPrototype.h>
#include <runtime/JSArray.h>
#include <runtime/JSCInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/Variant.h>

using namespace JSC;

namespace WebCore {

// Functions

JSC::EncodedJSValue JSC_HOST_CALL jsCachePrototypeFunctionMatch(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsCachePrototypeFunctionMatchAll(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsCachePrototypeFunctionAdd(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsCachePrototypeFunctionAddAll(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsCachePrototypeFunctionPut(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsCachePrototypeFunctionDelete(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsCachePrototypeFunctionKeys(JSC::ExecState*);

// Attributes

JSC::EncodedJSValue jsCacheConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSCacheConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);

class JSCachePrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSCachePrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSCachePrototype* ptr = new (NotNull, JSC::allocateCell<JSCachePrototype>(vm.heap)) JSCachePrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSCachePrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSCacheConstructor = JSDOMConstructorNotConstructable<JSCache>;

template<> JSValue JSCacheConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSCacheConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSCache::prototype(vm, globalObject), DontDelete | ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String(ASCIILiteral("Cache"))), ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), ReadOnly | DontEnum);
}

template<> const ClassInfo JSCacheConstructor::s_info = { "Cache", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSCacheConstructor) };

/* Hash table for prototype */

static const HashTableValue JSCachePrototypeTableValues[] =
{
    { "constructor", DontEnum, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCacheConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCacheConstructor) } },
    { "match", JSC::Function, NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsCachePrototypeFunctionMatch), (intptr_t) (1) } },
    { "matchAll", JSC::Function, NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsCachePrototypeFunctionMatchAll), (intptr_t) (0) } },
    { "add", JSC::Function, NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsCachePrototypeFunctionAdd), (intptr_t) (1) } },
    { "addAll", JSC::Function, NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsCachePrototypeFunctionAddAll), (intptr_t) (1) } },
    { "put", JSC::Function, NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsCachePrototypeFunctionPut), (intptr_t) (2) } },
    { "delete", JSC::Function, NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsCachePrototypeFunctionDelete), (intptr_t) (1) } },
    { "keys", JSC::Function, NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsCachePrototypeFunctionKeys), (intptr_t) (0) } },
};

const ClassInfo JSCachePrototype::s_info = { "CachePrototype", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSCachePrototype) };

void JSCachePrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSCache::info(), JSCachePrototypeTableValues, *this);
}

const ClassInfo JSCache::s_info = { "Cache", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSCache) };

JSCache::JSCache(Structure* structure, JSDOMGlobalObject& globalObject, Ref<Cache>&& impl)
    : JSDOMWrapper<Cache>(structure, globalObject, WTFMove(impl))
{
}

void JSCache::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSCache::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSCachePrototype::create(vm, &globalObject, JSCachePrototype::createStructure(vm, &globalObject, globalObject.objectPrototype()));
}

JSObject* JSCache::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSCache>(vm, globalObject);
}

JSValue JSCache::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSCacheConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

void JSCache::destroy(JSC::JSCell* cell)
{
    JSCache* thisObject = static_cast<JSCache*>(cell);
    thisObject->JSCache::~JSCache();
}

template<> inline JSCache* IDLOperation<JSCache>::cast(ExecState& state)
{
    return jsDynamicDowncast<JSCache*>(state.vm(), state.thisValue());
}

EncodedJSValue jsCacheConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicDowncast<JSCachePrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSCache::getConstructor(state->vm(), prototype->globalObject()));
}

bool setJSCacheConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicDowncast<JSCachePrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return prototype->putDirect(state->vm(), state->propertyNames().constructor, JSValue::decode(encodedValue));
}

static inline JSC::EncodedJSValue jsCachePrototypeFunctionMatchBody(JSC::ExecState* state, typename IDLOperationReturningPromise<JSCache>::ClassParameter castedThis, Ref<DeferredPromise>&& promise, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto request = convert<IDLUnion<IDLInterface<FetchRequest>, IDLUSVString>>(*state, state->uncheckedArgument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto options = convert<IDLDictionary<CacheQueryOptions>>(*state, state->argument(1));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    impl.match(WTFMove(request), WTFMove(options), WTFMove(promise));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsCachePrototypeFunctionMatch(ExecState* state)
{
    return IDLOperationReturningPromise<JSCache>::call<jsCachePrototypeFunctionMatchBody, PromiseExecutionScope::WindowOrWorker>(*state, "match");
}

static inline JSC::EncodedJSValue jsCachePrototypeFunctionMatchAllBody(JSC::ExecState* state, typename IDLOperationReturningPromise<JSCache>::ClassParameter castedThis, Ref<DeferredPromise>&& promise, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    auto request = state->argument(0).isUndefined() ? std::optional<Converter<IDLUnion<IDLInterface<FetchRequest>, IDLUSVString>>::ReturnType>() : std::optional<Converter<IDLUnion<IDLInterface<FetchRequest>, IDLUSVString>>::ReturnType>(convert<IDLUnion<IDLInterface<FetchRequest>, IDLUSVString>>(*state, state->uncheckedArgument(0)));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto options = convert<IDLDictionary<CacheQueryOptions>>(*state, state->argument(1));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    impl.matchAll(WTFMove(request), WTFMove(options), WTFMove(promise));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsCachePrototypeFunctionMatchAll(ExecState* state)
{
    return IDLOperationReturningPromise<JSCache>::call<jsCachePrototypeFunctionMatchAllBody, PromiseExecutionScope::WindowOrWorker>(*state, "matchAll");
}

static inline JSC::EncodedJSValue jsCachePrototypeFunctionAddBody(JSC::ExecState* state, typename IDLOperationReturningPromise<JSCache>::ClassParameter castedThis, Ref<DeferredPromise>&& promise, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto request = convert<IDLUnion<IDLInterface<FetchRequest>, IDLUSVString>>(*state, state->uncheckedArgument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    impl.add(WTFMove(request), WTFMove(promise));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsCachePrototypeFunctionAdd(ExecState* state)
{
    return IDLOperationReturningPromise<JSCache>::call<jsCachePrototypeFunctionAddBody, PromiseExecutionScope::WindowOrWorker>(*state, "add");
}

static inline JSC::EncodedJSValue jsCachePrototypeFunctionAddAllBody(JSC::ExecState* state, typename IDLOperationReturningPromise<JSCache>::ClassParameter castedThis, Ref<DeferredPromise>&& promise, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto requests = convert<IDLSequence<IDLUnion<IDLInterface<FetchRequest>, IDLUSVString>>>(*state, state->uncheckedArgument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    impl.addAll(WTFMove(requests), WTFMove(promise));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsCachePrototypeFunctionAddAll(ExecState* state)
{
    return IDLOperationReturningPromise<JSCache>::call<jsCachePrototypeFunctionAddAllBody, PromiseExecutionScope::WindowOrWorker>(*state, "addAll");
}

static inline JSC::EncodedJSValue jsCachePrototypeFunctionPutBody(JSC::ExecState* state, typename IDLOperationReturningPromise<JSCache>::ClassParameter castedThis, Ref<DeferredPromise>&& promise, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 2))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto request = convert<IDLUnion<IDLInterface<FetchRequest>, IDLUSVString>>(*state, state->uncheckedArgument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto response = convert<IDLInterface<FetchResponse>>(*state, state->uncheckedArgument(1), [](JSC::ExecState& state, JSC::ThrowScope& scope) { throwArgumentTypeError(state, scope, 1, "response", "Cache", "put", "FetchResponse"); });
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    impl.put(WTFMove(request), *response, WTFMove(promise));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsCachePrototypeFunctionPut(ExecState* state)
{
    return IDLOperationReturningPromise<JSCache>::call<jsCachePrototypeFunctionPutBody, PromiseExecutionScope::WindowOrWorker>(*state, "put");
}

static inline JSC::EncodedJSValue jsCachePrototypeFunctionDeleteBody(JSC::ExecState* state, typename IDLOperationReturningPromise<JSCache>::ClassParameter castedThis, Ref<DeferredPromise>&& promise, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto request = convert<IDLUnion<IDLInterface<FetchRequest>, IDLUSVString>>(*state, state->uncheckedArgument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto options = convert<IDLDictionary<CacheQueryOptions>>(*state, state->argument(1));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    impl.remove(WTFMove(request), WTFMove(options), WTFMove(promise));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsCachePrototypeFunctionDelete(ExecState* state)
{
    return IDLOperationReturningPromise<JSCache>::call<jsCachePrototypeFunctionDeleteBody, PromiseExecutionScope::WindowOrWorker>(*state, "delete");
}

static inline JSC::EncodedJSValue jsCachePrototypeFunctionKeysBody(JSC::ExecState* state, typename IDLOperationReturningPromise<JSCache>::ClassParameter castedThis, Ref<DeferredPromise>&& promise, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    auto request = state->argument(0).isUndefined() ? std::optional<Converter<IDLUnion<IDLInterface<FetchRequest>, IDLUSVString>>::ReturnType>() : std::optional<Converter<IDLUnion<IDLInterface<FetchRequest>, IDLUSVString>>::ReturnType>(convert<IDLUnion<IDLInterface<FetchRequest>, IDLUSVString>>(*state, state->uncheckedArgument(0)));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto options = convert<IDLDictionary<CacheQueryOptions>>(*state, state->argument(1));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    impl.keys(WTFMove(request), WTFMove(options), WTFMove(promise));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsCachePrototypeFunctionKeys(ExecState* state)
{
    return IDLOperationReturningPromise<JSCache>::call<jsCachePrototypeFunctionKeysBody, PromiseExecutionScope::WindowOrWorker>(*state, "keys");
}

bool JSCacheOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSCacheOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsCache = static_cast<JSCache*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsCache->wrapped(), jsCache);
}

JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject* globalObject, Ref<Cache>&& impl)
{
    // If you hit this failure the interface definition has the ImplementationLacksVTable
    // attribute. You should remove that attribute. If the class has subclasses
    // that may be passed through this toJS() function you should use the SkipVTableValidation
    // attribute to Cache.
    static_assert(!std::is_polymorphic<Cache>::value, "Cache is polymorphic but the IDL claims it is not");
    return createWrapper<Cache>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, Cache& impl)
{
    return wrap(state, globalObject, impl);
}

Cache* JSCache::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicDowncast<JSCache*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
