/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSCacheStorage.h"

#include "JSCacheQueryOptions.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvertDictionary.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMConvertStrings.h"
#include "JSDOMConvertUnion.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMOperation.h"
#include "JSDOMOperationReturningPromise.h"
#include "JSDOMWrapperCache.h"
#include "JSFetchRequest.h"
#include <runtime/FunctionPrototype.h>
#include <runtime/JSCInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/Variant.h>

using namespace JSC;

namespace WebCore {

// Functions

JSC::EncodedJSValue JSC_HOST_CALL jsCacheStoragePrototypeFunctionMatch(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsCacheStoragePrototypeFunctionHas(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsCacheStoragePrototypeFunctionOpen(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsCacheStoragePrototypeFunctionDelete(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsCacheStoragePrototypeFunctionKeys(JSC::ExecState*);

// Attributes

JSC::EncodedJSValue jsCacheStorageConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSCacheStorageConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);

class JSCacheStoragePrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSCacheStoragePrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSCacheStoragePrototype* ptr = new (NotNull, JSC::allocateCell<JSCacheStoragePrototype>(vm.heap)) JSCacheStoragePrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSCacheStoragePrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSCacheStorageConstructor = JSDOMConstructorNotConstructable<JSCacheStorage>;

template<> JSValue JSCacheStorageConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSCacheStorageConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSCacheStorage::prototype(vm, globalObject), DontDelete | ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String(ASCIILiteral("CacheStorage"))), ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), ReadOnly | DontEnum);
}

template<> const ClassInfo JSCacheStorageConstructor::s_info = { "CacheStorage", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSCacheStorageConstructor) };

/* Hash table for prototype */

static const HashTableValue JSCacheStoragePrototypeTableValues[] =
{
    { "constructor", DontEnum, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCacheStorageConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCacheStorageConstructor) } },
    { "match", JSC::Function, NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsCacheStoragePrototypeFunctionMatch), (intptr_t) (1) } },
    { "has", JSC::Function, NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsCacheStoragePrototypeFunctionHas), (intptr_t) (1) } },
    { "open", JSC::Function, NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsCacheStoragePrototypeFunctionOpen), (intptr_t) (1) } },
    { "delete", JSC::Function, NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsCacheStoragePrototypeFunctionDelete), (intptr_t) (1) } },
    { "keys", JSC::Function, NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsCacheStoragePrototypeFunctionKeys), (intptr_t) (0) } },
};

const ClassInfo JSCacheStoragePrototype::s_info = { "CacheStoragePrototype", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSCacheStoragePrototype) };

void JSCacheStoragePrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSCacheStorage::info(), JSCacheStoragePrototypeTableValues, *this);
}

const ClassInfo JSCacheStorage::s_info = { "CacheStorage", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSCacheStorage) };

JSCacheStorage::JSCacheStorage(Structure* structure, JSDOMGlobalObject& globalObject, Ref<CacheStorage>&& impl)
    : JSDOMWrapper<CacheStorage>(structure, globalObject, WTFMove(impl))
{
}

void JSCacheStorage::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSCacheStorage::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSCacheStoragePrototype::create(vm, &globalObject, JSCacheStoragePrototype::createStructure(vm, &globalObject, globalObject.objectPrototype()));
}

JSObject* JSCacheStorage::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSCacheStorage>(vm, globalObject);
}

JSValue JSCacheStorage::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSCacheStorageConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

void JSCacheStorage::destroy(JSC::JSCell* cell)
{
    JSCacheStorage* thisObject = static_cast<JSCacheStorage*>(cell);
    thisObject->JSCacheStorage::~JSCacheStorage();
}

template<> inline JSCacheStorage* IDLOperation<JSCacheStorage>::cast(ExecState& state)
{
    return jsDynamicDowncast<JSCacheStorage*>(state.vm(), state.thisValue());
}

EncodedJSValue jsCacheStorageConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicDowncast<JSCacheStoragePrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSCacheStorage::getConstructor(state->vm(), prototype->globalObject()));
}

bool setJSCacheStorageConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicDowncast<JSCacheStoragePrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return prototype->putDirect(state->vm(), state->propertyNames().constructor, JSValue::decode(encodedValue));
}

static inline JSC::EncodedJSValue jsCacheStoragePrototypeFunctionMatchBody(JSC::ExecState* state, typename IDLOperationReturningPromise<JSCacheStorage>::ClassParameter castedThis, Ref<DeferredPromise>&& promise, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto request = convert<IDLUnion<IDLInterface<FetchRequest>, IDLUSVString>>(*state, state->uncheckedArgument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto options = convert<IDLDictionary<CacheQueryOptions>>(*state, state->argument(1));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    impl.match(WTFMove(request), WTFMove(options), WTFMove(promise));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsCacheStoragePrototypeFunctionMatch(ExecState* state)
{
    return IDLOperationReturningPromise<JSCacheStorage>::call<jsCacheStoragePrototypeFunctionMatchBody, PromiseExecutionScope::WindowOrWorker>(*state, "match");
}

static inline JSC::EncodedJSValue jsCacheStoragePrototypeFunctionHasBody(JSC::ExecState* state, typename IDLOperationReturningPromise<JSCacheStorage>::ClassParameter castedThis, Ref<DeferredPromise>&& promise, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto cacheName = convert<IDLDOMString>(*state, state->uncheckedArgument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    impl.has(WTFMove(cacheName), WTFMove(promise));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsCacheStoragePrototypeFunctionHas(ExecState* state)
{
    return IDLOperationReturningPromise<JSCacheStorage>::call<jsCacheStoragePrototypeFunctionHasBody, PromiseExecutionScope::WindowOrWorker>(*state, "has");
}

static inline JSC::EncodedJSValue jsCacheStoragePrototypeFunctionOpenBody(JSC::ExecState* state, typename IDLOperationReturningPromise<JSCacheStorage>::ClassParameter castedThis, Ref<DeferredPromise>&& promise, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto cacheName = convert<IDLDOMString>(*state, state->uncheckedArgument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    impl.open(WTFMove(cacheName), WTFMove(promise));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsCacheStoragePrototypeFunctionOpen(ExecState* state)
{
    return IDLOperationReturningPromise<JSCacheStorage>::call<jsCacheStoragePrototypeFunctionOpenBody, PromiseExecutionScope::WindowOrWorker>(*state, "open");
}

static inline JSC::EncodedJSValue jsCacheStoragePrototypeFunctionDeleteBody(JSC::ExecState* state, typename IDLOperationReturningPromise<JSCacheStorage>::ClassParameter castedThis, Ref<DeferredPromise>&& promise, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto cacheName = convert<IDLDOMString>(*state, state->uncheckedArgument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    impl.remove(WTFMove(cacheName), WTFMove(promise));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsCacheStoragePrototypeFunctionDelete(ExecState* state)
{
    return IDLOperationReturningPromise<JSCacheStorage>::call<jsCacheStoragePrototypeFunctionDeleteBody, PromiseExecutionScope::WindowOrWorker>(*state, "delete");
}

static inline JSC::EncodedJSValue jsCacheStoragePrototypeFunctionKeysBody(JSC::ExecState* state, typename IDLOperationReturningPromise<JSCacheStorage>::ClassParameter castedThis, Ref<DeferredPromise>&& promise, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    impl.keys(WTFMove(promise));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsCacheStoragePrototypeFunctionKeys(ExecState* state)
{
    return IDLOperationReturningPromise<JSCacheStorage>::call<jsCacheStoragePrototypeFunctionKeysBody, PromiseExecutionScope::WindowOrWorker>(*state, "keys");
}

bool JSCacheStorageOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSCacheStorageOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsCacheStorage = static_cast<JSCacheStorage*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsCacheStorage->wrapped(), jsCacheStorage);
}

JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject* globalObject, Ref<CacheStorage>&& impl)
{
    // If you hit this failure the interface definition has the ImplementationLacksVTable
    // attribute. You should remove that attribute. If the class has subclasses
    // that may be passed through this toJS() function you should use the SkipVTableValidation
    // attribute to CacheStorage.
    static_assert(!std::is_polymorphic<CacheStorage>::value, "CacheStorage is polymorphic but the IDL claims it is not");
    return createWrapper<CacheStorage>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, CacheStorage& impl)
{
    return wrap(state, globalObject, impl);
}

CacheStorage* JSCacheStorage::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicDowncast<JSCacheStorage*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
