/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSCommandLineAPIHost.h"

#include "JSDOMBinding.h"
#include "JSDOMConvertAny.h"
#include "JSDOMConvertBoolean.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMConvertNullable.h"
#include "JSDOMConvertObject.h"
#include "JSDOMConvertRecord.h"
#include "JSDOMConvertSequences.h"
#include "JSDOMConvertStrings.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObject.h"
#include "JSDOMOperation.h"
#include "JSDOMWrapperCache.h"
#include "JSDatabase.h"
#include "JSNode.h"
#include "JSStorage.h"
#include <runtime/JSArray.h>
#include <runtime/JSCInlines.h>
#include <runtime/ObjectConstructor.h>
#include <wtf/GetPtr.h>
#include <wtf/Vector.h>

using namespace JSC;

namespace WebCore {

template<> CommandLineAPIHost::ListenerEntry convertDictionary<CommandLineAPIHost::ListenerEntry>(ExecState& state, JSValue value)
{
    VM& vm = state.vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&state, throwScope);
        return { };
    }
    CommandLineAPIHost::ListenerEntry result;
    JSValue functionValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "function"));
    if (!functionValue.isUndefined()) {
        result.function = convert<IDLObject>(state, functionValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "function", "ListenerEntry", "object");
        return { };
    }
    JSValue useCaptureValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "useCapture"));
    if (!useCaptureValue.isUndefined()) {
        result.useCapture = convert<IDLBoolean>(state, useCaptureValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "useCapture", "ListenerEntry", "boolean");
        return { };
    }
    return result;
}

JSC::JSObject* convertDictionaryToJS(JSC::ExecState& state, JSDOMGlobalObject& globalObject, const CommandLineAPIHost::ListenerEntry& dictionary)
{
    auto& vm = state.vm();

    auto result = constructEmptyObject(&state, globalObject.objectPrototype());

    auto functionValue = toJS<IDLObject>(dictionary.function);
    result->putDirect(vm, JSC::Identifier::fromString(&vm, "function"), functionValue);
    auto useCaptureValue = toJS<IDLBoolean>(dictionary.useCapture);
    result->putDirect(vm, JSC::Identifier::fromString(&vm, "useCapture"), useCaptureValue);
    return result;
}

// Functions

JSC::EncodedJSValue JSC_HOST_CALL jsCommandLineAPIHostPrototypeFunctionClearConsoleMessages(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsCommandLineAPIHostPrototypeFunctionCopyText(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsCommandLineAPIHostPrototypeFunctionInspect(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsCommandLineAPIHostPrototypeFunctionInspectedObject(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsCommandLineAPIHostPrototypeFunctionGetEventListeners(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsCommandLineAPIHostPrototypeFunctionDatabaseId(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsCommandLineAPIHostPrototypeFunctionStorageId(JSC::ExecState*);

class JSCommandLineAPIHostPrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSCommandLineAPIHostPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSCommandLineAPIHostPrototype* ptr = new (NotNull, JSC::allocateCell<JSCommandLineAPIHostPrototype>(vm.heap)) JSCommandLineAPIHostPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSCommandLineAPIHostPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

/* Hash table for prototype */

static const HashTableValue JSCommandLineAPIHostPrototypeTableValues[] =
{
    { "clearConsoleMessages", JSC::Function, NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsCommandLineAPIHostPrototypeFunctionClearConsoleMessages), (intptr_t) (0) } },
    { "copyText", JSC::Function, NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsCommandLineAPIHostPrototypeFunctionCopyText), (intptr_t) (1) } },
    { "inspect", JSC::Function, NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsCommandLineAPIHostPrototypeFunctionInspect), (intptr_t) (2) } },
    { "inspectedObject", JSC::Function, NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsCommandLineAPIHostPrototypeFunctionInspectedObject), (intptr_t) (0) } },
    { "getEventListeners", JSC::Function, NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsCommandLineAPIHostPrototypeFunctionGetEventListeners), (intptr_t) (1) } },
    { "databaseId", JSC::Function, NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsCommandLineAPIHostPrototypeFunctionDatabaseId), (intptr_t) (1) } },
    { "storageId", JSC::Function, NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsCommandLineAPIHostPrototypeFunctionStorageId), (intptr_t) (1) } },
};

const ClassInfo JSCommandLineAPIHostPrototype::s_info = { "CommandLineAPIHostPrototype", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSCommandLineAPIHostPrototype) };

void JSCommandLineAPIHostPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSCommandLineAPIHost::info(), JSCommandLineAPIHostPrototypeTableValues, *this);
}

const ClassInfo JSCommandLineAPIHost::s_info = { "CommandLineAPIHost", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSCommandLineAPIHost) };

JSCommandLineAPIHost::JSCommandLineAPIHost(Structure* structure, JSDOMGlobalObject& globalObject, Ref<CommandLineAPIHost>&& impl)
    : JSDOMWrapper<CommandLineAPIHost>(structure, globalObject, WTFMove(impl))
{
}

void JSCommandLineAPIHost::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSCommandLineAPIHost::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSCommandLineAPIHostPrototype::create(vm, &globalObject, JSCommandLineAPIHostPrototype::createStructure(vm, &globalObject, globalObject.objectPrototype()));
}

JSObject* JSCommandLineAPIHost::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSCommandLineAPIHost>(vm, globalObject);
}

void JSCommandLineAPIHost::destroy(JSC::JSCell* cell)
{
    JSCommandLineAPIHost* thisObject = static_cast<JSCommandLineAPIHost*>(cell);
    thisObject->JSCommandLineAPIHost::~JSCommandLineAPIHost();
}

template<> inline JSCommandLineAPIHost* IDLOperation<JSCommandLineAPIHost>::cast(ExecState& state)
{
    return jsDynamicDowncast<JSCommandLineAPIHost*>(state.vm(), state.thisValue());
}

static inline JSC::EncodedJSValue jsCommandLineAPIHostPrototypeFunctionClearConsoleMessagesBody(JSC::ExecState* state, typename IDLOperation<JSCommandLineAPIHost>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    impl.clearConsoleMessages();
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsCommandLineAPIHostPrototypeFunctionClearConsoleMessages(ExecState* state)
{
    return IDLOperation<JSCommandLineAPIHost>::call<jsCommandLineAPIHostPrototypeFunctionClearConsoleMessagesBody>(*state, "clearConsoleMessages");
}

static inline JSC::EncodedJSValue jsCommandLineAPIHostPrototypeFunctionCopyTextBody(JSC::ExecState* state, typename IDLOperation<JSCommandLineAPIHost>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto text = convert<IDLDOMString>(*state, state->uncheckedArgument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    impl.copyText(WTFMove(text));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsCommandLineAPIHostPrototypeFunctionCopyText(ExecState* state)
{
    return IDLOperation<JSCommandLineAPIHost>::call<jsCommandLineAPIHostPrototypeFunctionCopyTextBody>(*state, "copyText");
}

static inline JSC::EncodedJSValue jsCommandLineAPIHostPrototypeFunctionInspectBody(JSC::ExecState* state, typename IDLOperation<JSCommandLineAPIHost>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 2))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto objectToInspect = convert<IDLAny>(*state, state->uncheckedArgument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto hints = convert<IDLAny>(*state, state->uncheckedArgument(1));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    impl.inspect(*state, WTFMove(objectToInspect), WTFMove(hints));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsCommandLineAPIHostPrototypeFunctionInspect(ExecState* state)
{
    return IDLOperation<JSCommandLineAPIHost>::call<jsCommandLineAPIHostPrototypeFunctionInspectBody>(*state, "inspect");
}

static inline JSC::EncodedJSValue jsCommandLineAPIHostPrototypeFunctionInspectedObjectBody(JSC::ExecState* state, typename IDLOperation<JSCommandLineAPIHost>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    return JSValue::encode(toJS<IDLAny>(impl.inspectedObject(*state)));
}

EncodedJSValue JSC_HOST_CALL jsCommandLineAPIHostPrototypeFunctionInspectedObject(ExecState* state)
{
    return IDLOperation<JSCommandLineAPIHost>::call<jsCommandLineAPIHostPrototypeFunctionInspectedObjectBody>(*state, "inspectedObject");
}

static inline JSC::EncodedJSValue jsCommandLineAPIHostPrototypeFunctionGetEventListenersBody(JSC::ExecState* state, typename IDLOperation<JSCommandLineAPIHost>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto node = convert<IDLNullable<IDLInterface<Node>>>(*state, state->uncheckedArgument(0), [](JSC::ExecState& state, JSC::ThrowScope& scope) { throwArgumentTypeError(state, scope, 0, "node", "CommandLineAPIHost", "getEventListeners", "Node"); });
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    return JSValue::encode(toJS<IDLRecord<IDLDOMString, IDLSequence<IDLDictionary<CommandLineAPIHost::ListenerEntry>>>>(*state, *castedThis->globalObject(), impl.getEventListeners(*state, WTFMove(node))));
}

EncodedJSValue JSC_HOST_CALL jsCommandLineAPIHostPrototypeFunctionGetEventListeners(ExecState* state)
{
    return IDLOperation<JSCommandLineAPIHost>::call<jsCommandLineAPIHostPrototypeFunctionGetEventListenersBody>(*state, "getEventListeners");
}

static inline JSC::EncodedJSValue jsCommandLineAPIHostPrototypeFunctionDatabaseIdBody(JSC::ExecState* state, typename IDLOperation<JSCommandLineAPIHost>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto database = convert<IDLInterface<Database>>(*state, state->uncheckedArgument(0), [](JSC::ExecState& state, JSC::ThrowScope& scope) { throwArgumentTypeError(state, scope, 0, "database", "CommandLineAPIHost", "databaseId", "Database"); });
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    return JSValue::encode(toJS<IDLDOMString>(*state, impl.databaseId(*database)));
}

EncodedJSValue JSC_HOST_CALL jsCommandLineAPIHostPrototypeFunctionDatabaseId(ExecState* state)
{
    return IDLOperation<JSCommandLineAPIHost>::call<jsCommandLineAPIHostPrototypeFunctionDatabaseIdBody>(*state, "databaseId");
}

static inline JSC::EncodedJSValue jsCommandLineAPIHostPrototypeFunctionStorageIdBody(JSC::ExecState* state, typename IDLOperation<JSCommandLineAPIHost>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto storage = convert<IDLInterface<Storage>>(*state, state->uncheckedArgument(0), [](JSC::ExecState& state, JSC::ThrowScope& scope) { throwArgumentTypeError(state, scope, 0, "storage", "CommandLineAPIHost", "storageId", "Storage"); });
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    return JSValue::encode(toJS<IDLDOMString>(*state, impl.storageId(*storage)));
}

EncodedJSValue JSC_HOST_CALL jsCommandLineAPIHostPrototypeFunctionStorageId(ExecState* state)
{
    return IDLOperation<JSCommandLineAPIHost>::call<jsCommandLineAPIHostPrototypeFunctionStorageIdBody>(*state, "storageId");
}

bool JSCommandLineAPIHostOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSCommandLineAPIHostOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsCommandLineAPIHost = static_cast<JSCommandLineAPIHost*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsCommandLineAPIHost->wrapped(), jsCommandLineAPIHost);
}

JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject* globalObject, Ref<CommandLineAPIHost>&& impl)
{
    // If you hit this failure the interface definition has the ImplementationLacksVTable
    // attribute. You should remove that attribute. If the class has subclasses
    // that may be passed through this toJS() function you should use the SkipVTableValidation
    // attribute to CommandLineAPIHost.
    static_assert(!std::is_polymorphic<CommandLineAPIHost>::value, "CommandLineAPIHost is polymorphic but the IDL claims it is not");
    return createWrapper<CommandLineAPIHost>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, CommandLineAPIHost& impl)
{
    return wrap(state, globalObject, impl);
}

CommandLineAPIHost* JSCommandLineAPIHost::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicDowncast<JSCommandLineAPIHost*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
