/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(GEOLOCATION)

#include "JSCoordinates.h"

#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConvertNullable.h"
#include "JSDOMConvertNumbers.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMWrapperCache.h"
#include <runtime/JSCInlines.h>
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

// Attributes

JSC::EncodedJSValue jsCoordinatesLatitude(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsCoordinatesLongitude(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsCoordinatesAltitude(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsCoordinatesAccuracy(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsCoordinatesAltitudeAccuracy(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsCoordinatesHeading(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsCoordinatesSpeed(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);

class JSCoordinatesPrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSCoordinatesPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSCoordinatesPrototype* ptr = new (NotNull, JSC::allocateCell<JSCoordinatesPrototype>(vm.heap)) JSCoordinatesPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSCoordinatesPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

/* Hash table for prototype */

static const HashTableValue JSCoordinatesPrototypeTableValues[] =
{
    { "latitude", ReadOnly | CustomAccessor | DOMAttribute, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCoordinatesLatitude), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "longitude", ReadOnly | CustomAccessor | DOMAttribute, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCoordinatesLongitude), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "altitude", ReadOnly | CustomAccessor | DOMAttribute, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCoordinatesAltitude), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "accuracy", ReadOnly | CustomAccessor | DOMAttribute, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCoordinatesAccuracy), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "altitudeAccuracy", ReadOnly | CustomAccessor | DOMAttribute, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCoordinatesAltitudeAccuracy), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "heading", ReadOnly | CustomAccessor | DOMAttribute, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCoordinatesHeading), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "speed", ReadOnly | CustomAccessor | DOMAttribute, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCoordinatesSpeed), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
};

const ClassInfo JSCoordinatesPrototype::s_info = { "CoordinatesPrototype", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSCoordinatesPrototype) };

void JSCoordinatesPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSCoordinates::info(), JSCoordinatesPrototypeTableValues, *this);
}

const ClassInfo JSCoordinates::s_info = { "Coordinates", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSCoordinates) };

JSCoordinates::JSCoordinates(Structure* structure, JSDOMGlobalObject& globalObject, Ref<Coordinates>&& impl)
    : JSDOMWrapper<Coordinates>(structure, globalObject, WTFMove(impl))
{
}

void JSCoordinates::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSCoordinates::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSCoordinatesPrototype::create(vm, &globalObject, JSCoordinatesPrototype::createStructure(vm, &globalObject, globalObject.objectPrototype()));
}

JSObject* JSCoordinates::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSCoordinates>(vm, globalObject);
}

void JSCoordinates::destroy(JSC::JSCell* cell)
{
    JSCoordinates* thisObject = static_cast<JSCoordinates*>(cell);
    thisObject->JSCoordinates::~JSCoordinates();
}

template<> inline JSCoordinates* IDLAttribute<JSCoordinates>::cast(ExecState& state, EncodedJSValue thisValue)
{
    return jsDynamicDowncast<JSCoordinates*>(state.vm(), JSValue::decode(thisValue));
}

static inline JSValue jsCoordinatesLatitudeGetter(ExecState& state, JSCoordinates& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnrestrictedDouble>(impl.latitude());
    return result;
}

EncodedJSValue jsCoordinatesLatitude(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSCoordinates>::get<jsCoordinatesLatitudeGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "latitude");
}

static inline JSValue jsCoordinatesLongitudeGetter(ExecState& state, JSCoordinates& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnrestrictedDouble>(impl.longitude());
    return result;
}

EncodedJSValue jsCoordinatesLongitude(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSCoordinates>::get<jsCoordinatesLongitudeGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "longitude");
}

static inline JSValue jsCoordinatesAltitudeGetter(ExecState& state, JSCoordinates& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLNullable<IDLUnrestrictedDouble>>(impl.altitude());
    return result;
}

EncodedJSValue jsCoordinatesAltitude(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSCoordinates>::get<jsCoordinatesAltitudeGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "altitude");
}

static inline JSValue jsCoordinatesAccuracyGetter(ExecState& state, JSCoordinates& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnrestrictedDouble>(impl.accuracy());
    return result;
}

EncodedJSValue jsCoordinatesAccuracy(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSCoordinates>::get<jsCoordinatesAccuracyGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "accuracy");
}

static inline JSValue jsCoordinatesAltitudeAccuracyGetter(ExecState& state, JSCoordinates& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLNullable<IDLUnrestrictedDouble>>(impl.altitudeAccuracy());
    return result;
}

EncodedJSValue jsCoordinatesAltitudeAccuracy(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSCoordinates>::get<jsCoordinatesAltitudeAccuracyGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "altitudeAccuracy");
}

static inline JSValue jsCoordinatesHeadingGetter(ExecState& state, JSCoordinates& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLNullable<IDLUnrestrictedDouble>>(impl.heading());
    return result;
}

EncodedJSValue jsCoordinatesHeading(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSCoordinates>::get<jsCoordinatesHeadingGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "heading");
}

static inline JSValue jsCoordinatesSpeedGetter(ExecState& state, JSCoordinates& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLNullable<IDLUnrestrictedDouble>>(impl.speed());
    return result;
}

EncodedJSValue jsCoordinatesSpeed(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSCoordinates>::get<jsCoordinatesSpeedGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "speed");
}

bool JSCoordinatesOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSCoordinatesOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsCoordinates = static_cast<JSCoordinates*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsCoordinates->wrapped(), jsCoordinates);
}

JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject* globalObject, Ref<Coordinates>&& impl)
{
    // If you hit this failure the interface definition has the ImplementationLacksVTable
    // attribute. You should remove that attribute. If the class has subclasses
    // that may be passed through this toJS() function you should use the SkipVTableValidation
    // attribute to Coordinates.
    static_assert(!std::is_polymorphic<Coordinates>::value, "Coordinates is polymorphic but the IDL claims it is not");
    return createWrapper<Coordinates>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, Coordinates& impl)
{
    return wrap(state, globalObject, impl);
}

Coordinates* JSCoordinates::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicDowncast<JSCoordinates*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}

#endif // ENABLE(GEOLOCATION)
