/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSCredentialCreationOptions.h"

#include "JSDOMConvertInterface.h"
#include "JSDOMConvertNullable.h"
#include "JSDOMConvertUnion.h"
#include "JSFederatedCredentialInit.h"
#include "JSHTMLFormElement.h"
#include "JSPasswordCredentialData.h"
#include <runtime/JSCInlines.h>
#include <wtf/Variant.h>

using namespace JSC;

namespace WebCore {

template<> CredentialCreationOptions convertDictionary<CredentialCreationOptions>(ExecState& state, JSValue value)
{
    VM& vm = state.vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&state, throwScope);
        return { };
    }
    CredentialCreationOptions result;
    JSValue federatedValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "federated"));
    if (!federatedValue.isUndefined()) {
        result.federated = convert<IDLNullable<IDLDictionary<FederatedCredentialInit>>>(state, federatedValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue passwordValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "password"));
    if (!passwordValue.isUndefined()) {
        result.password = convert<IDLNullable<IDLUnion<IDLDictionary<PasswordCredentialData>, IDLInterface<HTMLFormElement>>>>(state, passwordValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    return result;
}

} // namespace WebCore
