/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSCredentialRequestOptions.h"

#include "JSDOMConvertBoolean.h"
#include "JSDOMConvertNullable.h"
#include "JSFederatedCredentialRequestOptions.h"
#include <runtime/JSCInlines.h>
#include <runtime/JSString.h>
#include <wtf/NeverDestroyed.h>

using namespace JSC;

namespace WebCore {

template<> CredentialRequestOptions convertDictionary<CredentialRequestOptions>(ExecState& state, JSValue value)
{
    VM& vm = state.vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&state, throwScope);
        return { };
    }
    CredentialRequestOptions result;
    JSValue federatedValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "federated"));
    if (!federatedValue.isUndefined()) {
        result.federated = convert<IDLNullable<IDLDictionary<FederatedCredentialRequestOptions>>>(state, federatedValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue mediationValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "mediation"));
    if (!mediationValue.isUndefined()) {
        result.mediation = convert<IDLEnumeration<CredentialRequestOptions::MediationRequirement>>(state, mediationValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.mediation = CredentialRequestOptions::MediationRequirement::Optional;
    JSValue passwordValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "password"));
    if (!passwordValue.isUndefined()) {
        result.password = convert<IDLBoolean>(state, passwordValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.password = false;
    return result;
}

template<> JSString* convertEnumerationToJS(ExecState& state, CredentialRequestOptions::MediationRequirement enumerationValue)
{
    static const NeverDestroyed<String> values[] = {
        MAKE_STATIC_STRING_IMPL("silent"),
        MAKE_STATIC_STRING_IMPL("optional"),
        MAKE_STATIC_STRING_IMPL("required"),
    };
    static_assert(static_cast<size_t>(CredentialRequestOptions::MediationRequirement::Silent) == 0, "CredentialRequestOptions::MediationRequirement::Silent is not 0 as expected");
    static_assert(static_cast<size_t>(CredentialRequestOptions::MediationRequirement::Optional) == 1, "CredentialRequestOptions::MediationRequirement::Optional is not 1 as expected");
    static_assert(static_cast<size_t>(CredentialRequestOptions::MediationRequirement::Required) == 2, "CredentialRequestOptions::MediationRequirement::Required is not 2 as expected");
    ASSERT(static_cast<size_t>(enumerationValue) < WTF_ARRAY_LENGTH(values));
    return jsStringWithCache(&state, values[static_cast<size_t>(enumerationValue)]);
}

template<> std::optional<CredentialRequestOptions::MediationRequirement> parseEnumeration<CredentialRequestOptions::MediationRequirement>(ExecState& state, JSValue value)
{
    auto stringValue = value.toWTFString(&state);
    if (stringValue == "silent")
        return CredentialRequestOptions::MediationRequirement::Silent;
    if (stringValue == "optional")
        return CredentialRequestOptions::MediationRequirement::Optional;
    if (stringValue == "required")
        return CredentialRequestOptions::MediationRequirement::Required;
    return std::nullopt;
}

template<> const char* expectedEnumerationValues<CredentialRequestOptions::MediationRequirement>()
{
    return "\"silent\", \"optional\", \"required\"";
}

} // namespace WebCore
