/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSCredentialsContainer.h"

#include "JSBasicCredential.h"
#include "JSCredentialCreationOptions.h"
#include "JSCredentialRequestOptions.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvertDictionary.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMOperation.h"
#include "JSDOMOperationReturningPromise.h"
#include "JSDOMWrapperCache.h"
#include <runtime/FunctionPrototype.h>
#include <runtime/JSCInlines.h>
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

// Functions

JSC::EncodedJSValue JSC_HOST_CALL jsCredentialsContainerPrototypeFunctionGet(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsCredentialsContainerPrototypeFunctionStore(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsCredentialsContainerPrototypeFunctionCreate(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsCredentialsContainerPrototypeFunctionPreventSilentAccess(JSC::ExecState*);

// Attributes

JSC::EncodedJSValue jsCredentialsContainerConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSCredentialsContainerConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);

class JSCredentialsContainerPrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSCredentialsContainerPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSCredentialsContainerPrototype* ptr = new (NotNull, JSC::allocateCell<JSCredentialsContainerPrototype>(vm.heap)) JSCredentialsContainerPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSCredentialsContainerPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSCredentialsContainerConstructor = JSDOMConstructorNotConstructable<JSCredentialsContainer>;

template<> JSValue JSCredentialsContainerConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSCredentialsContainerConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSCredentialsContainer::prototype(vm, globalObject), DontDelete | ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String(ASCIILiteral("CredentialsContainer"))), ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), ReadOnly | DontEnum);
}

template<> const ClassInfo JSCredentialsContainerConstructor::s_info = { "CredentialsContainer", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSCredentialsContainerConstructor) };

/* Hash table for prototype */

static const HashTableValue JSCredentialsContainerPrototypeTableValues[] =
{
    { "constructor", DontEnum, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCredentialsContainerConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSCredentialsContainerConstructor) } },
    { "get", JSC::Function, NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsCredentialsContainerPrototypeFunctionGet), (intptr_t) (0) } },
    { "store", JSC::Function, NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsCredentialsContainerPrototypeFunctionStore), (intptr_t) (1) } },
    { "create", JSC::Function, NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsCredentialsContainerPrototypeFunctionCreate), (intptr_t) (0) } },
    { "preventSilentAccess", JSC::Function, NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsCredentialsContainerPrototypeFunctionPreventSilentAccess), (intptr_t) (0) } },
};

const ClassInfo JSCredentialsContainerPrototype::s_info = { "CredentialsContainerPrototype", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSCredentialsContainerPrototype) };

void JSCredentialsContainerPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSCredentialsContainer::info(), JSCredentialsContainerPrototypeTableValues, *this);
}

const ClassInfo JSCredentialsContainer::s_info = { "CredentialsContainer", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSCredentialsContainer) };

JSCredentialsContainer::JSCredentialsContainer(Structure* structure, JSDOMGlobalObject& globalObject, Ref<CredentialsContainer>&& impl)
    : JSDOMWrapper<CredentialsContainer>(structure, globalObject, WTFMove(impl))
{
}

void JSCredentialsContainer::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSCredentialsContainer::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSCredentialsContainerPrototype::create(vm, &globalObject, JSCredentialsContainerPrototype::createStructure(vm, &globalObject, globalObject.objectPrototype()));
}

JSObject* JSCredentialsContainer::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSCredentialsContainer>(vm, globalObject);
}

JSValue JSCredentialsContainer::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSCredentialsContainerConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

void JSCredentialsContainer::destroy(JSC::JSCell* cell)
{
    JSCredentialsContainer* thisObject = static_cast<JSCredentialsContainer*>(cell);
    thisObject->JSCredentialsContainer::~JSCredentialsContainer();
}

template<> inline JSCredentialsContainer* IDLOperation<JSCredentialsContainer>::cast(ExecState& state)
{
    return jsDynamicDowncast<JSCredentialsContainer*>(state.vm(), state.thisValue());
}

EncodedJSValue jsCredentialsContainerConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicDowncast<JSCredentialsContainerPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSCredentialsContainer::getConstructor(state->vm(), prototype->globalObject()));
}

bool setJSCredentialsContainerConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicDowncast<JSCredentialsContainerPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return prototype->putDirect(state->vm(), state->propertyNames().constructor, JSValue::decode(encodedValue));
}

static inline JSC::EncodedJSValue jsCredentialsContainerPrototypeFunctionGetBody(JSC::ExecState* state, typename IDLOperationReturningPromise<JSCredentialsContainer>::ClassParameter castedThis, Ref<DeferredPromise>&& promise, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    auto options = convert<IDLDictionary<CredentialRequestOptions>>(*state, state->argument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    impl.get(WTFMove(options), WTFMove(promise));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsCredentialsContainerPrototypeFunctionGet(ExecState* state)
{
    return IDLOperationReturningPromise<JSCredentialsContainer>::call<jsCredentialsContainerPrototypeFunctionGetBody, PromiseExecutionScope::WindowOrWorker>(*state, "get");
}

static inline JSC::EncodedJSValue jsCredentialsContainerPrototypeFunctionStoreBody(JSC::ExecState* state, typename IDLOperationReturningPromise<JSCredentialsContainer>::ClassParameter castedThis, Ref<DeferredPromise>&& promise, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto credential = convert<IDLInterface<BasicCredential>>(*state, state->uncheckedArgument(0), [](JSC::ExecState& state, JSC::ThrowScope& scope) { throwArgumentTypeError(state, scope, 0, "credential", "CredentialsContainer", "store", "BasicCredential"); });
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    impl.store(*credential, WTFMove(promise));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsCredentialsContainerPrototypeFunctionStore(ExecState* state)
{
    return IDLOperationReturningPromise<JSCredentialsContainer>::call<jsCredentialsContainerPrototypeFunctionStoreBody, PromiseExecutionScope::WindowOrWorker>(*state, "store");
}

static inline JSC::EncodedJSValue jsCredentialsContainerPrototypeFunctionCreateBody(JSC::ExecState* state, typename IDLOperationReturningPromise<JSCredentialsContainer>::ClassParameter castedThis, Ref<DeferredPromise>&& promise, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    auto options = convert<IDLDictionary<CredentialCreationOptions>>(*state, state->argument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    impl.isCreate(WTFMove(options), WTFMove(promise));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsCredentialsContainerPrototypeFunctionCreate(ExecState* state)
{
    return IDLOperationReturningPromise<JSCredentialsContainer>::call<jsCredentialsContainerPrototypeFunctionCreateBody, PromiseExecutionScope::WindowOrWorker>(*state, "create");
}

static inline JSC::EncodedJSValue jsCredentialsContainerPrototypeFunctionPreventSilentAccessBody(JSC::ExecState* state, typename IDLOperationReturningPromise<JSCredentialsContainer>::ClassParameter castedThis, Ref<DeferredPromise>&& promise, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    impl.preventSilentAccess(WTFMove(promise));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsCredentialsContainerPrototypeFunctionPreventSilentAccess(ExecState* state)
{
    return IDLOperationReturningPromise<JSCredentialsContainer>::call<jsCredentialsContainerPrototypeFunctionPreventSilentAccessBody, PromiseExecutionScope::WindowOrWorker>(*state, "preventSilentAccess");
}

bool JSCredentialsContainerOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSCredentialsContainerOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsCredentialsContainer = static_cast<JSCredentialsContainer*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsCredentialsContainer->wrapped(), jsCredentialsContainer);
}

JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject* globalObject, Ref<CredentialsContainer>&& impl)
{
    // If you hit this failure the interface definition has the ImplementationLacksVTable
    // attribute. You should remove that attribute. If the class has subclasses
    // that may be passed through this toJS() function you should use the SkipVTableValidation
    // attribute to CredentialsContainer.
    static_assert(!std::is_polymorphic<CredentialsContainer>::value, "CredentialsContainer is polymorphic but the IDL claims it is not");
    return createWrapper<CredentialsContainer>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, CredentialsContainer& impl)
{
    return wrap(state, globalObject, impl);
}

CredentialsContainer* JSCredentialsContainer::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicDowncast<JSCredentialsContainer*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
