/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(SUBTLE_CRYPTO)

#include "JSCryptoRsaHashedKeyAlgorithm.h"

#include "JSCryptoKeyAlgorithm.h"
#include "JSDOMConvertBufferSource.h"
#include "JSDOMConvertNumbers.h"
#include "JSDOMConvertStrings.h"
#include "JSDOMGlobalObject.h"
#include <runtime/JSCInlines.h>
#include <runtime/ObjectConstructor.h>

using namespace JSC;

namespace WebCore {

#if ENABLE(SUBTLE_CRYPTO)

template<> CryptoRsaHashedKeyAlgorithm convertDictionary<CryptoRsaHashedKeyAlgorithm>(ExecState& state, JSValue value)
{
    VM& vm = state.vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&state, throwScope);
        return { };
    }
    CryptoRsaHashedKeyAlgorithm result;
    JSValue nameValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "name"));
    if (!nameValue.isUndefined()) {
        result.name = convert<IDLDOMString>(state, nameValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "name", "CryptoRsaHashedKeyAlgorithm", "DOMString");
        return { };
    }
    JSValue modulusLengthValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "modulusLength"));
    if (!modulusLengthValue.isUndefined()) {
        result.modulusLength = convert<IDLUnsignedLong>(state, modulusLengthValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "modulusLength", "CryptoRsaHashedKeyAlgorithm", "unsigned long");
        return { };
    }
    JSValue publicExponentValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "publicExponent"));
    if (!publicExponentValue.isUndefined()) {
        result.publicExponent = convert<IDLUint8Array>(state, publicExponentValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "publicExponent", "CryptoRsaHashedKeyAlgorithm", "Uint8Array");
        return { };
    }
    JSValue hashValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "hash"));
    if (!hashValue.isUndefined()) {
        result.hash = convert<IDLDictionary<CryptoKeyAlgorithm>>(state, hashValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "hash", "CryptoRsaHashedKeyAlgorithm", "CryptoKeyAlgorithm");
        return { };
    }
    return result;
}

JSC::JSObject* convertDictionaryToJS(JSC::ExecState& state, JSDOMGlobalObject& globalObject, const CryptoRsaHashedKeyAlgorithm& dictionary)
{
    auto& vm = state.vm();

    auto result = constructEmptyObject(&state, globalObject.objectPrototype());

    auto nameValue = toJS<IDLDOMString>(state, dictionary.name);
    result->putDirect(vm, JSC::Identifier::fromString(&vm, "name"), nameValue);
    auto modulusLengthValue = toJS<IDLUnsignedLong>(dictionary.modulusLength);
    result->putDirect(vm, JSC::Identifier::fromString(&vm, "modulusLength"), modulusLengthValue);
    auto publicExponentValue = toJS<IDLUint8Array>(state, globalObject, dictionary.publicExponent);
    result->putDirect(vm, JSC::Identifier::fromString(&vm, "publicExponent"), publicExponentValue);
    auto hashValue = toJS<IDLDictionary<CryptoKeyAlgorithm>>(state, globalObject, dictionary.hash);
    result->putDirect(vm, JSC::Identifier::fromString(&vm, "hash"), hashValue);
    return result;
}

#endif

} // namespace WebCore

#endif // ENABLE(SUBTLE_CRYPTO)
