/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSDOMMatrixInit.h"

#include "JSDOMConvertBoolean.h"
#include "JSDOMConvertNumbers.h"
#include <runtime/JSCInlines.h>

using namespace JSC;

namespace WebCore {

template<> DOMMatrixInit convertDictionary<DOMMatrixInit>(ExecState& state, JSValue value)
{
    VM& vm = state.vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&state, throwScope);
        return { };
    }
    DOMMatrixInit result;
    JSValue aValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "a"));
    if (!aValue.isUndefined()) {
        result.a = convert<IDLUnrestrictedDouble>(state, aValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue bValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "b"));
    if (!bValue.isUndefined()) {
        result.b = convert<IDLUnrestrictedDouble>(state, bValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue cValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "c"));
    if (!cValue.isUndefined()) {
        result.c = convert<IDLUnrestrictedDouble>(state, cValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue dValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "d"));
    if (!dValue.isUndefined()) {
        result.d = convert<IDLUnrestrictedDouble>(state, dValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue eValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "e"));
    if (!eValue.isUndefined()) {
        result.e = convert<IDLUnrestrictedDouble>(state, eValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue fValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "f"));
    if (!fValue.isUndefined()) {
        result.f = convert<IDLUnrestrictedDouble>(state, fValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue is2DValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "is2D"));
    if (!is2DValue.isUndefined()) {
        result.is2D = convert<IDLBoolean>(state, is2DValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue m11Value = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "m11"));
    if (!m11Value.isUndefined()) {
        result.m11 = convert<IDLUnrestrictedDouble>(state, m11Value);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue m12Value = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "m12"));
    if (!m12Value.isUndefined()) {
        result.m12 = convert<IDLUnrestrictedDouble>(state, m12Value);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue m13Value = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "m13"));
    if (!m13Value.isUndefined()) {
        result.m13 = convert<IDLUnrestrictedDouble>(state, m13Value);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.m13 = 0;
    JSValue m14Value = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "m14"));
    if (!m14Value.isUndefined()) {
        result.m14 = convert<IDLUnrestrictedDouble>(state, m14Value);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.m14 = 0;
    JSValue m21Value = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "m21"));
    if (!m21Value.isUndefined()) {
        result.m21 = convert<IDLUnrestrictedDouble>(state, m21Value);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue m22Value = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "m22"));
    if (!m22Value.isUndefined()) {
        result.m22 = convert<IDLUnrestrictedDouble>(state, m22Value);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue m23Value = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "m23"));
    if (!m23Value.isUndefined()) {
        result.m23 = convert<IDLUnrestrictedDouble>(state, m23Value);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.m23 = 0;
    JSValue m24Value = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "m24"));
    if (!m24Value.isUndefined()) {
        result.m24 = convert<IDLUnrestrictedDouble>(state, m24Value);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.m24 = 0;
    JSValue m31Value = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "m31"));
    if (!m31Value.isUndefined()) {
        result.m31 = convert<IDLUnrestrictedDouble>(state, m31Value);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.m31 = 0;
    JSValue m32Value = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "m32"));
    if (!m32Value.isUndefined()) {
        result.m32 = convert<IDLUnrestrictedDouble>(state, m32Value);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.m32 = 0;
    JSValue m33Value = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "m33"));
    if (!m33Value.isUndefined()) {
        result.m33 = convert<IDLUnrestrictedDouble>(state, m33Value);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.m33 = 1;
    JSValue m34Value = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "m34"));
    if (!m34Value.isUndefined()) {
        result.m34 = convert<IDLUnrestrictedDouble>(state, m34Value);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.m34 = 0;
    JSValue m41Value = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "m41"));
    if (!m41Value.isUndefined()) {
        result.m41 = convert<IDLUnrestrictedDouble>(state, m41Value);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue m42Value = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "m42"));
    if (!m42Value.isUndefined()) {
        result.m42 = convert<IDLUnrestrictedDouble>(state, m42Value);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue m43Value = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "m43"));
    if (!m43Value.isUndefined()) {
        result.m43 = convert<IDLUnrestrictedDouble>(state, m43Value);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.m43 = 0;
    JSValue m44Value = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "m44"));
    if (!m44Value.isUndefined()) {
        result.m44 = convert<IDLUnrestrictedDouble>(state, m44Value);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.m44 = 1;
    return result;
}

} // namespace WebCore
