/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSErrorEvent.h"

#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructor.h"
#include "JSDOMConvertAny.h"
#include "JSDOMConvertBoolean.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMConvertNumbers.h"
#include "JSDOMConvertStrings.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMWrapperCache.h"
#include <runtime/JSCInlines.h>
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

template<> ErrorEvent::Init convertDictionary<ErrorEvent::Init>(ExecState& state, JSValue value)
{
    VM& vm = state.vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&state, throwScope);
        return { };
    }
    ErrorEvent::Init result;
    JSValue bubblesValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "bubbles"));
    if (!bubblesValue.isUndefined()) {
        result.bubbles = convert<IDLBoolean>(state, bubblesValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.bubbles = false;
    JSValue cancelableValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "cancelable"));
    if (!cancelableValue.isUndefined()) {
        result.cancelable = convert<IDLBoolean>(state, cancelableValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.cancelable = false;
    JSValue composedValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "composed"));
    if (!composedValue.isUndefined()) {
        result.composed = convert<IDLBoolean>(state, composedValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.composed = false;
    JSValue colnoValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "colno"));
    if (!colnoValue.isUndefined()) {
        result.colno = convert<IDLUnsignedLong>(state, colnoValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.colno = 0;
    JSValue errorValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "error"));
    if (!errorValue.isUndefined()) {
        result.error = convert<IDLAny>(state, errorValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.error = jsNull();
    JSValue filenameValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "filename"));
    if (!filenameValue.isUndefined()) {
        result.filename = convert<IDLUSVString>(state, filenameValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.filename = emptyString();
    JSValue linenoValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "lineno"));
    if (!linenoValue.isUndefined()) {
        result.lineno = convert<IDLUnsignedLong>(state, linenoValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.lineno = 0;
    JSValue messageValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "message"));
    if (!messageValue.isUndefined()) {
        result.message = convert<IDLDOMString>(state, messageValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.message = emptyString();
    return result;
}

// Attributes

JSC::EncodedJSValue jsErrorEventConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSErrorEventConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);
JSC::EncodedJSValue jsErrorEventMessage(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsErrorEventFilename(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsErrorEventLineno(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsErrorEventColno(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsErrorEventError(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);

class JSErrorEventPrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSErrorEventPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSErrorEventPrototype* ptr = new (NotNull, JSC::allocateCell<JSErrorEventPrototype>(vm.heap)) JSErrorEventPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSErrorEventPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSErrorEventConstructor = JSDOMConstructor<JSErrorEvent>;

template<> EncodedJSValue JSC_HOST_CALL JSErrorEventConstructor::construct(ExecState* state)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    auto* castedThis = jsCast<JSErrorEventConstructor*>(state->jsCallee());
    ASSERT(castedThis);
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto type = convert<IDLDOMString>(*state, state->uncheckedArgument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto eventInitDict = convert<IDLDictionary<ErrorEvent::Init>>(*state, state->argument(1));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto object = ErrorEvent::create(*state, WTFMove(type), WTFMove(eventInitDict));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    return JSValue::encode(toJSNewlyCreated<IDLInterface<ErrorEvent>>(*state, *castedThis->globalObject(), WTFMove(object)));
}

template<> JSValue JSErrorEventConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    return JSEvent::getConstructor(vm, &globalObject);
}

template<> void JSErrorEventConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSErrorEvent::prototype(vm, globalObject), DontDelete | ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String(ASCIILiteral("ErrorEvent"))), ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(1), ReadOnly | DontEnum);
}

template<> const ClassInfo JSErrorEventConstructor::s_info = { "ErrorEvent", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSErrorEventConstructor) };

/* Hash table for prototype */

static const HashTableValue JSErrorEventPrototypeTableValues[] =
{
    { "constructor", DontEnum, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsErrorEventConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSErrorEventConstructor) } },
    { "message", ReadOnly | CustomAccessor | DOMAttribute, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsErrorEventMessage), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "filename", ReadOnly | CustomAccessor | DOMAttribute, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsErrorEventFilename), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "lineno", ReadOnly | CustomAccessor | DOMAttribute, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsErrorEventLineno), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "colno", ReadOnly | CustomAccessor | DOMAttribute, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsErrorEventColno), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "error", ReadOnly | CustomAccessor | DOMAttribute, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsErrorEventError), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
};

const ClassInfo JSErrorEventPrototype::s_info = { "ErrorEventPrototype", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSErrorEventPrototype) };

void JSErrorEventPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSErrorEvent::info(), JSErrorEventPrototypeTableValues, *this);
}

const ClassInfo JSErrorEvent::s_info = { "ErrorEvent", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSErrorEvent) };

JSErrorEvent::JSErrorEvent(Structure* structure, JSDOMGlobalObject& globalObject, Ref<ErrorEvent>&& impl)
    : JSEvent(structure, globalObject, WTFMove(impl))
{
}

void JSErrorEvent::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSErrorEvent::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSErrorEventPrototype::create(vm, &globalObject, JSErrorEventPrototype::createStructure(vm, &globalObject, JSEvent::prototype(vm, globalObject)));
}

JSObject* JSErrorEvent::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSErrorEvent>(vm, globalObject);
}

JSValue JSErrorEvent::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSErrorEventConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

template<> inline JSErrorEvent* IDLAttribute<JSErrorEvent>::cast(ExecState& state, EncodedJSValue thisValue)
{
    return jsDynamicDowncast<JSErrorEvent*>(state.vm(), JSValue::decode(thisValue));
}

EncodedJSValue jsErrorEventConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicDowncast<JSErrorEventPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSErrorEvent::getConstructor(state->vm(), prototype->globalObject()));
}

bool setJSErrorEventConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicDowncast<JSErrorEventPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return prototype->putDirect(state->vm(), state->propertyNames().constructor, JSValue::decode(encodedValue));
}

static inline JSValue jsErrorEventMessageGetter(ExecState& state, JSErrorEvent& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLDOMString>(state, impl.message());
    return result;
}

EncodedJSValue jsErrorEventMessage(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSErrorEvent>::get<jsErrorEventMessageGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "message");
}

static inline JSValue jsErrorEventFilenameGetter(ExecState& state, JSErrorEvent& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUSVString>(state, impl.filename());
    return result;
}

EncodedJSValue jsErrorEventFilename(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSErrorEvent>::get<jsErrorEventFilenameGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "filename");
}

static inline JSValue jsErrorEventLinenoGetter(ExecState& state, JSErrorEvent& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnsignedLong>(impl.lineno());
    return result;
}

EncodedJSValue jsErrorEventLineno(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSErrorEvent>::get<jsErrorEventLinenoGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "lineno");
}

static inline JSValue jsErrorEventColnoGetter(ExecState& state, JSErrorEvent& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnsignedLong>(impl.colno());
    return result;
}

EncodedJSValue jsErrorEventColno(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSErrorEvent>::get<jsErrorEventColnoGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "colno");
}

static inline JSValue jsErrorEventErrorGetter(ExecState& state, JSErrorEvent& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLAny>(impl.error(state, *jsCast<JSDOMGlobalObject*>(state.lexicalGlobalObject())));
    return result;
}

EncodedJSValue jsErrorEventError(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSErrorEvent>::get<jsErrorEventErrorGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "error");
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7ErrorEvent@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore10ErrorEventE[]; }
#endif
#endif

JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject* globalObject, Ref<ErrorEvent>&& impl)
{

#if ENABLE(BINDING_INTEGRITY)
    void* actualVTablePointer = *(reinterpret_cast<void**>(impl.ptr()));
#if PLATFORM(WIN)
    void* expectedVTablePointer = reinterpret_cast<void*>(__identifier("??_7ErrorEvent@WebCore@@6B@"));
#else
    void* expectedVTablePointer = &_ZTVN7WebCore10ErrorEventE[2];
#endif

    // If this fails ErrorEvent does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    static_assert(std::is_polymorphic<ErrorEvent>::value, "ErrorEvent is not polymorphic");

    // If you hit this assertion you either have a use after free bug, or
    // ErrorEvent has subclasses. If ErrorEvent has subclasses that get passed
    // to toJS() we currently require ErrorEvent you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    return createWrapper<ErrorEvent>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, ErrorEvent& impl)
{
    return wrap(state, globalObject, impl);
}


}
