/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSFederatedCredential.h"

#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructor.h"
#include "JSDOMConvertDictionary.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMConvertNullable.h"
#include "JSDOMConvertStrings.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMWrapperCache.h"
#include "JSFederatedCredentialInit.h"
#include "RuntimeEnabledFeatures.h"
#include "ScriptExecutionContext.h"
#include <runtime/JSCInlines.h>
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

// Attributes

JSC::EncodedJSValue jsFederatedCredentialConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSFederatedCredentialConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);
JSC::EncodedJSValue jsFederatedCredentialProvider(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsFederatedCredentialProtocol(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsFederatedCredentialName(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsFederatedCredentialIconURL(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);

class JSFederatedCredentialPrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSFederatedCredentialPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSFederatedCredentialPrototype* ptr = new (NotNull, JSC::allocateCell<JSFederatedCredentialPrototype>(vm.heap)) JSFederatedCredentialPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSFederatedCredentialPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSFederatedCredentialConstructor = JSDOMConstructor<JSFederatedCredential>;

template<> EncodedJSValue JSC_HOST_CALL JSFederatedCredentialConstructor::construct(ExecState* state)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    auto* castedThis = jsCast<JSFederatedCredentialConstructor*>(state->jsCallee());
    ASSERT(castedThis);
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto data = convert<IDLDictionary<FederatedCredentialInit>>(*state, state->uncheckedArgument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto object = FederatedCredential::create(WTFMove(data));
    return JSValue::encode(toJSNewlyCreated<IDLInterface<FederatedCredential>>(*state, *castedThis->globalObject(), WTFMove(object)));
}

template<> JSValue JSFederatedCredentialConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    return JSBasicCredential::getConstructor(vm, &globalObject);
}

template<> void JSFederatedCredentialConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSFederatedCredential::prototype(vm, globalObject), DontDelete | ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String(ASCIILiteral("FederatedCredential"))), ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(1), ReadOnly | DontEnum);
}

template<> const ClassInfo JSFederatedCredentialConstructor::s_info = { "FederatedCredential", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSFederatedCredentialConstructor) };

/* Hash table for prototype */

static const HashTableValue JSFederatedCredentialPrototypeTableValues[] =
{
    { "constructor", DontEnum, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsFederatedCredentialConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSFederatedCredentialConstructor) } },
    { "provider", ReadOnly | CustomAccessor | DOMAttribute, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsFederatedCredentialProvider), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "protocol", ReadOnly | CustomAccessor | DOMAttribute, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsFederatedCredentialProtocol), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "name", ReadOnly | CustomAccessor | DOMAttribute, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsFederatedCredentialName), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "iconURL", ReadOnly | CustomAccessor | DOMAttribute, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsFederatedCredentialIconURL), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
};

const ClassInfo JSFederatedCredentialPrototype::s_info = { "FederatedCredentialPrototype", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSFederatedCredentialPrototype) };

void JSFederatedCredentialPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSFederatedCredential::info(), JSFederatedCredentialPrototypeTableValues, *this);
    if (!RuntimeEnabledFeatures::sharedFeatures().credentialManagementEnabled()) {
        auto propertyName = Identifier::fromString(&vm, reinterpret_cast<const LChar*>("name"), strlen("name"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        JSObject::deleteProperty(this, globalObject()->globalExec(), propertyName);
    }
    if (!RuntimeEnabledFeatures::sharedFeatures().credentialManagementEnabled()) {
        auto propertyName = Identifier::fromString(&vm, reinterpret_cast<const LChar*>("iconURL"), strlen("iconURL"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        JSObject::deleteProperty(this, globalObject()->globalExec(), propertyName);
    }
}

const ClassInfo JSFederatedCredential::s_info = { "FederatedCredential", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSFederatedCredential) };

JSFederatedCredential::JSFederatedCredential(Structure* structure, JSDOMGlobalObject& globalObject, Ref<FederatedCredential>&& impl)
    : JSBasicCredential(structure, globalObject, WTFMove(impl))
{
}

void JSFederatedCredential::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSFederatedCredential::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSFederatedCredentialPrototype::create(vm, &globalObject, JSFederatedCredentialPrototype::createStructure(vm, &globalObject, JSBasicCredential::prototype(vm, globalObject)));
}

JSObject* JSFederatedCredential::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSFederatedCredential>(vm, globalObject);
}

JSValue JSFederatedCredential::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSFederatedCredentialConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

template<> inline JSFederatedCredential* IDLAttribute<JSFederatedCredential>::cast(ExecState& state, EncodedJSValue thisValue)
{
    return jsDynamicDowncast<JSFederatedCredential*>(state.vm(), JSValue::decode(thisValue));
}

EncodedJSValue jsFederatedCredentialConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicDowncast<JSFederatedCredentialPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSFederatedCredential::getConstructor(state->vm(), prototype->globalObject()));
}

bool setJSFederatedCredentialConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicDowncast<JSFederatedCredentialPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return prototype->putDirect(state->vm(), state->propertyNames().constructor, JSValue::decode(encodedValue));
}

static inline JSValue jsFederatedCredentialProviderGetter(ExecState& state, JSFederatedCredential& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUSVString>(state, impl.provider());
    return result;
}

EncodedJSValue jsFederatedCredentialProvider(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSFederatedCredential>::get<jsFederatedCredentialProviderGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "provider");
}

static inline JSValue jsFederatedCredentialProtocolGetter(ExecState& state, JSFederatedCredential& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLNullable<IDLDOMString>>(state, impl.protocol());
    return result;
}

EncodedJSValue jsFederatedCredentialProtocol(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSFederatedCredential>::get<jsFederatedCredentialProtocolGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "protocol");
}

static inline JSValue jsFederatedCredentialNameGetter(ExecState& state, JSFederatedCredential& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUSVString>(state, impl.name());
    return result;
}

EncodedJSValue jsFederatedCredentialName(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSFederatedCredential>::get<jsFederatedCredentialNameGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "name");
}

static inline JSValue jsFederatedCredentialIconURLGetter(ExecState& state, JSFederatedCredential& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUSVString>(state, impl.iconURL());
    return result;
}

EncodedJSValue jsFederatedCredentialIconURL(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSFederatedCredential>::get<jsFederatedCredentialIconURLGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "iconURL");
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7FederatedCredential@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore19FederatedCredentialE[]; }
#endif
#endif

JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject* globalObject, Ref<FederatedCredential>&& impl)
{

#if ENABLE(BINDING_INTEGRITY)
    void* actualVTablePointer = *(reinterpret_cast<void**>(impl.ptr()));
#if PLATFORM(WIN)
    void* expectedVTablePointer = reinterpret_cast<void*>(__identifier("??_7FederatedCredential@WebCore@@6B@"));
#else
    void* expectedVTablePointer = &_ZTVN7WebCore19FederatedCredentialE[2];
#endif

    // If this fails FederatedCredential does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    static_assert(std::is_polymorphic<FederatedCredential>::value, "FederatedCredential is not polymorphic");

    // If you hit this assertion you either have a use after free bug, or
    // FederatedCredential has subclasses. If FederatedCredential has subclasses that get passed
    // to toJS() we currently require FederatedCredential you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    return createWrapper<FederatedCredential>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, FederatedCredential& impl)
{
    return wrap(state, globalObject, impl);
}


}
