/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSFetchRequestInit.h"

#include "JSBlob.h"
#include "JSDOMConvertAny.h"
#include "JSDOMConvertBoolean.h"
#include "JSDOMConvertBufferSource.h"
#include "JSDOMConvertEnumeration.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMConvertNullable.h"
#include "JSDOMConvertRecord.h"
#include "JSDOMConvertSequences.h"
#include "JSDOMConvertStrings.h"
#include "JSDOMConvertUnion.h"
#include "JSDOMFormData.h"
#include "JSFetchReferrerPolicy.h"
#include "JSFetchRequestCache.h"
#include "JSFetchRequestCredentials.h"
#include "JSFetchRequestMode.h"
#include "JSFetchRequestRedirect.h"
#include "JSURLSearchParams.h"
#include <runtime/JSArray.h>
#include <runtime/JSCInlines.h>
#include <wtf/Variant.h>
#include <wtf/Vector.h>

using namespace JSC;

namespace WebCore {

template<> FetchRequestInit convertDictionary<FetchRequestInit>(ExecState& state, JSValue value)
{
    VM& vm = state.vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&state, throwScope);
        return { };
    }
    FetchRequestInit result;
    JSValue bodyValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "body"));
    if (!bodyValue.isUndefined()) {
        result.body = convert<IDLNullable<IDLUnion<IDLInterface<Blob>, IDLArrayBufferView, IDLArrayBuffer, IDLInterface<DOMFormData>, IDLInterface<URLSearchParams>, IDLUSVString>>>(state, bodyValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue cacheValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "cache"));
    if (!cacheValue.isUndefined()) {
        result.cache = convert<IDLEnumeration<FetchRequestCache>>(state, cacheValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue credentialsValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "credentials"));
    if (!credentialsValue.isUndefined()) {
        result.credentials = convert<IDLEnumeration<FetchRequestCredentials>>(state, credentialsValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue headersValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "headers"));
    if (!headersValue.isUndefined()) {
        result.headers = convert<IDLUnion<IDLSequence<IDLSequence<IDLByteString>>, IDLRecord<IDLByteString, IDLByteString>>>(state, headersValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue integrityValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "integrity"));
    if (!integrityValue.isUndefined()) {
        result.integrity = convert<IDLDOMString>(state, integrityValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue keepaliveValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "keepalive"));
    if (!keepaliveValue.isUndefined()) {
        result.keepalive = convert<IDLBoolean>(state, keepaliveValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue methodValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "method"));
    if (!methodValue.isUndefined()) {
        result.method = convert<IDLByteString>(state, methodValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue modeValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "mode"));
    if (!modeValue.isUndefined()) {
        result.mode = convert<IDLEnumeration<FetchRequestMode>>(state, modeValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue redirectValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "redirect"));
    if (!redirectValue.isUndefined()) {
        result.redirect = convert<IDLEnumeration<FetchRequestRedirect>>(state, redirectValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue referrerValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "referrer"));
    if (!referrerValue.isUndefined()) {
        result.referrer = convert<IDLUSVString>(state, referrerValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue referrerPolicyValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "referrerPolicy"));
    if (!referrerPolicyValue.isUndefined()) {
        result.referrerPolicy = convert<IDLEnumeration<FetchReferrerPolicy>>(state, referrerPolicyValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue windowValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "window"));
    if (!windowValue.isUndefined()) {
        result.window = convert<IDLAny>(state, windowValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.window = jsUndefined();
    return result;
}

} // namespace WebCore
