/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSFetchResponse.h"

#include "FetchResponseBuiltins.h"
#include "JSBlob.h"
#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMBuiltinConstructor.h"
#include "JSDOMConvertBoolean.h"
#include "JSDOMConvertBufferSource.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMConvertNumbers.h"
#include "JSDOMConvertRecord.h"
#include "JSDOMConvertSequences.h"
#include "JSDOMConvertStrings.h"
#include "JSDOMConvertUnion.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMFormData.h"
#include "JSDOMGlobalObject.h"
#include "JSDOMOperation.h"
#include "JSDOMOperationReturningPromise.h"
#include "JSDOMWrapperCache.h"
#include "JSFetchHeaders.h"
#include "JSFetchResponse.h"
#include "JSReadableStreamSource.h"
#include "JSURLSearchParams.h"
#include "WebCoreJSClientData.h"
#include <runtime/FunctionPrototype.h>
#include <runtime/JSArray.h>
#include <runtime/JSCInlines.h>
#include <runtime/JSString.h>
#include <wtf/GetPtr.h>
#include <wtf/Variant.h>
#include <wtf/Vector.h>

using namespace JSC;

namespace WebCore {

template<> JSString* convertEnumerationToJS(ExecState& state, FetchResponse::Type enumerationValue)
{
    static const NeverDestroyed<String> values[] = {
        MAKE_STATIC_STRING_IMPL("basic"),
        MAKE_STATIC_STRING_IMPL("cors"),
        MAKE_STATIC_STRING_IMPL("default"),
        MAKE_STATIC_STRING_IMPL("error"),
        MAKE_STATIC_STRING_IMPL("opaque"),
        MAKE_STATIC_STRING_IMPL("opaqueredirect"),
    };
    static_assert(static_cast<size_t>(FetchResponse::Type::Basic) == 0, "FetchResponse::Type::Basic is not 0 as expected");
    static_assert(static_cast<size_t>(FetchResponse::Type::Cors) == 1, "FetchResponse::Type::Cors is not 1 as expected");
    static_assert(static_cast<size_t>(FetchResponse::Type::Default) == 2, "FetchResponse::Type::Default is not 2 as expected");
    static_assert(static_cast<size_t>(FetchResponse::Type::Error) == 3, "FetchResponse::Type::Error is not 3 as expected");
    static_assert(static_cast<size_t>(FetchResponse::Type::Opaque) == 4, "FetchResponse::Type::Opaque is not 4 as expected");
    static_assert(static_cast<size_t>(FetchResponse::Type::Opaqueredirect) == 5, "FetchResponse::Type::Opaqueredirect is not 5 as expected");
    ASSERT(static_cast<size_t>(enumerationValue) < WTF_ARRAY_LENGTH(values));
    return jsStringWithCache(&state, values[static_cast<size_t>(enumerationValue)]);
}

template<> std::optional<FetchResponse::Type> parseEnumeration<FetchResponse::Type>(ExecState& state, JSValue value)
{
    auto stringValue = value.toWTFString(&state);
    if (stringValue == "basic")
        return FetchResponse::Type::Basic;
    if (stringValue == "cors")
        return FetchResponse::Type::Cors;
    if (stringValue == "default")
        return FetchResponse::Type::Default;
    if (stringValue == "error")
        return FetchResponse::Type::Error;
    if (stringValue == "opaque")
        return FetchResponse::Type::Opaque;
    if (stringValue == "opaqueredirect")
        return FetchResponse::Type::Opaqueredirect;
    return std::nullopt;
}

template<> const char* expectedEnumerationValues<FetchResponse::Type>()
{
    return "\"basic\", \"cors\", \"default\", \"error\", \"opaque\", \"opaqueredirect\"";
}

template<> FetchResponse::Init convertDictionary<FetchResponse::Init>(ExecState& state, JSValue value)
{
    VM& vm = state.vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&state, throwScope);
        return { };
    }
    FetchResponse::Init result;
    JSValue headersValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "headers"));
    if (!headersValue.isUndefined()) {
        result.headers = convert<IDLUnion<IDLSequence<IDLSequence<IDLByteString>>, IDLRecord<IDLByteString, IDLByteString>>>(state, headersValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue statusValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "status"));
    if (!statusValue.isUndefined()) {
        result.status = convert<IDLUnsignedShort>(state, statusValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.status = 200;
    JSValue statusTextValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "statusText"));
    if (!statusTextValue.isUndefined()) {
        result.statusText = convert<IDLByteString>(state, statusTextValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.statusText = ASCIILiteral("OK");
    return result;
}

// Functions

JSC::EncodedJSValue JSC_HOST_CALL jsFetchResponseConstructorFunctionError(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsFetchResponseConstructorFunctionRedirect(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsFetchResponsePrototypeFunctionCloneForJS(JSC::ExecState*);
#if ENABLE(STREAMS_API)
JSC::EncodedJSValue JSC_HOST_CALL jsFetchResponsePrototypeFunctionStartConsumingStream(JSC::ExecState*);
#endif
#if ENABLE(STREAMS_API)
JSC::EncodedJSValue JSC_HOST_CALL jsFetchResponsePrototypeFunctionConsumeChunk(JSC::ExecState*);
#endif
#if ENABLE(STREAMS_API)
JSC::EncodedJSValue JSC_HOST_CALL jsFetchResponsePrototypeFunctionFinishConsumingStream(JSC::ExecState*);
#endif
JSC::EncodedJSValue JSC_HOST_CALL jsFetchResponsePrototypeFunctionConsume(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsFetchResponsePrototypeFunctionIsLoading(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsFetchResponsePrototypeFunctionSetStatus(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsFetchResponsePrototypeFunctionInitializeWith(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsFetchResponsePrototypeFunctionCreateReadableStreamSource(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsFetchResponsePrototypeFunctionIsDisturbed(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsFetchResponsePrototypeFunctionSetBodyAsReadableStream(JSC::ExecState*);

// Attributes

JSC::EncodedJSValue jsFetchResponseConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSFetchResponseConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);
JSC::EncodedJSValue jsFetchResponseType(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsFetchResponseUrl(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsFetchResponseRedirected(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsFetchResponseStatus(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsFetchResponseOk(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsFetchResponseStatusText(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsFetchResponseHeaders(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);

class JSFetchResponsePrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSFetchResponsePrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSFetchResponsePrototype* ptr = new (NotNull, JSC::allocateCell<JSFetchResponsePrototype>(vm.heap)) JSFetchResponsePrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSFetchResponsePrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSFetchResponseConstructor = JSDOMBuiltinConstructor<JSFetchResponse>;

/* Hash table for constructor */

static const HashTableValue JSFetchResponseConstructorTableValues[] =
{
    { "error", JSC::Function, NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsFetchResponseConstructorFunctionError), (intptr_t) (0) } },
    { "redirect", JSC::Function, NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsFetchResponseConstructorFunctionRedirect), (intptr_t) (1) } },
};

template<> JSValue JSFetchResponseConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSFetchResponseConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSFetchResponse::prototype(vm, globalObject), DontDelete | ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String(ASCIILiteral("Response"))), ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), ReadOnly | DontEnum);
    reifyStaticProperties(vm, JSFetchResponse::info(), JSFetchResponseConstructorTableValues, *this);
}

template<> FunctionExecutable* JSFetchResponseConstructor::initializeExecutable(VM& vm)
{
    return fetchResponseInitializeFetchResponseCodeGenerator(vm);
}

template<> const ClassInfo JSFetchResponseConstructor::s_info = { "Response", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSFetchResponseConstructor) };

/* Hash table for prototype */

static const HashTableValue JSFetchResponsePrototypeTableValues[] =
{
    { "constructor", DontEnum, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsFetchResponseConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSFetchResponseConstructor) } },
    { "type", ReadOnly | CustomAccessor | DOMAttribute, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsFetchResponseType), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "url", ReadOnly | CustomAccessor | DOMAttribute, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsFetchResponseUrl), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "redirected", ReadOnly | CustomAccessor | DOMAttribute, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsFetchResponseRedirected), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "status", ReadOnly | CustomAccessor | DOMAttribute, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsFetchResponseStatus), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "ok", ReadOnly | CustomAccessor | DOMAttribute, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsFetchResponseOk), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "statusText", ReadOnly | CustomAccessor | DOMAttribute, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsFetchResponseStatusText), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "headers", ReadOnly | CustomAccessor | DOMAttribute, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsFetchResponseHeaders), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "body", ReadOnly | Accessor | Builtin, NoIntrinsic, { (intptr_t)static_cast<BuiltinGenerator>(fetchResponseBodyCodeGenerator), (intptr_t) (0) } },
    { "bodyUsed", ReadOnly | Accessor | Builtin, NoIntrinsic, { (intptr_t)static_cast<BuiltinGenerator>(fetchResponseBodyUsedCodeGenerator), (intptr_t) (0) } },
    { "clone", JSC::Builtin, NoIntrinsic, { (intptr_t)static_cast<BuiltinGenerator>(fetchResponseCloneCodeGenerator), (intptr_t) (0) } },
    { "arrayBuffer", JSC::Builtin, NoIntrinsic, { (intptr_t)static_cast<BuiltinGenerator>(fetchResponseArrayBufferCodeGenerator), (intptr_t) (0) } },
    { "blob", JSC::Builtin, NoIntrinsic, { (intptr_t)static_cast<BuiltinGenerator>(fetchResponseBlobCodeGenerator), (intptr_t) (0) } },
    { "formData", JSC::Builtin, NoIntrinsic, { (intptr_t)static_cast<BuiltinGenerator>(fetchResponseFormDataCodeGenerator), (intptr_t) (0) } },
    { "json", JSC::Builtin, NoIntrinsic, { (intptr_t)static_cast<BuiltinGenerator>(fetchResponseJsonCodeGenerator), (intptr_t) (0) } },
    { "text", JSC::Builtin, NoIntrinsic, { (intptr_t)static_cast<BuiltinGenerator>(fetchResponseTextCodeGenerator), (intptr_t) (0) } },
};

const ClassInfo JSFetchResponsePrototype::s_info = { "ResponsePrototype", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSFetchResponsePrototype) };

void JSFetchResponsePrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSFetchResponse::info(), JSFetchResponsePrototypeTableValues, *this);
    putDirect(vm, static_cast<JSVMClientData*>(vm.clientData)->builtinNames().cloneForJSPrivateName(), JSFunction::create(vm, globalObject(), 0, String(), jsFetchResponsePrototypeFunctionCloneForJS), ReadOnly | DontEnum);
#if ENABLE(STREAMS_API)
    putDirect(vm, static_cast<JSVMClientData*>(vm.clientData)->builtinNames().startConsumingStreamPrivateName(), JSFunction::create(vm, globalObject(), 0, String(), jsFetchResponsePrototypeFunctionStartConsumingStream), ReadOnly | DontEnum);
#endif
#if ENABLE(STREAMS_API)
    putDirect(vm, static_cast<JSVMClientData*>(vm.clientData)->builtinNames().consumeChunkPrivateName(), JSFunction::create(vm, globalObject(), 0, String(), jsFetchResponsePrototypeFunctionConsumeChunk), ReadOnly | DontEnum);
#endif
#if ENABLE(STREAMS_API)
    putDirect(vm, static_cast<JSVMClientData*>(vm.clientData)->builtinNames().finishConsumingStreamPrivateName(), JSFunction::create(vm, globalObject(), 0, String(), jsFetchResponsePrototypeFunctionFinishConsumingStream), ReadOnly | DontEnum);
#endif
    putDirect(vm, static_cast<JSVMClientData*>(vm.clientData)->builtinNames().consumePrivateName(), JSFunction::create(vm, globalObject(), 0, String(), jsFetchResponsePrototypeFunctionConsume), ReadOnly | DontEnum);
    putDirect(vm, static_cast<JSVMClientData*>(vm.clientData)->builtinNames().isLoadingPrivateName(), JSFunction::create(vm, globalObject(), 0, String(), jsFetchResponsePrototypeFunctionIsLoading), ReadOnly | DontEnum);
    putDirect(vm, static_cast<JSVMClientData*>(vm.clientData)->builtinNames().setStatusPrivateName(), JSFunction::create(vm, globalObject(), 0, String(), jsFetchResponsePrototypeFunctionSetStatus), ReadOnly | DontEnum);
    putDirect(vm, static_cast<JSVMClientData*>(vm.clientData)->builtinNames().initializeWithPrivateName(), JSFunction::create(vm, globalObject(), 0, String(), jsFetchResponsePrototypeFunctionInitializeWith), ReadOnly | DontEnum);
    putDirect(vm, static_cast<JSVMClientData*>(vm.clientData)->builtinNames().createReadableStreamSourcePrivateName(), JSFunction::create(vm, globalObject(), 0, String(), jsFetchResponsePrototypeFunctionCreateReadableStreamSource), ReadOnly | DontEnum);
    putDirect(vm, static_cast<JSVMClientData*>(vm.clientData)->builtinNames().isDisturbedPrivateName(), JSFunction::create(vm, globalObject(), 0, String(), jsFetchResponsePrototypeFunctionIsDisturbed), ReadOnly | DontEnum);
    putDirect(vm, static_cast<JSVMClientData*>(vm.clientData)->builtinNames().setBodyAsReadableStreamPrivateName(), JSFunction::create(vm, globalObject(), 0, String(), jsFetchResponsePrototypeFunctionSetBodyAsReadableStream), ReadOnly | DontEnum);
}

const ClassInfo JSFetchResponse::s_info = { "Response", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSFetchResponse) };

JSFetchResponse::JSFetchResponse(Structure* structure, JSDOMGlobalObject& globalObject, Ref<FetchResponse>&& impl)
    : JSDOMWrapper<FetchResponse>(structure, globalObject, WTFMove(impl))
{
}

void JSFetchResponse::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSFetchResponse::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSFetchResponsePrototype::create(vm, &globalObject, JSFetchResponsePrototype::createStructure(vm, &globalObject, globalObject.objectPrototype()));
}

JSObject* JSFetchResponse::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSFetchResponse>(vm, globalObject);
}

JSValue JSFetchResponse::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSFetchResponseConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

void JSFetchResponse::destroy(JSC::JSCell* cell)
{
    JSFetchResponse* thisObject = static_cast<JSFetchResponse*>(cell);
    thisObject->JSFetchResponse::~JSFetchResponse();
}

template<> inline JSFetchResponse* IDLAttribute<JSFetchResponse>::cast(ExecState& state, EncodedJSValue thisValue)
{
    return jsDynamicDowncast<JSFetchResponse*>(state.vm(), JSValue::decode(thisValue));
}

template<> inline JSFetchResponse* IDLOperation<JSFetchResponse>::cast(ExecState& state)
{
    return jsDynamicDowncast<JSFetchResponse*>(state.vm(), state.thisValue());
}

EncodedJSValue jsFetchResponseConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicDowncast<JSFetchResponsePrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSFetchResponse::getConstructor(state->vm(), prototype->globalObject()));
}

bool setJSFetchResponseConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicDowncast<JSFetchResponsePrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return prototype->putDirect(state->vm(), state->propertyNames().constructor, JSValue::decode(encodedValue));
}

static inline JSValue jsFetchResponseTypeGetter(ExecState& state, JSFetchResponse& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLEnumeration<FetchResponse::Type>>(state, impl.type());
    return result;
}

EncodedJSValue jsFetchResponseType(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSFetchResponse>::get<jsFetchResponseTypeGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "type");
}

static inline JSValue jsFetchResponseUrlGetter(ExecState& state, JSFetchResponse& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUSVString>(state, impl.url());
    return result;
}

EncodedJSValue jsFetchResponseUrl(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSFetchResponse>::get<jsFetchResponseUrlGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "url");
}

static inline JSValue jsFetchResponseRedirectedGetter(ExecState& state, JSFetchResponse& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLBoolean>(impl.redirected());
    return result;
}

EncodedJSValue jsFetchResponseRedirected(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSFetchResponse>::get<jsFetchResponseRedirectedGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "redirected");
}

static inline JSValue jsFetchResponseStatusGetter(ExecState& state, JSFetchResponse& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnsignedShort>(impl.status());
    return result;
}

EncodedJSValue jsFetchResponseStatus(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSFetchResponse>::get<jsFetchResponseStatusGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "status");
}

static inline JSValue jsFetchResponseOkGetter(ExecState& state, JSFetchResponse& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLBoolean>(impl.ok());
    return result;
}

EncodedJSValue jsFetchResponseOk(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSFetchResponse>::get<jsFetchResponseOkGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "ok");
}

static inline JSValue jsFetchResponseStatusTextGetter(ExecState& state, JSFetchResponse& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLByteString>(state, impl.statusText());
    return result;
}

EncodedJSValue jsFetchResponseStatusText(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSFetchResponse>::get<jsFetchResponseStatusTextGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "statusText");
}

static inline JSValue jsFetchResponseHeadersGetter(ExecState& state, JSFetchResponse& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLInterface<FetchHeaders>>(state, *thisObject.globalObject(), impl.headers());
    return result;
}

EncodedJSValue jsFetchResponseHeaders(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSFetchResponse>::get<jsFetchResponseHeadersGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "headers");
}

static inline JSC::EncodedJSValue jsFetchResponseConstructorFunctionErrorBody(JSC::ExecState* state, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto* context = jsCast<JSDOMGlobalObject*>(state->lexicalGlobalObject())->scriptExecutionContext();
    if (UNLIKELY(!context))
        return JSValue::encode(jsUndefined());
    return JSValue::encode(toJSNewlyCreated<IDLInterface<FetchResponse>>(*state, *jsCast<JSDOMGlobalObject*>(state->lexicalGlobalObject()), FetchResponse::error(*context)));
}

EncodedJSValue JSC_HOST_CALL jsFetchResponseConstructorFunctionError(ExecState* state)
{
    return IDLOperation<JSFetchResponse>::callStatic<jsFetchResponseConstructorFunctionErrorBody>(*state, "error");
}

static inline JSC::EncodedJSValue jsFetchResponseConstructorFunctionRedirectBody(JSC::ExecState* state, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto* context = jsCast<JSDOMGlobalObject*>(state->lexicalGlobalObject())->scriptExecutionContext();
    if (UNLIKELY(!context))
        return JSValue::encode(jsUndefined());
    auto url = convert<IDLUSVString>(*state, state->uncheckedArgument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto status = state->argument(1).isUndefined() ? 302 : convert<IDLUnsignedShort>(*state, state->uncheckedArgument(1));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    return JSValue::encode(toJSNewlyCreated<IDLInterface<FetchResponse>>(*state, *jsCast<JSDOMGlobalObject*>(state->lexicalGlobalObject()), throwScope, FetchResponse::redirect(*context, WTFMove(url), WTFMove(status))));
}

EncodedJSValue JSC_HOST_CALL jsFetchResponseConstructorFunctionRedirect(ExecState* state)
{
    return IDLOperation<JSFetchResponse>::callStatic<jsFetchResponseConstructorFunctionRedirectBody>(*state, "redirect");
}

static inline JSC::EncodedJSValue jsFetchResponsePrototypeFunctionCloneForJSBody(JSC::ExecState* state, typename IDLOperation<JSFetchResponse>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    return JSValue::encode(toJSNewlyCreated<IDLInterface<FetchResponse>>(*state, *castedThis->globalObject(), impl.cloneForJS()));
}

EncodedJSValue JSC_HOST_CALL jsFetchResponsePrototypeFunctionCloneForJS(ExecState* state)
{
    return IDLOperation<JSFetchResponse>::call<jsFetchResponsePrototypeFunctionCloneForJSBody, CastedThisErrorBehavior::Assert>(*state, "cloneForJS");
}

#if ENABLE(STREAMS_API)
static inline JSC::EncodedJSValue jsFetchResponsePrototypeFunctionStartConsumingStreamBody(JSC::ExecState* state, typename IDLOperation<JSFetchResponse>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto type = convert<IDLUnsignedShort>(*state, state->uncheckedArgument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    impl.startConsumingStream(WTFMove(type));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsFetchResponsePrototypeFunctionStartConsumingStream(ExecState* state)
{
    return IDLOperation<JSFetchResponse>::call<jsFetchResponsePrototypeFunctionStartConsumingStreamBody, CastedThisErrorBehavior::Assert>(*state, "startConsumingStream");
}

#endif

#if ENABLE(STREAMS_API)
static inline JSC::EncodedJSValue jsFetchResponsePrototypeFunctionConsumeChunkBody(JSC::ExecState* state, typename IDLOperation<JSFetchResponse>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto chunk = convert<IDLUint8Array>(*state, state->uncheckedArgument(0), [](JSC::ExecState& state, JSC::ThrowScope& scope) { throwArgumentTypeError(state, scope, 0, "chunk", "Response", "consumeChunk", "Uint8Array"); });
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    impl.consumeChunk(chunk.releaseNonNull());
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsFetchResponsePrototypeFunctionConsumeChunk(ExecState* state)
{
    return IDLOperation<JSFetchResponse>::call<jsFetchResponsePrototypeFunctionConsumeChunkBody, CastedThisErrorBehavior::Assert>(*state, "consumeChunk");
}

#endif

#if ENABLE(STREAMS_API)
static inline JSC::EncodedJSValue jsFetchResponsePrototypeFunctionFinishConsumingStreamBody(JSC::ExecState* state, typename IDLOperationReturningPromise<JSFetchResponse>::ClassParameter castedThis, Ref<DeferredPromise>&& promise, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    impl.finishConsumingStream(WTFMove(promise));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsFetchResponsePrototypeFunctionFinishConsumingStream(ExecState* state)
{
    return IDLOperationReturningPromise<JSFetchResponse>::call<jsFetchResponsePrototypeFunctionFinishConsumingStreamBody, PromiseExecutionScope::WindowOrWorker, CastedThisErrorBehavior::Assert>(*state, "finishConsumingStream");
}

#endif

static inline JSC::EncodedJSValue jsFetchResponsePrototypeFunctionConsumeBody(JSC::ExecState* state, typename IDLOperationReturningPromise<JSFetchResponse>::ClassParameter castedThis, Ref<DeferredPromise>&& promise, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto type = convert<IDLUnsignedShort>(*state, state->uncheckedArgument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    impl.consume(WTFMove(type), WTFMove(promise));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsFetchResponsePrototypeFunctionConsume(ExecState* state)
{
    return IDLOperationReturningPromise<JSFetchResponse>::call<jsFetchResponsePrototypeFunctionConsumeBody, PromiseExecutionScope::WindowOrWorker, CastedThisErrorBehavior::Assert>(*state, "consume");
}

static inline JSC::EncodedJSValue jsFetchResponsePrototypeFunctionIsLoadingBody(JSC::ExecState* state, typename IDLOperation<JSFetchResponse>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    return JSValue::encode(toJS<IDLBoolean>(impl.isLoading()));
}

EncodedJSValue JSC_HOST_CALL jsFetchResponsePrototypeFunctionIsLoading(ExecState* state)
{
    return IDLOperation<JSFetchResponse>::call<jsFetchResponsePrototypeFunctionIsLoadingBody, CastedThisErrorBehavior::Assert>(*state, "isLoading");
}

static inline JSC::EncodedJSValue jsFetchResponsePrototypeFunctionSetStatusBody(JSC::ExecState* state, typename IDLOperation<JSFetchResponse>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 2))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto status = convert<IDLUnsignedShort>(*state, state->uncheckedArgument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto statusText = convert<IDLDOMString>(*state, state->uncheckedArgument(1));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    propagateException(*state, throwScope, impl.setStatus(WTFMove(status), WTFMove(statusText)));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsFetchResponsePrototypeFunctionSetStatus(ExecState* state)
{
    return IDLOperation<JSFetchResponse>::call<jsFetchResponsePrototypeFunctionSetStatusBody, CastedThisErrorBehavior::Assert>(*state, "setStatus");
}

static inline JSC::EncodedJSValue jsFetchResponsePrototypeFunctionInitializeWithBody(JSC::ExecState* state, typename IDLOperation<JSFetchResponse>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto body = convert<IDLUnion<IDLInterface<Blob>, IDLArrayBufferView, IDLArrayBuffer, IDLInterface<DOMFormData>, IDLInterface<URLSearchParams>, IDLUSVString>>(*state, state->uncheckedArgument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    impl.initializeWith(WTFMove(body));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsFetchResponsePrototypeFunctionInitializeWith(ExecState* state)
{
    return IDLOperation<JSFetchResponse>::call<jsFetchResponsePrototypeFunctionInitializeWithBody, CastedThisErrorBehavior::Assert>(*state, "initializeWith");
}

static inline JSC::EncodedJSValue jsFetchResponsePrototypeFunctionCreateReadableStreamSourceBody(JSC::ExecState* state, typename IDLOperation<JSFetchResponse>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    return JSValue::encode(toJSNewlyCreated<IDLInterface<ReadableStreamSource>>(*state, *castedThis->globalObject(), impl.createReadableStreamSource()));
}

EncodedJSValue JSC_HOST_CALL jsFetchResponsePrototypeFunctionCreateReadableStreamSource(ExecState* state)
{
    return IDLOperation<JSFetchResponse>::call<jsFetchResponsePrototypeFunctionCreateReadableStreamSourceBody, CastedThisErrorBehavior::Assert>(*state, "createReadableStreamSource");
}

static inline JSC::EncodedJSValue jsFetchResponsePrototypeFunctionIsDisturbedBody(JSC::ExecState* state, typename IDLOperation<JSFetchResponse>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    return JSValue::encode(toJS<IDLBoolean>(impl.isDisturbed()));
}

EncodedJSValue JSC_HOST_CALL jsFetchResponsePrototypeFunctionIsDisturbed(ExecState* state)
{
    return IDLOperation<JSFetchResponse>::call<jsFetchResponsePrototypeFunctionIsDisturbedBody, CastedThisErrorBehavior::Assert>(*state, "isDisturbed");
}

static inline JSC::EncodedJSValue jsFetchResponsePrototypeFunctionSetBodyAsReadableStreamBody(JSC::ExecState* state, typename IDLOperation<JSFetchResponse>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    impl.setBodyAsReadableStream();
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsFetchResponsePrototypeFunctionSetBodyAsReadableStream(ExecState* state)
{
    return IDLOperation<JSFetchResponse>::call<jsFetchResponsePrototypeFunctionSetBodyAsReadableStreamBody, CastedThisErrorBehavior::Assert>(*state, "setBodyAsReadableStream");
}

bool JSFetchResponseOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    auto* jsFetchResponse = jsCast<JSFetchResponse*>(handle.slot()->asCell());
    if (jsFetchResponse->wrapped().hasPendingActivity())
        return true;
    UNUSED_PARAM(visitor);
    return false;
}

void JSFetchResponseOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsFetchResponse = static_cast<JSFetchResponse*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsFetchResponse->wrapped(), jsFetchResponse);
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7FetchResponse@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore13FetchResponseE[]; }
#endif
#endif

JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject* globalObject, Ref<FetchResponse>&& impl)
{

#if ENABLE(BINDING_INTEGRITY)
    void* actualVTablePointer = *(reinterpret_cast<void**>(impl.ptr()));
#if PLATFORM(WIN)
    void* expectedVTablePointer = reinterpret_cast<void*>(__identifier("??_7FetchResponse@WebCore@@6B@"));
#else
    void* expectedVTablePointer = &_ZTVN7WebCore13FetchResponseE[2];
#endif

    // If this fails FetchResponse does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    static_assert(std::is_polymorphic<FetchResponse>::value, "FetchResponse is not polymorphic");

    // If you hit this assertion you either have a use after free bug, or
    // FetchResponse has subclasses. If FetchResponse has subclasses that get passed
    // to toJS() we currently require FetchResponse you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    return createWrapper<FetchResponse>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, FetchResponse& impl)
{
    return wrap(state, globalObject, impl);
}

FetchResponse* JSFetchResponse::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicDowncast<JSFetchResponse*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
