/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#pragma once

#include "FetchResponse.h"
#include "JSDOMConvertDictionary.h"
#include "JSDOMConvertEnumeration.h"
#include "JSDOMWrapper.h"
#include <wtf/NeverDestroyed.h>

namespace WebCore {

class JSFetchResponse : public JSDOMWrapper<FetchResponse> {
public:
    using Base = JSDOMWrapper<FetchResponse>;
    static JSFetchResponse* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, Ref<FetchResponse>&& impl)
    {
        JSFetchResponse* ptr = new (NotNull, JSC::allocateCell<JSFetchResponse>(globalObject->vm().heap)) JSFetchResponse(structure, *globalObject, WTFMove(impl));
        ptr->finishCreation(globalObject->vm());
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSDOMGlobalObject&);
    static JSC::JSObject* prototype(JSC::VM&, JSDOMGlobalObject&);
    static FetchResponse* toWrapped(JSC::VM&, JSC::JSValue);
    static void destroy(JSC::JSCell*);

    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

    static JSC::JSValue getConstructor(JSC::VM&, const JSC::JSGlobalObject*);
protected:
    JSFetchResponse(JSC::Structure*, JSDOMGlobalObject&, Ref<FetchResponse>&&);

    void finishCreation(JSC::VM&);
};

class JSFetchResponseOwner : public JSC::WeakHandleOwner {
public:
    virtual bool isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown>, void* context, JSC::SlotVisitor&);
    virtual void finalize(JSC::Handle<JSC::Unknown>, void* context);
};

inline JSC::WeakHandleOwner* wrapperOwner(DOMWrapperWorld&, FetchResponse*)
{
    static NeverDestroyed<JSFetchResponseOwner> owner;
    return &owner.get();
}

inline void* wrapperKey(FetchResponse* wrappableObject)
{
    return wrappableObject;
}

JSC::JSValue toJS(JSC::ExecState*, JSDOMGlobalObject*, FetchResponse&);
inline JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, FetchResponse* impl) { return impl ? toJS(state, globalObject, *impl) : JSC::jsNull(); }
JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject*, Ref<FetchResponse>&&);
inline JSC::JSValue toJSNewlyCreated(JSC::ExecState* state, JSDOMGlobalObject* globalObject, RefPtr<FetchResponse>&& impl) { return impl ? toJSNewlyCreated(state, globalObject, impl.releaseNonNull()) : JSC::jsNull(); }

template<> struct JSDOMWrapperConverterTraits<FetchResponse> {
    using WrapperClass = JSFetchResponse;
    using ToWrappedReturnType = FetchResponse*;
};
template<> JSC::JSString* convertEnumerationToJS(JSC::ExecState&, FetchResponse::Type);

template<> std::optional<FetchResponse::Type> parseEnumeration<FetchResponse::Type>(JSC::ExecState&, JSC::JSValue);
template<> const char* expectedEnumerationValues<FetchResponse::Type>();

template<> FetchResponse::Init convertDictionary<FetchResponse::Init>(JSC::ExecState&, JSC::JSValue);


} // namespace WebCore
