/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(SUBTLE_CRYPTO)

#include "JSHkdfParams.h"

#include "JSDOMConvertAny.h"
#include "JSDOMConvertBufferSource.h"
#include "JSDOMConvertStrings.h"
#include "JSDOMConvertUnion.h"
#include <runtime/JSCInlines.h>
#include <wtf/Variant.h>

using namespace JSC;

namespace WebCore {

#if ENABLE(SUBTLE_CRYPTO)

template<> CryptoAlgorithmHkdfParams convertDictionary<CryptoAlgorithmHkdfParams>(ExecState& state, JSValue value)
{
    VM& vm = state.vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&state, throwScope);
        return { };
    }
    CryptoAlgorithmHkdfParams result;
    JSValue nameValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "name"));
    if (!nameValue.isUndefined()) {
        result.name = convert<IDLDOMString>(state, nameValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "name", "HkdfParams", "DOMString");
        return { };
    }
    JSValue hashValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "hash"));
    if (!hashValue.isUndefined()) {
        result.hash = convert<IDLAny>(state, hashValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "hash", "HkdfParams", "any");
        return { };
    }
    JSValue infoValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "info"));
    if (!infoValue.isUndefined()) {
        result.info = convert<IDLUnion<IDLArrayBufferView, IDLArrayBuffer>>(state, infoValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "info", "HkdfParams", "(ArrayBufferView or ArrayBuffer)");
        return { };
    }
    JSValue saltValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "salt"));
    if (!saltValue.isUndefined()) {
        result.salt = convert<IDLUnion<IDLArrayBufferView, IDLArrayBuffer>>(state, saltValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "salt", "HkdfParams", "(ArrayBufferView or ArrayBuffer)");
        return { };
    }
    return result;
}

#endif

} // namespace WebCore

#endif // ENABLE(SUBTLE_CRYPTO)
