/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#pragma once

#if ENABLE(NOTIFICATIONS)

#include "JSDOMConvertDictionary.h"
#include "JSDOMConvertEnumeration.h"
#include "JSEventTarget.h"
#include "Notification.h"
#include <wtf/NeverDestroyed.h>

namespace WebCore {

class WEBCORE_EXPORT JSNotification : public JSEventTarget {
public:
    using Base = JSEventTarget;
    using DOMWrapped = Notification;
    static JSNotification* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, Ref<Notification>&& impl)
    {
        JSNotification* ptr = new (NotNull, JSC::allocateCell<JSNotification>(globalObject->vm().heap)) JSNotification(structure, *globalObject, WTFMove(impl));
        ptr->finishCreation(globalObject->vm());
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSDOMGlobalObject&);
    static JSC::JSObject* prototype(JSC::VM&, JSDOMGlobalObject&);
    static Notification* toWrapped(JSC::VM&, JSC::JSValue);

    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

    static JSC::JSValue getConstructor(JSC::VM&, const JSC::JSGlobalObject*);
    Notification& wrapped() const
    {
        return static_cast<Notification&>(Base::wrapped());
    }
protected:
    JSNotification(JSC::Structure*, JSDOMGlobalObject&, Ref<Notification>&&);

    void finishCreation(JSC::VM&);
};

class JSNotificationOwner : public JSC::WeakHandleOwner {
public:
    virtual bool isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown>, void* context, JSC::SlotVisitor&);
    virtual void finalize(JSC::Handle<JSC::Unknown>, void* context);
};

inline JSC::WeakHandleOwner* wrapperOwner(DOMWrapperWorld&, Notification*)
{
    static NeverDestroyed<JSNotificationOwner> owner;
    return &owner.get();
}

inline void* wrapperKey(Notification* wrappableObject)
{
    return wrappableObject;
}

WEBCORE_EXPORT JSC::JSValue toJS(JSC::ExecState*, JSDOMGlobalObject*, Notification&);
inline JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, Notification* impl) { return impl ? toJS(state, globalObject, *impl) : JSC::jsNull(); }
JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject*, Ref<Notification>&&);
inline JSC::JSValue toJSNewlyCreated(JSC::ExecState* state, JSDOMGlobalObject* globalObject, RefPtr<Notification>&& impl) { return impl ? toJSNewlyCreated(state, globalObject, impl.releaseNonNull()) : JSC::jsNull(); }

template<> struct JSDOMWrapperConverterTraits<Notification> {
    using WrapperClass = JSNotification;
    using ToWrappedReturnType = Notification*;
};
#if ENABLE(NOTIFICATIONS)

template<> JSC::JSString* convertEnumerationToJS(JSC::ExecState&, Notification::Direction);

template<> std::optional<Notification::Direction> parseEnumeration<Notification::Direction>(JSC::ExecState&, JSC::JSValue);
template<> const char* expectedEnumerationValues<Notification::Direction>();

#endif

#if ENABLE(NOTIFICATIONS)

template<> Notification::Options convertDictionary<Notification::Options>(JSC::ExecState&, JSC::JSValue);

#endif


} // namespace WebCore

#endif // ENABLE(NOTIFICATIONS)
