/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(NOTIFICATIONS)

#include "JSNotificationPermission.h"

#include <runtime/JSCInlines.h>
#include <runtime/JSString.h>
#include <wtf/NeverDestroyed.h>

using namespace JSC;

namespace WebCore {

template<> JSString* convertEnumerationToJS(ExecState& state, NotificationPermission enumerationValue)
{
    static const NeverDestroyed<String> values[] = {
        MAKE_STATIC_STRING_IMPL("default"),
        MAKE_STATIC_STRING_IMPL("denied"),
        MAKE_STATIC_STRING_IMPL("granted"),
    };
    static_assert(static_cast<size_t>(NotificationPermission::Default) == 0, "NotificationPermission::Default is not 0 as expected");
    static_assert(static_cast<size_t>(NotificationPermission::Denied) == 1, "NotificationPermission::Denied is not 1 as expected");
    static_assert(static_cast<size_t>(NotificationPermission::Granted) == 2, "NotificationPermission::Granted is not 2 as expected");
    ASSERT(static_cast<size_t>(enumerationValue) < WTF_ARRAY_LENGTH(values));
    return jsStringWithCache(&state, values[static_cast<size_t>(enumerationValue)]);
}

template<> std::optional<NotificationPermission> parseEnumeration<NotificationPermission>(ExecState& state, JSValue value)
{
    auto stringValue = value.toWTFString(&state);
    if (stringValue == "default")
        return NotificationPermission::Default;
    if (stringValue == "denied")
        return NotificationPermission::Denied;
    if (stringValue == "granted")
        return NotificationPermission::Granted;
    return std::nullopt;
}

template<> const char* expectedEnumerationValues<NotificationPermission>()
{
    return "\"default\", \"denied\", \"granted\"";
}

} // namespace WebCore

#endif // ENABLE(NOTIFICATIONS)
