/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSPasswordCredential.h"

#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructor.h"
#include "JSDOMConvertDictionary.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMConvertStrings.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMWrapperCache.h"
#include "JSHTMLFormElement.h"
#include "JSPasswordCredentialData.h"
#include "RuntimeEnabledFeatures.h"
#include "ScriptExecutionContext.h"
#include <runtime/JSCInlines.h>
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

// Attributes

JSC::EncodedJSValue jsPasswordCredentialConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSPasswordCredentialConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);
JSC::EncodedJSValue jsPasswordCredentialPassword(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsPasswordCredentialName(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsPasswordCredentialIconURL(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);

class JSPasswordCredentialPrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSPasswordCredentialPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSPasswordCredentialPrototype* ptr = new (NotNull, JSC::allocateCell<JSPasswordCredentialPrototype>(vm.heap)) JSPasswordCredentialPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSPasswordCredentialPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSPasswordCredentialConstructor = JSDOMConstructor<JSPasswordCredential>;

static inline EncodedJSValue constructJSPasswordCredential1(ExecState* state)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    auto* castedThis = jsCast<JSPasswordCredentialConstructor*>(state->jsCallee());
    ASSERT(castedThis);
    auto data = convert<IDLDictionary<PasswordCredentialData>>(*state, state->uncheckedArgument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto object = PasswordCredential::create(WTFMove(data));
    return JSValue::encode(toJSNewlyCreated<IDLInterface<PasswordCredential>>(*state, *castedThis->globalObject(), WTFMove(object)));
}

static inline EncodedJSValue constructJSPasswordCredential2(ExecState* state)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    auto* castedThis = jsCast<JSPasswordCredentialConstructor*>(state->jsCallee());
    ASSERT(castedThis);
    auto form = convert<IDLInterface<HTMLFormElement>>(*state, state->uncheckedArgument(0), [](JSC::ExecState& state, JSC::ThrowScope& scope) { throwArgumentTypeError(state, scope, 0, "form", "PasswordCredential", nullptr, "HTMLFormElement"); });
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto object = PasswordCredential::create(*form);
    return JSValue::encode(toJSNewlyCreated<IDLInterface<PasswordCredential>>(*state, *castedThis->globalObject(), WTFMove(object)));
}

template<> EncodedJSValue JSC_HOST_CALL JSPasswordCredentialConstructor::construct(ExecState* state)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    size_t argsCount = std::min<size_t>(1, state->argumentCount());
    if (argsCount == 1) {
        JSValue distinguishingArg = state->uncheckedArgument(0);
        if (distinguishingArg.isUndefinedOrNull())
            return constructJSPasswordCredential1(state);
        if (distinguishingArg.isObject() && asObject(distinguishingArg)->inherits(vm, JSHTMLFormElement::info()))
            return constructJSPasswordCredential2(state);
        if (distinguishingArg.isObject())
            return constructJSPasswordCredential1(state);
    }
    return argsCount < 1 ? throwVMError(state, throwScope, createNotEnoughArgumentsError(state)) : throwVMTypeError(state, throwScope);
}

template<> JSValue JSPasswordCredentialConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    return JSBasicCredential::getConstructor(vm, &globalObject);
}

template<> void JSPasswordCredentialConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSPasswordCredential::prototype(vm, globalObject), DontDelete | ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String(ASCIILiteral("PasswordCredential"))), ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(1), ReadOnly | DontEnum);
}

template<> const ClassInfo JSPasswordCredentialConstructor::s_info = { "PasswordCredential", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSPasswordCredentialConstructor) };

/* Hash table for prototype */

static const HashTableValue JSPasswordCredentialPrototypeTableValues[] =
{
    { "constructor", DontEnum, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPasswordCredentialConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSPasswordCredentialConstructor) } },
    { "password", ReadOnly | CustomAccessor | DOMAttribute, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPasswordCredentialPassword), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "name", ReadOnly | CustomAccessor | DOMAttribute, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPasswordCredentialName), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "iconURL", ReadOnly | CustomAccessor | DOMAttribute, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPasswordCredentialIconURL), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
};

const ClassInfo JSPasswordCredentialPrototype::s_info = { "PasswordCredentialPrototype", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSPasswordCredentialPrototype) };

void JSPasswordCredentialPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSPasswordCredential::info(), JSPasswordCredentialPrototypeTableValues, *this);
    if (!RuntimeEnabledFeatures::sharedFeatures().credentialManagementEnabled()) {
        auto propertyName = Identifier::fromString(&vm, reinterpret_cast<const LChar*>("name"), strlen("name"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        JSObject::deleteProperty(this, globalObject()->globalExec(), propertyName);
    }
    if (!RuntimeEnabledFeatures::sharedFeatures().credentialManagementEnabled()) {
        auto propertyName = Identifier::fromString(&vm, reinterpret_cast<const LChar*>("iconURL"), strlen("iconURL"));
        VM::DeletePropertyModeScope scope(vm, VM::DeletePropertyMode::IgnoreConfigurable);
        JSObject::deleteProperty(this, globalObject()->globalExec(), propertyName);
    }
}

const ClassInfo JSPasswordCredential::s_info = { "PasswordCredential", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSPasswordCredential) };

JSPasswordCredential::JSPasswordCredential(Structure* structure, JSDOMGlobalObject& globalObject, Ref<PasswordCredential>&& impl)
    : JSBasicCredential(structure, globalObject, WTFMove(impl))
{
}

void JSPasswordCredential::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSPasswordCredential::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSPasswordCredentialPrototype::create(vm, &globalObject, JSPasswordCredentialPrototype::createStructure(vm, &globalObject, JSBasicCredential::prototype(vm, globalObject)));
}

JSObject* JSPasswordCredential::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSPasswordCredential>(vm, globalObject);
}

JSValue JSPasswordCredential::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSPasswordCredentialConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

template<> inline JSPasswordCredential* IDLAttribute<JSPasswordCredential>::cast(ExecState& state, EncodedJSValue thisValue)
{
    return jsDynamicDowncast<JSPasswordCredential*>(state.vm(), JSValue::decode(thisValue));
}

EncodedJSValue jsPasswordCredentialConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicDowncast<JSPasswordCredentialPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSPasswordCredential::getConstructor(state->vm(), prototype->globalObject()));
}

bool setJSPasswordCredentialConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicDowncast<JSPasswordCredentialPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return prototype->putDirect(state->vm(), state->propertyNames().constructor, JSValue::decode(encodedValue));
}

static inline JSValue jsPasswordCredentialPasswordGetter(ExecState& state, JSPasswordCredential& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUSVString>(state, impl.password());
    return result;
}

EncodedJSValue jsPasswordCredentialPassword(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSPasswordCredential>::get<jsPasswordCredentialPasswordGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "password");
}

static inline JSValue jsPasswordCredentialNameGetter(ExecState& state, JSPasswordCredential& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUSVString>(state, impl.name());
    return result;
}

EncodedJSValue jsPasswordCredentialName(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSPasswordCredential>::get<jsPasswordCredentialNameGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "name");
}

static inline JSValue jsPasswordCredentialIconURLGetter(ExecState& state, JSPasswordCredential& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUSVString>(state, impl.iconURL());
    return result;
}

EncodedJSValue jsPasswordCredentialIconURL(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSPasswordCredential>::get<jsPasswordCredentialIconURLGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "iconURL");
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7PasswordCredential@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore18PasswordCredentialE[]; }
#endif
#endif

JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject* globalObject, Ref<PasswordCredential>&& impl)
{

#if ENABLE(BINDING_INTEGRITY)
    void* actualVTablePointer = *(reinterpret_cast<void**>(impl.ptr()));
#if PLATFORM(WIN)
    void* expectedVTablePointer = reinterpret_cast<void*>(__identifier("??_7PasswordCredential@WebCore@@6B@"));
#else
    void* expectedVTablePointer = &_ZTVN7WebCore18PasswordCredentialE[2];
#endif

    // If this fails PasswordCredential does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    static_assert(std::is_polymorphic<PasswordCredential>::value, "PasswordCredential is not polymorphic");

    // If you hit this assertion you either have a use after free bug, or
    // PasswordCredential has subclasses. If PasswordCredential has subclasses that get passed
    // to toJS() we currently require PasswordCredential you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    return createWrapper<PasswordCredential>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, PasswordCredential& impl)
{
    return wrap(state, globalObject, impl);
}


}
