/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSPasswordCredentialData.h"

#include "JSDOMConvertStrings.h"
#include <runtime/JSCInlines.h>

using namespace JSC;

namespace WebCore {

template<> PasswordCredentialData convertDictionary<PasswordCredentialData>(ExecState& state, JSValue value)
{
    VM& vm = state.vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&state, throwScope);
        return { };
    }
    PasswordCredentialData result;
    JSValue idValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "id"));
    if (!idValue.isUndefined()) {
        result.id = convert<IDLUSVString>(state, idValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "id", "PasswordCredentialData", "USVString");
        return { };
    }
    JSValue iconURLValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "iconURL"));
    if (!iconURLValue.isUndefined()) {
        result.iconURL = convert<IDLUSVString>(state, iconURLValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue nameValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "name"));
    if (!nameValue.isUndefined()) {
        result.name = convert<IDLUSVString>(state, nameValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue passwordValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "password"));
    if (!passwordValue.isUndefined()) {
        result.password = convert<IDLUSVString>(state, passwordValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "password", "PasswordCredentialData", "USVString");
        return { };
    }
    return result;
}

} // namespace WebCore
