/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSPerformanceObserverEntryList.h"

#include "JSDOMBinding.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMConvertSequences.h"
#include "JSDOMConvertStrings.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObject.h"
#include "JSDOMOperation.h"
#include "JSDOMWrapperCache.h"
#include "JSPerformanceEntry.h"
#include <runtime/FunctionPrototype.h>
#include <runtime/JSArray.h>
#include <runtime/JSCInlines.h>
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

// Functions

JSC::EncodedJSValue JSC_HOST_CALL jsPerformanceObserverEntryListPrototypeFunctionGetEntries(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsPerformanceObserverEntryListPrototypeFunctionGetEntriesByType(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsPerformanceObserverEntryListPrototypeFunctionGetEntriesByName(JSC::ExecState*);

// Attributes

JSC::EncodedJSValue jsPerformanceObserverEntryListConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSPerformanceObserverEntryListConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);

class JSPerformanceObserverEntryListPrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSPerformanceObserverEntryListPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSPerformanceObserverEntryListPrototype* ptr = new (NotNull, JSC::allocateCell<JSPerformanceObserverEntryListPrototype>(vm.heap)) JSPerformanceObserverEntryListPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSPerformanceObserverEntryListPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSPerformanceObserverEntryListConstructor = JSDOMConstructorNotConstructable<JSPerformanceObserverEntryList>;

template<> JSValue JSPerformanceObserverEntryListConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSPerformanceObserverEntryListConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSPerformanceObserverEntryList::prototype(vm, globalObject), DontDelete | ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String(ASCIILiteral("PerformanceObserverEntryList"))), ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), ReadOnly | DontEnum);
}

template<> const ClassInfo JSPerformanceObserverEntryListConstructor::s_info = { "PerformanceObserverEntryList", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSPerformanceObserverEntryListConstructor) };

/* Hash table for prototype */

static const HashTableValue JSPerformanceObserverEntryListPrototypeTableValues[] =
{
    { "constructor", DontEnum, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPerformanceObserverEntryListConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSPerformanceObserverEntryListConstructor) } },
    { "getEntries", JSC::Function, NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsPerformanceObserverEntryListPrototypeFunctionGetEntries), (intptr_t) (0) } },
    { "getEntriesByType", JSC::Function, NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsPerformanceObserverEntryListPrototypeFunctionGetEntriesByType), (intptr_t) (1) } },
    { "getEntriesByName", JSC::Function, NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsPerformanceObserverEntryListPrototypeFunctionGetEntriesByName), (intptr_t) (1) } },
};

const ClassInfo JSPerformanceObserverEntryListPrototype::s_info = { "PerformanceObserverEntryListPrototype", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSPerformanceObserverEntryListPrototype) };

void JSPerformanceObserverEntryListPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSPerformanceObserverEntryList::info(), JSPerformanceObserverEntryListPrototypeTableValues, *this);
}

const ClassInfo JSPerformanceObserverEntryList::s_info = { "PerformanceObserverEntryList", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSPerformanceObserverEntryList) };

JSPerformanceObserverEntryList::JSPerformanceObserverEntryList(Structure* structure, JSDOMGlobalObject& globalObject, Ref<PerformanceObserverEntryList>&& impl)
    : JSDOMWrapper<PerformanceObserverEntryList>(structure, globalObject, WTFMove(impl))
{
}

void JSPerformanceObserverEntryList::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSPerformanceObserverEntryList::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSPerformanceObserverEntryListPrototype::create(vm, &globalObject, JSPerformanceObserverEntryListPrototype::createStructure(vm, &globalObject, globalObject.objectPrototype()));
}

JSObject* JSPerformanceObserverEntryList::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSPerformanceObserverEntryList>(vm, globalObject);
}

JSValue JSPerformanceObserverEntryList::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSPerformanceObserverEntryListConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

void JSPerformanceObserverEntryList::destroy(JSC::JSCell* cell)
{
    JSPerformanceObserverEntryList* thisObject = static_cast<JSPerformanceObserverEntryList*>(cell);
    thisObject->JSPerformanceObserverEntryList::~JSPerformanceObserverEntryList();
}

template<> inline JSPerformanceObserverEntryList* IDLOperation<JSPerformanceObserverEntryList>::cast(ExecState& state)
{
    return jsDynamicDowncast<JSPerformanceObserverEntryList*>(state.vm(), state.thisValue());
}

EncodedJSValue jsPerformanceObserverEntryListConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicDowncast<JSPerformanceObserverEntryListPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSPerformanceObserverEntryList::getConstructor(state->vm(), prototype->globalObject()));
}

bool setJSPerformanceObserverEntryListConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicDowncast<JSPerformanceObserverEntryListPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return prototype->putDirect(state->vm(), state->propertyNames().constructor, JSValue::decode(encodedValue));
}

static inline JSC::EncodedJSValue jsPerformanceObserverEntryListPrototypeFunctionGetEntriesBody(JSC::ExecState* state, typename IDLOperation<JSPerformanceObserverEntryList>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    return JSValue::encode(toJS<IDLSequence<IDLInterface<PerformanceEntry>>>(*state, *castedThis->globalObject(), impl.getEntries()));
}

EncodedJSValue JSC_HOST_CALL jsPerformanceObserverEntryListPrototypeFunctionGetEntries(ExecState* state)
{
    return IDLOperation<JSPerformanceObserverEntryList>::call<jsPerformanceObserverEntryListPrototypeFunctionGetEntriesBody>(*state, "getEntries");
}

static inline JSC::EncodedJSValue jsPerformanceObserverEntryListPrototypeFunctionGetEntriesByTypeBody(JSC::ExecState* state, typename IDLOperation<JSPerformanceObserverEntryList>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto type = convert<IDLDOMString>(*state, state->uncheckedArgument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    return JSValue::encode(toJS<IDLSequence<IDLInterface<PerformanceEntry>>>(*state, *castedThis->globalObject(), impl.getEntriesByType(WTFMove(type))));
}

EncodedJSValue JSC_HOST_CALL jsPerformanceObserverEntryListPrototypeFunctionGetEntriesByType(ExecState* state)
{
    return IDLOperation<JSPerformanceObserverEntryList>::call<jsPerformanceObserverEntryListPrototypeFunctionGetEntriesByTypeBody>(*state, "getEntriesByType");
}

static inline JSC::EncodedJSValue jsPerformanceObserverEntryListPrototypeFunctionGetEntriesByNameBody(JSC::ExecState* state, typename IDLOperation<JSPerformanceObserverEntryList>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto name = convert<IDLDOMString>(*state, state->uncheckedArgument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto type = state->argument(1).isUndefined() ? String() : convert<IDLDOMString>(*state, state->uncheckedArgument(1));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    return JSValue::encode(toJS<IDLSequence<IDLInterface<PerformanceEntry>>>(*state, *castedThis->globalObject(), impl.getEntriesByName(WTFMove(name), WTFMove(type))));
}

EncodedJSValue JSC_HOST_CALL jsPerformanceObserverEntryListPrototypeFunctionGetEntriesByName(ExecState* state)
{
    return IDLOperation<JSPerformanceObserverEntryList>::call<jsPerformanceObserverEntryListPrototypeFunctionGetEntriesByNameBody>(*state, "getEntriesByName");
}

bool JSPerformanceObserverEntryListOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSPerformanceObserverEntryListOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsPerformanceObserverEntryList = static_cast<JSPerformanceObserverEntryList*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsPerformanceObserverEntryList->wrapped(), jsPerformanceObserverEntryList);
}

JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject* globalObject, Ref<PerformanceObserverEntryList>&& impl)
{
    // If you hit this failure the interface definition has the ImplementationLacksVTable
    // attribute. You should remove that attribute. If the class has subclasses
    // that may be passed through this toJS() function you should use the SkipVTableValidation
    // attribute to PerformanceObserverEntryList.
    static_assert(!std::is_polymorphic<PerformanceObserverEntryList>::value, "PerformanceObserverEntryList is polymorphic but the IDL claims it is not");
    return createWrapper<PerformanceObserverEntryList>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, PerformanceObserverEntryList& impl)
{
    return wrap(state, globalObject, impl);
}

PerformanceObserverEntryList* JSPerformanceObserverEntryList::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicDowncast<JSPerformanceObserverEntryList*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
