/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSTextMetrics.h"

#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvertNumbers.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMWrapperCache.h"
#include <runtime/FunctionPrototype.h>
#include <runtime/JSCInlines.h>
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

// Attributes

JSC::EncodedJSValue jsTextMetricsConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSTextMetricsConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);
JSC::EncodedJSValue jsTextMetricsWidth(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsTextMetricsActualBoundingBoxLeft(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsTextMetricsActualBoundingBoxRight(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsTextMetricsFontBoundingBoxAscent(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsTextMetricsFontBoundingBoxDescent(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsTextMetricsActualBoundingBoxAscent(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsTextMetricsActualBoundingBoxDescent(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsTextMetricsEmHeightAscent(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsTextMetricsEmHeightDescent(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsTextMetricsHangingBaseline(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsTextMetricsAlphabeticBaseline(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsTextMetricsIdeographicBaseline(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);

class JSTextMetricsPrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSTextMetricsPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSTextMetricsPrototype* ptr = new (NotNull, JSC::allocateCell<JSTextMetricsPrototype>(vm.heap)) JSTextMetricsPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSTextMetricsPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSTextMetricsConstructor = JSDOMConstructorNotConstructable<JSTextMetrics>;

template<> JSValue JSTextMetricsConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSTextMetricsConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSTextMetrics::prototype(vm, globalObject), DontDelete | ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String(ASCIILiteral("TextMetrics"))), ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), ReadOnly | DontEnum);
}

template<> const ClassInfo JSTextMetricsConstructor::s_info = { "TextMetrics", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSTextMetricsConstructor) };

/* Hash table for prototype */

static const HashTableValue JSTextMetricsPrototypeTableValues[] =
{
    { "constructor", DontEnum, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsTextMetricsConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSTextMetricsConstructor) } },
    { "width", ReadOnly | CustomAccessor | DOMAttribute, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsTextMetricsWidth), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "actualBoundingBoxLeft", ReadOnly | CustomAccessor | DOMAttribute, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsTextMetricsActualBoundingBoxLeft), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "actualBoundingBoxRight", ReadOnly | CustomAccessor | DOMAttribute, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsTextMetricsActualBoundingBoxRight), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "fontBoundingBoxAscent", ReadOnly | CustomAccessor | DOMAttribute, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsTextMetricsFontBoundingBoxAscent), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "fontBoundingBoxDescent", ReadOnly | CustomAccessor | DOMAttribute, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsTextMetricsFontBoundingBoxDescent), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "actualBoundingBoxAscent", ReadOnly | CustomAccessor | DOMAttribute, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsTextMetricsActualBoundingBoxAscent), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "actualBoundingBoxDescent", ReadOnly | CustomAccessor | DOMAttribute, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsTextMetricsActualBoundingBoxDescent), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "emHeightAscent", ReadOnly | CustomAccessor | DOMAttribute, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsTextMetricsEmHeightAscent), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "emHeightDescent", ReadOnly | CustomAccessor | DOMAttribute, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsTextMetricsEmHeightDescent), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "hangingBaseline", ReadOnly | CustomAccessor | DOMAttribute, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsTextMetricsHangingBaseline), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "alphabeticBaseline", ReadOnly | CustomAccessor | DOMAttribute, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsTextMetricsAlphabeticBaseline), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "ideographicBaseline", ReadOnly | CustomAccessor | DOMAttribute, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsTextMetricsIdeographicBaseline), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
};

const ClassInfo JSTextMetricsPrototype::s_info = { "TextMetricsPrototype", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSTextMetricsPrototype) };

void JSTextMetricsPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSTextMetrics::info(), JSTextMetricsPrototypeTableValues, *this);
}

const ClassInfo JSTextMetrics::s_info = { "TextMetrics", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSTextMetrics) };

JSTextMetrics::JSTextMetrics(Structure* structure, JSDOMGlobalObject& globalObject, Ref<TextMetrics>&& impl)
    : JSDOMWrapper<TextMetrics>(structure, globalObject, WTFMove(impl))
{
}

void JSTextMetrics::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSTextMetrics::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSTextMetricsPrototype::create(vm, &globalObject, JSTextMetricsPrototype::createStructure(vm, &globalObject, globalObject.objectPrototype()));
}

JSObject* JSTextMetrics::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSTextMetrics>(vm, globalObject);
}

JSValue JSTextMetrics::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSTextMetricsConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

void JSTextMetrics::destroy(JSC::JSCell* cell)
{
    JSTextMetrics* thisObject = static_cast<JSTextMetrics*>(cell);
    thisObject->JSTextMetrics::~JSTextMetrics();
}

template<> inline JSTextMetrics* IDLAttribute<JSTextMetrics>::cast(ExecState& state, EncodedJSValue thisValue)
{
    return jsDynamicDowncast<JSTextMetrics*>(state.vm(), JSValue::decode(thisValue));
}

EncodedJSValue jsTextMetricsConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicDowncast<JSTextMetricsPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSTextMetrics::getConstructor(state->vm(), prototype->globalObject()));
}

bool setJSTextMetricsConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicDowncast<JSTextMetricsPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return prototype->putDirect(state->vm(), state->propertyNames().constructor, JSValue::decode(encodedValue));
}

static inline JSValue jsTextMetricsWidthGetter(ExecState& state, JSTextMetrics& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnrestrictedFloat>(impl.width());
    return result;
}

EncodedJSValue jsTextMetricsWidth(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSTextMetrics>::get<jsTextMetricsWidthGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "width");
}

static inline JSValue jsTextMetricsActualBoundingBoxLeftGetter(ExecState& state, JSTextMetrics& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnrestrictedFloat>(impl.actualBoundingBoxLeft());
    return result;
}

EncodedJSValue jsTextMetricsActualBoundingBoxLeft(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSTextMetrics>::get<jsTextMetricsActualBoundingBoxLeftGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "actualBoundingBoxLeft");
}

static inline JSValue jsTextMetricsActualBoundingBoxRightGetter(ExecState& state, JSTextMetrics& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnrestrictedFloat>(impl.actualBoundingBoxRight());
    return result;
}

EncodedJSValue jsTextMetricsActualBoundingBoxRight(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSTextMetrics>::get<jsTextMetricsActualBoundingBoxRightGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "actualBoundingBoxRight");
}

static inline JSValue jsTextMetricsFontBoundingBoxAscentGetter(ExecState& state, JSTextMetrics& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnrestrictedFloat>(impl.fontBoundingBoxAscent());
    return result;
}

EncodedJSValue jsTextMetricsFontBoundingBoxAscent(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSTextMetrics>::get<jsTextMetricsFontBoundingBoxAscentGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "fontBoundingBoxAscent");
}

static inline JSValue jsTextMetricsFontBoundingBoxDescentGetter(ExecState& state, JSTextMetrics& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnrestrictedFloat>(impl.fontBoundingBoxDescent());
    return result;
}

EncodedJSValue jsTextMetricsFontBoundingBoxDescent(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSTextMetrics>::get<jsTextMetricsFontBoundingBoxDescentGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "fontBoundingBoxDescent");
}

static inline JSValue jsTextMetricsActualBoundingBoxAscentGetter(ExecState& state, JSTextMetrics& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnrestrictedFloat>(impl.actualBoundingBoxAscent());
    return result;
}

EncodedJSValue jsTextMetricsActualBoundingBoxAscent(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSTextMetrics>::get<jsTextMetricsActualBoundingBoxAscentGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "actualBoundingBoxAscent");
}

static inline JSValue jsTextMetricsActualBoundingBoxDescentGetter(ExecState& state, JSTextMetrics& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnrestrictedFloat>(impl.actualBoundingBoxDescent());
    return result;
}

EncodedJSValue jsTextMetricsActualBoundingBoxDescent(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSTextMetrics>::get<jsTextMetricsActualBoundingBoxDescentGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "actualBoundingBoxDescent");
}

static inline JSValue jsTextMetricsEmHeightAscentGetter(ExecState& state, JSTextMetrics& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnrestrictedFloat>(impl.emHeightAscent());
    return result;
}

EncodedJSValue jsTextMetricsEmHeightAscent(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSTextMetrics>::get<jsTextMetricsEmHeightAscentGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "emHeightAscent");
}

static inline JSValue jsTextMetricsEmHeightDescentGetter(ExecState& state, JSTextMetrics& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnrestrictedFloat>(impl.emHeightDescent());
    return result;
}

EncodedJSValue jsTextMetricsEmHeightDescent(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSTextMetrics>::get<jsTextMetricsEmHeightDescentGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "emHeightDescent");
}

static inline JSValue jsTextMetricsHangingBaselineGetter(ExecState& state, JSTextMetrics& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnrestrictedFloat>(impl.hangingBaseline());
    return result;
}

EncodedJSValue jsTextMetricsHangingBaseline(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSTextMetrics>::get<jsTextMetricsHangingBaselineGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "hangingBaseline");
}

static inline JSValue jsTextMetricsAlphabeticBaselineGetter(ExecState& state, JSTextMetrics& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnrestrictedFloat>(impl.alphabeticBaseline());
    return result;
}

EncodedJSValue jsTextMetricsAlphabeticBaseline(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSTextMetrics>::get<jsTextMetricsAlphabeticBaselineGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "alphabeticBaseline");
}

static inline JSValue jsTextMetricsIdeographicBaselineGetter(ExecState& state, JSTextMetrics& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnrestrictedFloat>(impl.ideographicBaseline());
    return result;
}

EncodedJSValue jsTextMetricsIdeographicBaseline(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSTextMetrics>::get<jsTextMetricsIdeographicBaselineGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "ideographicBaseline");
}

bool JSTextMetricsOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSTextMetricsOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsTextMetrics = static_cast<JSTextMetrics*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsTextMetrics->wrapped(), jsTextMetrics);
}

JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject* globalObject, Ref<TextMetrics>&& impl)
{
    // If you hit this failure the interface definition has the ImplementationLacksVTable
    // attribute. You should remove that attribute. If the class has subclasses
    // that may be passed through this toJS() function you should use the SkipVTableValidation
    // attribute to TextMetrics.
    static_assert(!std::is_polymorphic<TextMetrics>::value, "TextMetrics is polymorphic but the IDL claims it is not");
    return createWrapper<TextMetrics>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, TextMetrics& impl)
{
    return wrap(state, globalObject, impl);
}

TextMetrics* JSTextMetrics::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicDowncast<JSTextMetrics*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
