/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#pragma once

#if ENABLE(VIDEO_TRACK)

#include "JSDOMConvertEnumeration.h"
#include "JSEventTarget.h"
#include "TextTrack.h"
#include <wtf/NeverDestroyed.h>

namespace WebCore {

class JSTextTrack : public JSEventTarget {
public:
    using Base = JSEventTarget;
    using DOMWrapped = TextTrack;
    static JSTextTrack* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, Ref<TextTrack>&& impl)
    {
        JSTextTrack* ptr = new (NotNull, JSC::allocateCell<JSTextTrack>(globalObject->vm().heap)) JSTextTrack(structure, *globalObject, WTFMove(impl));
        ptr->finishCreation(globalObject->vm());
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSDOMGlobalObject&);
    static JSC::JSObject* prototype(JSC::VM&, JSDOMGlobalObject&);
    static TextTrack* toWrapped(JSC::VM&, JSC::JSValue);

    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

    static JSC::JSValue getConstructor(JSC::VM&, const JSC::JSGlobalObject*);
    static void visitChildren(JSCell*, JSC::SlotVisitor&);
    void visitAdditionalChildren(JSC::SlotVisitor&);

    static void visitOutputConstraints(JSCell*, JSC::SlotVisitor&);
    template<typename> static JSC::Subspace* subspaceFor(JSC::VM& vm) { return outputConstraintSubspaceFor(vm); }
    TextTrack& wrapped() const
    {
        return static_cast<TextTrack&>(Base::wrapped());
    }
protected:
    JSTextTrack(JSC::Structure*, JSDOMGlobalObject&, Ref<TextTrack>&&);

    void finishCreation(JSC::VM&);
};

class JSTextTrackOwner : public JSC::WeakHandleOwner {
public:
    virtual bool isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown>, void* context, JSC::SlotVisitor&);
    virtual void finalize(JSC::Handle<JSC::Unknown>, void* context);
};

inline JSC::WeakHandleOwner* wrapperOwner(DOMWrapperWorld&, TextTrack*)
{
    static NeverDestroyed<JSTextTrackOwner> owner;
    return &owner.get();
}

inline void* wrapperKey(TextTrack* wrappableObject)
{
    return wrappableObject;
}

JSC::JSValue toJS(JSC::ExecState*, JSDOMGlobalObject*, TextTrack&);
inline JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, TextTrack* impl) { return impl ? toJS(state, globalObject, *impl) : JSC::jsNull(); }
JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject*, Ref<TextTrack>&&);
inline JSC::JSValue toJSNewlyCreated(JSC::ExecState* state, JSDOMGlobalObject* globalObject, RefPtr<TextTrack>&& impl) { return impl ? toJSNewlyCreated(state, globalObject, impl.releaseNonNull()) : JSC::jsNull(); }

template<> struct JSDOMWrapperConverterTraits<TextTrack> {
    using WrapperClass = JSTextTrack;
    using ToWrappedReturnType = TextTrack*;
};
template<> JSC::JSString* convertEnumerationToJS(JSC::ExecState&, TextTrack::Mode);

template<> std::optional<TextTrack::Mode> parseEnumeration<TextTrack::Mode>(JSC::ExecState&, JSC::JSValue);
template<> const char* expectedEnumerationValues<TextTrack::Mode>();

template<> JSC::JSString* convertEnumerationToJS(JSC::ExecState&, TextTrack::Kind);

template<> std::optional<TextTrack::Kind> parseEnumeration<TextTrack::Kind>(JSC::ExecState&, JSC::JSValue);
template<> const char* expectedEnumerationValues<TextTrack::Kind>();


} // namespace WebCore

#endif // ENABLE(VIDEO_TRACK)
