/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(USER_MESSAGE_HANDLERS)

#include "JSUserMessageHandler.h"

#include "JSDOMBinding.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvertSerializedScriptValue.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMOperation.h"
#include "JSDOMWrapperCache.h"
#include "SerializedScriptValue.h"
#include <runtime/FunctionPrototype.h>
#include <runtime/JSCInlines.h>
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

// Functions

JSC::EncodedJSValue JSC_HOST_CALL jsUserMessageHandlerPrototypeFunctionPostMessage(JSC::ExecState*);

// Attributes

JSC::EncodedJSValue jsUserMessageHandlerConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSUserMessageHandlerConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);

class JSUserMessageHandlerPrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSUserMessageHandlerPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSUserMessageHandlerPrototype* ptr = new (NotNull, JSC::allocateCell<JSUserMessageHandlerPrototype>(vm.heap)) JSUserMessageHandlerPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSUserMessageHandlerPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSUserMessageHandlerConstructor = JSDOMConstructorNotConstructable<JSUserMessageHandler>;

template<> JSValue JSUserMessageHandlerConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSUserMessageHandlerConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSUserMessageHandler::prototype(vm, globalObject), DontDelete | ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String(ASCIILiteral("UserMessageHandler"))), ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), ReadOnly | DontEnum);
}

template<> const ClassInfo JSUserMessageHandlerConstructor::s_info = { "UserMessageHandler", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSUserMessageHandlerConstructor) };

/* Hash table for prototype */

static const HashTableValue JSUserMessageHandlerPrototypeTableValues[] =
{
    { "constructor", DontEnum, NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsUserMessageHandlerConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSUserMessageHandlerConstructor) } },
    { "postMessage", JSC::Function, NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsUserMessageHandlerPrototypeFunctionPostMessage), (intptr_t) (1) } },
};

const ClassInfo JSUserMessageHandlerPrototype::s_info = { "UserMessageHandlerPrototype", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSUserMessageHandlerPrototype) };

void JSUserMessageHandlerPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSUserMessageHandler::info(), JSUserMessageHandlerPrototypeTableValues, *this);
}

const ClassInfo JSUserMessageHandler::s_info = { "UserMessageHandler", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSUserMessageHandler) };

JSUserMessageHandler::JSUserMessageHandler(Structure* structure, JSDOMGlobalObject& globalObject, Ref<UserMessageHandler>&& impl)
    : JSDOMWrapper<UserMessageHandler>(structure, globalObject, WTFMove(impl))
{
}

void JSUserMessageHandler::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSUserMessageHandler::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSUserMessageHandlerPrototype::create(vm, &globalObject, JSUserMessageHandlerPrototype::createStructure(vm, &globalObject, globalObject.objectPrototype()));
}

JSObject* JSUserMessageHandler::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSUserMessageHandler>(vm, globalObject);
}

JSValue JSUserMessageHandler::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSUserMessageHandlerConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

void JSUserMessageHandler::destroy(JSC::JSCell* cell)
{
    JSUserMessageHandler* thisObject = static_cast<JSUserMessageHandler*>(cell);
    thisObject->JSUserMessageHandler::~JSUserMessageHandler();
}

template<> inline JSUserMessageHandler* IDLOperation<JSUserMessageHandler>::cast(ExecState& state)
{
    return jsDynamicDowncast<JSUserMessageHandler*>(state.vm(), state.thisValue());
}

EncodedJSValue jsUserMessageHandlerConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicDowncast<JSUserMessageHandlerPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSUserMessageHandler::getConstructor(state->vm(), prototype->globalObject()));
}

bool setJSUserMessageHandlerConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicDowncast<JSUserMessageHandlerPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return prototype->putDirect(state->vm(), state->propertyNames().constructor, JSValue::decode(encodedValue));
}

static inline JSC::EncodedJSValue jsUserMessageHandlerPrototypeFunctionPostMessageBody(JSC::ExecState* state, typename IDLOperation<JSUserMessageHandler>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    if (UNLIKELY(state->argumentCount() < 1))
        return throwVMError(state, throwScope, createNotEnoughArgumentsError(state));
    auto message = convert<IDLSerializedScriptValue<SerializedScriptValue>>(*state, state->uncheckedArgument(0));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    propagateException(*state, throwScope, impl.postMessage(WTFMove(message)));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsUserMessageHandlerPrototypeFunctionPostMessage(ExecState* state)
{
    return IDLOperation<JSUserMessageHandler>::call<jsUserMessageHandlerPrototypeFunctionPostMessageBody>(*state, "postMessage");
}

bool JSUserMessageHandlerOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSUserMessageHandlerOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsUserMessageHandler = static_cast<JSUserMessageHandler*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsUserMessageHandler->wrapped(), jsUserMessageHandler);
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7UserMessageHandler@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore18UserMessageHandlerE[]; }
#endif
#endif

JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject* globalObject, Ref<UserMessageHandler>&& impl)
{

#if ENABLE(BINDING_INTEGRITY)
    void* actualVTablePointer = *(reinterpret_cast<void**>(impl.ptr()));
#if PLATFORM(WIN)
    void* expectedVTablePointer = reinterpret_cast<void*>(__identifier("??_7UserMessageHandler@WebCore@@6B@"));
#else
    void* expectedVTablePointer = &_ZTVN7WebCore18UserMessageHandlerE[2];
#endif

    // If this fails UserMessageHandler does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    static_assert(std::is_polymorphic<UserMessageHandler>::value, "UserMessageHandler is not polymorphic");

    // If you hit this assertion you either have a use after free bug, or
    // UserMessageHandler has subclasses. If UserMessageHandler has subclasses that get passed
    // to toJS() we currently require UserMessageHandler you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    return createWrapper<UserMessageHandler>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, UserMessageHandler& impl)
{
    return wrap(state, globalObject, impl);
}

UserMessageHandler* JSUserMessageHandler::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicDowncast<JSUserMessageHandler*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}

#endif // ENABLE(USER_MESSAGE_HANDLERS)
