/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#pragma once

#if ENABLE(SUBTLE_CRYPTO)

#include "JSDOMWrapper.h"
#include "WebKitSubtleCrypto.h"
#include <wtf/NeverDestroyed.h>

namespace WebCore {

class JSWebKitSubtleCrypto : public JSDOMWrapper<WebKitSubtleCrypto> {
public:
    using Base = JSDOMWrapper<WebKitSubtleCrypto>;
    static JSWebKitSubtleCrypto* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, Ref<WebKitSubtleCrypto>&& impl)
    {
        JSWebKitSubtleCrypto* ptr = new (NotNull, JSC::allocateCell<JSWebKitSubtleCrypto>(globalObject->vm().heap)) JSWebKitSubtleCrypto(structure, *globalObject, WTFMove(impl));
        ptr->finishCreation(globalObject->vm());
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSDOMGlobalObject&);
    static JSC::JSObject* prototype(JSC::VM&, JSDOMGlobalObject&);
    static WebKitSubtleCrypto* toWrapped(JSC::VM&, JSC::JSValue);
    static void destroy(JSC::JSCell*);

    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }


    // Custom functions
    JSC::JSValue encrypt(JSC::ExecState&);
    JSC::JSValue decrypt(JSC::ExecState&);
    JSC::JSValue sign(JSC::ExecState&);
    JSC::JSValue verify(JSC::ExecState&);
    JSC::JSValue digest(JSC::ExecState&);
    JSC::JSValue generateKey(JSC::ExecState&);
    JSC::JSValue importKey(JSC::ExecState&);
    JSC::JSValue exportKey(JSC::ExecState&);
    JSC::JSValue wrapKey(JSC::ExecState&);
    JSC::JSValue unwrapKey(JSC::ExecState&);
protected:
    JSWebKitSubtleCrypto(JSC::Structure*, JSDOMGlobalObject&, Ref<WebKitSubtleCrypto>&&);

    void finishCreation(JSC::VM&);
};

class JSWebKitSubtleCryptoOwner : public JSC::WeakHandleOwner {
public:
    virtual bool isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown>, void* context, JSC::SlotVisitor&);
    virtual void finalize(JSC::Handle<JSC::Unknown>, void* context);
};

inline JSC::WeakHandleOwner* wrapperOwner(DOMWrapperWorld&, WebKitSubtleCrypto*)
{
    static NeverDestroyed<JSWebKitSubtleCryptoOwner> owner;
    return &owner.get();
}

inline void* wrapperKey(WebKitSubtleCrypto* wrappableObject)
{
    return wrappableObject;
}

JSC::JSValue toJS(JSC::ExecState*, JSDOMGlobalObject*, WebKitSubtleCrypto&);
inline JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, WebKitSubtleCrypto* impl) { return impl ? toJS(state, globalObject, *impl) : JSC::jsNull(); }
JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject*, Ref<WebKitSubtleCrypto>&&);
inline JSC::JSValue toJSNewlyCreated(JSC::ExecState* state, JSDOMGlobalObject* globalObject, RefPtr<WebKitSubtleCrypto>&& impl) { return impl ? toJSNewlyCreated(state, globalObject, impl.releaseNonNull()) : JSC::jsNull(); }

template<> struct JSDOMWrapperConverterTraits<WebKitSubtleCrypto> {
    using WrapperClass = JSWebKitSubtleCrypto;
    using ToWrappedReturnType = WebKitSubtleCrypto*;
};

} // namespace WebCore

#endif // ENABLE(SUBTLE_CRYPTO)
