/*
 * Copyright (c) 2016 Apple Inc. All rights reserved.
 * Copyright (c) 2016 Canon Inc.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY APPLE INC. AND ITS CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL APPLE INC. OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 * 
 */

// DO NOT EDIT THIS FILE. It is automatically generated from JavaScript files for
// builtins by the script: Source/JavaScriptCore/Scripts/generate-js-builtins.py

#include "config.h"
#include "ReadableByteStreamControllerBuiltins.h"

#if ENABLE(STREAMS_API)

#include "WebCoreJSClientData.h"
#include <heap/HeapInlines.h>
#include <runtime/Intrinsic.h>
#include <runtime/JSCJSValueInlines.h>
#include <runtime/JSCellInlines.h>
#include <runtime/StructureInlines.h>
#include <runtime/VM.h>

namespace WebCore {

const JSC::ConstructAbility s_readableByteStreamControllerEnqueueCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const int s_readableByteStreamControllerEnqueueCodeLength = 658;
static const JSC::Intrinsic s_readableByteStreamControllerEnqueueCodeIntrinsic = JSC::NoIntrinsic;
const char* s_readableByteStreamControllerEnqueueCode =
    "(function (chunk)\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "    if (!@isReadableByteStreamController(this))\n" \
    "        throw @makeThisTypeError(\"ReadableByteStreamController\", \"enqueue\");\n" \
    "    if (this.@closeRequested)\n" \
    "        @throwTypeError(\"ReadableByteStreamController is requested to close\");\n" \
    "    if (this.@controlledReadableStream.@state !== @streamReadable)\n" \
    "        @throwTypeError(\"ReadableStream is not readable\");\n" \
    "    if (!@isObject(chunk))\n" \
    "        @throwTypeError(\"Provided chunk is not an object\");\n" \
    "    if (!@ArrayBuffer.@isView(chunk))\n" \
    "        @throwTypeError(\"Provided chunk is not an ArrayBuffer view\");\n" \
    "    return @readableByteStreamControllerEnqueue(this, chunk);\n" \
    "})\n" \
;

const JSC::ConstructAbility s_readableByteStreamControllerErrorCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const int s_readableByteStreamControllerErrorCodeLength = 343;
static const JSC::Intrinsic s_readableByteStreamControllerErrorCodeIntrinsic = JSC::NoIntrinsic;
const char* s_readableByteStreamControllerErrorCode =
    "(function (error)\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "    if (!@isReadableByteStreamController(this))\n" \
    "        throw @makeThisTypeError(\"ReadableByteStreamController\", \"error\");\n" \
    "    if (this.@controlledReadableStream.@state !== @streamReadable)\n" \
    "        @throwTypeError(\"ReadableStream is not readable\");\n" \
    "    @readableByteStreamControllerError(this, error);\n" \
    "})\n" \
;

const JSC::ConstructAbility s_readableByteStreamControllerCloseCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const int s_readableByteStreamControllerCloseCodeLength = 422;
static const JSC::Intrinsic s_readableByteStreamControllerCloseCodeIntrinsic = JSC::NoIntrinsic;
const char* s_readableByteStreamControllerCloseCode =
    "(function ()\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "    if (!@isReadableByteStreamController(this))\n" \
    "        throw @makeThisTypeError(\"ReadableByteStreamController\", \"close\");\n" \
    "    if (this.@closeRequested)\n" \
    "        @throwTypeError(\"Close has already been requested\");\n" \
    "    if (this.@controlledReadableStream.@state !== @streamReadable)\n" \
    "        @throwTypeError(\"ReadableStream is not readable\");\n" \
    "    @readableByteStreamControllerClose(this);\n" \
    "})\n" \
;

const JSC::ConstructAbility s_readableByteStreamControllerByobRequestCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const int s_readableByteStreamControllerByobRequestCodeLength = 613;
static const JSC::Intrinsic s_readableByteStreamControllerByobRequestCodeIntrinsic = JSC::NoIntrinsic;
const char* s_readableByteStreamControllerByobRequestCode =
    "(function ()\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "    if (!@isReadableByteStreamController(this))\n" \
    "        throw @makeGetterTypeError(\"ReadableByteStreamController\", \"byobRequest\");\n" \
    "    if (this.@byobRequest === @undefined && this.@pendingPullIntos.length) {\n" \
    "        const firstDescriptor = this.@pendingPullIntos[0];\n" \
    "        const view = new @Uint8Array(firstDescriptor.buffer,\n" \
    "            firstDescriptor.byteOffset + firstDescriptor.bytesFilled,\n" \
    "            firstDescriptor.byteLength - firstDescriptor.bytesFilled);\n" \
    "        this.@byobRequest = new @ReadableStreamBYOBRequest(this, view);\n" \
    "    }\n" \
    "    return this.@byobRequest;\n" \
    "})\n" \
;

const JSC::ConstructAbility s_readableByteStreamControllerDesiredSizeCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const int s_readableByteStreamControllerDesiredSizeCodeLength = 229;
static const JSC::Intrinsic s_readableByteStreamControllerDesiredSizeCodeIntrinsic = JSC::NoIntrinsic;
const char* s_readableByteStreamControllerDesiredSizeCode =
    "(function ()\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "    if (!@isReadableByteStreamController(this))\n" \
    "        throw @makeGetterTypeError(\"ReadableByteStreamController\", \"desiredSize\");\n" \
    "    return @readableByteStreamControllerGetDesiredSize(this);\n" \
    "})\n" \
;


#define DEFINE_BUILTIN_GENERATOR(codeName, functionName, argumentCount) \
JSC::FunctionExecutable* codeName##Generator(JSC::VM& vm) \
{\
    JSVMClientData* clientData = static_cast<JSVMClientData*>(vm.clientData); \
    return clientData->builtinFunctions().readableByteStreamControllerBuiltins().codeName##Executable()->link(vm, clientData->builtinFunctions().readableByteStreamControllerBuiltins().codeName##Source(), std::nullopt, s_##codeName##Intrinsic); \
}
WEBCORE_FOREACH_READABLEBYTESTREAMCONTROLLER_BUILTIN_CODE(DEFINE_BUILTIN_GENERATOR)
#undef DEFINE_BUILTIN_GENERATOR


} // namespace WebCore

#endif // ENABLE(STREAMS_API)
