/*
 * Copyright (c) 2016 Apple Inc. All rights reserved.
 * Copyright (c) 2016 Canon Inc. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY APPLE INC. AND ITS CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL APPLE INC. OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 * 
 */

// DO NOT EDIT THIS FILE. It is automatically generated from JavaScript files for
// builtins by the script: Source/JavaScriptCore/Scripts/generate-js-builtins.py

#include "config.h"
#include "ReadableByteStreamInternalsBuiltins.h"

#if ENABLE(STREAMS_API)

#include "WebCoreJSClientData.h"
#include <heap/HeapInlines.h>
#include <runtime/Intrinsic.h>
#include <runtime/JSCJSValueInlines.h>
#include <runtime/JSCellInlines.h>
#include <runtime/StructureInlines.h>
#include <runtime/VM.h>

namespace WebCore {

const JSC::ConstructAbility s_readableByteStreamInternalsPrivateInitializeReadableStreamBYOBReaderCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const int s_readableByteStreamInternalsPrivateInitializeReadableStreamBYOBReaderCodeLength = 522;
static const JSC::Intrinsic s_readableByteStreamInternalsPrivateInitializeReadableStreamBYOBReaderCodeIntrinsic = JSC::NoIntrinsic;
const char* s_readableByteStreamInternalsPrivateInitializeReadableStreamBYOBReaderCode =
    "(function (stream)\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "    if (!@isReadableStream(stream))\n" \
    "        @throwTypeError(\"ReadableStreamBYOBReader needs a ReadableStream\");\n" \
    "    if (!@isReadableByteStreamController(stream.@readableStreamController))\n" \
    "        @throwTypeError(\"ReadableStreamBYOBReader needs a ReadableByteStreamController\");\n" \
    "    if (@isReadableStreamLocked(stream))\n" \
    "        @throwTypeError(\"ReadableStream is locked\");\n" \
    "    @readableStreamReaderGenericInitialize(this, stream);\n" \
    "    this.@readIntoRequests = [];\n" \
    "    return this;\n" \
    "})\n" \
;

const JSC::ConstructAbility s_readableByteStreamInternalsPrivateInitializeReadableByteStreamControllerCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const int s_readableByteStreamInternalsPrivateInitializeReadableByteStreamControllerCodeLength = 1960;
static const JSC::Intrinsic s_readableByteStreamInternalsPrivateInitializeReadableByteStreamControllerCodeIntrinsic = JSC::NoIntrinsic;
const char* s_readableByteStreamInternalsPrivateInitializeReadableByteStreamControllerCode =
    "(function (stream, underlyingByteSource, highWaterMark)\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "    if (!@isReadableStream(stream))\n" \
    "        @throwTypeError(\"ReadableByteStreamController needs a ReadableStream\");\n" \
    "    if (stream.@readableStreamController !== null)\n" \
    "        @throwTypeError(\"ReadableStream already has a controller\");\n" \
    "    this.@controlledReadableStream = stream;\n" \
    "    this.@underlyingByteSource = underlyingByteSource;\n" \
    "    this.@pullAgain = false;\n" \
    "    this.@pulling = false;\n" \
    "    @readableByteStreamControllerClearPendingPullIntos(this);\n" \
    "    this.@queue = [];\n" \
    "    this.@totalQueuedBytes = 0;\n" \
    "    this.@started = false;\n" \
    "    this.@closeRequested = false;\n" \
    "    let hwm = @toNumber(highWaterMark);\n" \
    "    if (@isNaN(hwm) || hwm < 0)\n" \
    "        @throwRangeError(\"highWaterMark value is negative or not a number\");\n" \
    "    this.@strategyHWM = hwm;\n" \
    "    let autoAllocateChunkSize = underlyingByteSource.autoAllocateChunkSize;\n" \
    "    if (autoAllocateChunkSize !== @undefined) {\n" \
    "        autoAllocateChunkSize = @toNumber(autoAllocateChunkSize);\n" \
    "        if (autoAllocateChunkSize <= 0 || autoAllocateChunkSize === @Number.POSITIVE_INFINITY || autoAllocateChunkSize === @Number.NEGATIVE_INFINITY)\n" \
    "            @throwRangeError(\"autoAllocateChunkSize value is negative or equal to positive or negative infinity\");\n" \
    "    }\n" \
    "    this.@autoAllocateChunkSize = autoAllocateChunkSize;\n" \
    "    this.@pendingPullIntos = [];\n" \
    "    const controller = this;\n" \
    "    const startResult = @promiseInvokeOrNoopNoCatch(underlyingByteSource, \"start\", [this]).@then(() => {\n" \
    "        controller.@started = true;\n" \
    "        @assert(!controller.@pulling);\n" \
    "        @assert(!controller.@pullAgain);\n" \
    "        @readableByteStreamControllerCallPullIfNeeded(controller);\n" \
    "    }, (error) => {\n" \
    "        if (stream.@state === @streamReadable)\n" \
    "            @readableByteStreamControllerError(controller, error);\n" \
    "    });\n" \
    "    this.@cancel = @readableByteStreamControllerCancel;\n" \
    "    this.@pull = @readableByteStreamControllerPull;\n" \
    "    return this;\n" \
    "})\n" \
;

const JSC::ConstructAbility s_readableByteStreamInternalsPrivateInitializeReadableStreamBYOBRequestCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const int s_readableByteStreamInternalsPrivateInitializeReadableStreamBYOBRequestCodeLength = 138;
static const JSC::Intrinsic s_readableByteStreamInternalsPrivateInitializeReadableStreamBYOBRequestCodeIntrinsic = JSC::NoIntrinsic;
const char* s_readableByteStreamInternalsPrivateInitializeReadableStreamBYOBRequestCode =
    "(function (controller, view)\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "    this.@associatedReadableByteStreamController = controller;\n" \
    "    this.@view = view;\n" \
    "})\n" \
;

const JSC::ConstructAbility s_readableByteStreamInternalsIsReadableByteStreamControllerCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const int s_readableByteStreamInternalsIsReadableByteStreamControllerCodeLength = 118;
static const JSC::Intrinsic s_readableByteStreamInternalsIsReadableByteStreamControllerCodeIntrinsic = JSC::NoIntrinsic;
const char* s_readableByteStreamInternalsIsReadableByteStreamControllerCode =
    "(function (controller)\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "    return @isObject(controller) && !!controller.@underlyingByteSource;\n" \
    "})\n" \
;

const JSC::ConstructAbility s_readableByteStreamInternalsIsReadableStreamBYOBRequestCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const int s_readableByteStreamInternalsIsReadableStreamBYOBRequestCodeLength = 139;
static const JSC::Intrinsic s_readableByteStreamInternalsIsReadableStreamBYOBRequestCodeIntrinsic = JSC::NoIntrinsic;
const char* s_readableByteStreamInternalsIsReadableStreamBYOBRequestCode =
    "(function (byobRequest)\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "    return @isObject(byobRequest) && !!byobRequest.@associatedReadableByteStreamController;\n" \
    "})\n" \
;

const JSC::ConstructAbility s_readableByteStreamInternalsIsReadableStreamBYOBReaderCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const int s_readableByteStreamInternalsIsReadableStreamBYOBReaderCodeLength = 102;
static const JSC::Intrinsic s_readableByteStreamInternalsIsReadableStreamBYOBReaderCodeIntrinsic = JSC::NoIntrinsic;
const char* s_readableByteStreamInternalsIsReadableStreamBYOBReaderCode =
    "(function (reader)\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "    return @isObject(reader) && !!reader.@readIntoRequests;\n" \
    "})\n" \
;

const JSC::ConstructAbility s_readableByteStreamInternalsReadableByteStreamControllerCancelCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const int s_readableByteStreamInternalsReadableByteStreamControllerCancelCodeLength = 313;
static const JSC::Intrinsic s_readableByteStreamInternalsReadableByteStreamControllerCancelCodeIntrinsic = JSC::NoIntrinsic;
const char* s_readableByteStreamInternalsReadableByteStreamControllerCancelCode =
    "(function (controller, reason)\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "    if (controller.@pendingPullIntos.length > 0)\n" \
    "        controller.@pendingPullIntos[0].bytesFilled = 0;\n" \
    "    controller.@queue = [];\n" \
    "    controller.@totalQueuedBytes = 0;\n" \
    "    return @promiseInvokeOrNoop(controller.@underlyingByteSource, \"cancel\", [reason]);\n" \
    "})\n" \
;

const JSC::ConstructAbility s_readableByteStreamInternalsReadableByteStreamControllerErrorCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const int s_readableByteStreamInternalsReadableByteStreamControllerErrorCodeLength = 290;
static const JSC::Intrinsic s_readableByteStreamInternalsReadableByteStreamControllerErrorCodeIntrinsic = JSC::NoIntrinsic;
const char* s_readableByteStreamInternalsReadableByteStreamControllerErrorCode =
    "(function (controller, e)\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "    @assert(controller.@controlledReadableStream.@state === @streamReadable);\n" \
    "    @readableByteStreamControllerClearPendingPullIntos(controller);\n" \
    "    controller.@queue = [];\n" \
    "    @readableStreamError(controller.@controlledReadableStream, e);\n" \
    "})\n" \
;

const JSC::ConstructAbility s_readableByteStreamInternalsReadableByteStreamControllerCloseCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const int s_readableByteStreamInternalsReadableByteStreamControllerCloseCodeLength = 643;
static const JSC::Intrinsic s_readableByteStreamInternalsReadableByteStreamControllerCloseCodeIntrinsic = JSC::NoIntrinsic;
const char* s_readableByteStreamInternalsReadableByteStreamControllerCloseCode =
    "(function (controller)\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "    @assert(!controller.@closeRequested);\n" \
    "    @assert(controller.@controlledReadableStream.@state === @streamReadable);\n" \
    "    if (controller.@totalQueuedBytes > 0) {\n" \
    "        controller.@closeRequested = true;\n" \
    "        return;\n" \
    "    }\n" \
    "    if (controller.@pendingPullIntos.length > 0) {\n" \
    "        if (controller.@pendingPullIntos[0].bytesFilled > 0) {\n" \
    "            const e = new @TypeError(\"Close requested while there remain pending bytes\");\n" \
    "            @readableByteStreamControllerError(controller, e);\n" \
    "            throw e;\n" \
    "        }\n" \
    "    }\n" \
    "    @readableStreamClose(controller.@controlledReadableStream);\n" \
    "})\n" \
;

const JSC::ConstructAbility s_readableByteStreamInternalsReadableByteStreamControllerClearPendingPullIntosCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const int s_readableByteStreamInternalsReadableByteStreamControllerClearPendingPullIntosCodeLength = 153;
static const JSC::Intrinsic s_readableByteStreamInternalsReadableByteStreamControllerClearPendingPullIntosCodeIntrinsic = JSC::NoIntrinsic;
const char* s_readableByteStreamInternalsReadableByteStreamControllerClearPendingPullIntosCode =
    "(function (controller)\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "    @readableByteStreamControllerInvalidateBYOBRequest(controller);\n" \
    "    controller.@pendingPullIntos = [];\n" \
    "})\n" \
;

const JSC::ConstructAbility s_readableByteStreamInternalsReadableByteStreamControllerGetDesiredSizeCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const int s_readableByteStreamInternalsReadableByteStreamControllerGetDesiredSizeCodeLength = 285;
static const JSC::Intrinsic s_readableByteStreamInternalsReadableByteStreamControllerGetDesiredSizeCodeIntrinsic = JSC::NoIntrinsic;
const char* s_readableByteStreamInternalsReadableByteStreamControllerGetDesiredSizeCode =
    "(function (controller)\n" \
    "{\n" \
    "   \"use strict\";\n" \
    "   const stream = controller.@controlledReadableStream;\n" \
    "   if (stream.@state === @streamErrored)\n" \
    "       return null;\n" \
    "   if (stream.@state === @streamClosed)\n" \
    "       return 0;\n" \
    "   return controller.@strategyHWM - controller.@totalQueuedBytes;\n" \
    "})\n" \
;

const JSC::ConstructAbility s_readableByteStreamInternalsReadableStreamHasBYOBReaderCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const int s_readableByteStreamInternalsReadableStreamHasBYOBReaderCodeLength = 131;
static const JSC::Intrinsic s_readableByteStreamInternalsReadableStreamHasBYOBReaderCodeIntrinsic = JSC::NoIntrinsic;
const char* s_readableByteStreamInternalsReadableStreamHasBYOBReaderCode =
    "(function (stream)\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "    return stream.@reader !== @undefined && @isReadableStreamBYOBReader(stream.@reader);\n" \
    "})\n" \
;

const JSC::ConstructAbility s_readableByteStreamInternalsReadableStreamHasDefaultReaderCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const int s_readableByteStreamInternalsReadableStreamHasDefaultReaderCodeLength = 134;
static const JSC::Intrinsic s_readableByteStreamInternalsReadableStreamHasDefaultReaderCodeIntrinsic = JSC::NoIntrinsic;
const char* s_readableByteStreamInternalsReadableStreamHasDefaultReaderCode =
    "(function (stream)\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "    return stream.@reader !== @undefined && @isReadableStreamDefaultReader(stream.@reader);\n" \
    "})\n" \
;

const JSC::ConstructAbility s_readableByteStreamInternalsReadableByteStreamControllerHandleQueueDrainCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const int s_readableByteStreamInternalsReadableByteStreamControllerHandleQueueDrainCodeLength = 337;
static const JSC::Intrinsic s_readableByteStreamInternalsReadableByteStreamControllerHandleQueueDrainCodeIntrinsic = JSC::NoIntrinsic;
const char* s_readableByteStreamInternalsReadableByteStreamControllerHandleQueueDrainCode =
    "(function (controller) {\n" \
    "    \"use strict\";\n" \
    "    @assert(controller.@controlledReadableStream.@state === @streamReadable);\n" \
    "    if (!controller.@totalQueuedBytes && controller.@closeRequested)\n" \
    "        @readableStreamClose(controller.@controlledReadableStream);\n" \
    "    else\n" \
    "        @readableByteStreamControllerCallPullIfNeeded(controller);\n" \
    "})\n" \
;

const JSC::ConstructAbility s_readableByteStreamInternalsReadableByteStreamControllerPullCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const int s_readableByteStreamInternalsReadableByteStreamControllerPullCodeLength = 1437;
static const JSC::Intrinsic s_readableByteStreamInternalsReadableByteStreamControllerPullCodeIntrinsic = JSC::NoIntrinsic;
const char* s_readableByteStreamInternalsReadableByteStreamControllerPullCode =
    "(function (controller)\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "    const stream = controller.@controlledReadableStream;\n" \
    "    @assert(@readableStreamHasDefaultReader(stream));\n" \
    "    if (controller.@totalQueuedBytes > 0) {\n" \
    "        @assert(stream.@reader.@readRequests.length === 0);\n" \
    "        const entry = controller.@queue.@shift();\n" \
    "        controller.@totalQueuedBytes -= entry.byteLength;\n" \
    "        @readableByteStreamControllerHandleQueueDrain(controller);\n" \
    "        let view;\n" \
    "        try {\n" \
    "            view = new @Uint8Array(entry.buffer, entry.byteOffset, entry.byteLength);\n" \
    "        } catch (error) {\n" \
    "            return @Promise.@reject(error);\n" \
    "        }\n" \
    "        return @Promise.@resolve({value: view, done: false});\n" \
    "    }\n" \
    "    if (controller.@autoAllocateChunkSize !== @undefined) {\n" \
    "        let buffer;\n" \
    "        try {\n" \
    "            buffer = new @ArrayBuffer(controller.@autoAllocateChunkSize);\n" \
    "        } catch (error) {\n" \
    "            return @Promise.@reject(error);\n" \
    "        }\n" \
    "        const pullIntoDescriptor = {\n" \
    "            buffer,\n" \
    "            byteOffset: 0,\n" \
    "            byteLength: controller.@autoAllocateChunkSize,\n" \
    "            bytesFilled: 0,\n" \
    "            elementSize: 1,\n" \
    "            ctor: @Uint8Array,\n" \
    "            readerType: 'default'\n" \
    "        };\n" \
    "        controller.@pendingPullIntos.@push(pullIntoDescriptor);\n" \
    "    }\n" \
    "    const promise = @readableStreamAddReadRequest(stream);\n" \
    "    @readableByteStreamControllerCallPullIfNeeded(controller);\n" \
    "    return promise;\n" \
    "})\n" \
;

const JSC::ConstructAbility s_readableByteStreamInternalsReadableByteStreamControllerShouldCallPullCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const int s_readableByteStreamInternalsReadableByteStreamControllerShouldCallPullCodeLength = 613;
static const JSC::Intrinsic s_readableByteStreamInternalsReadableByteStreamControllerShouldCallPullCodeIntrinsic = JSC::NoIntrinsic;
const char* s_readableByteStreamInternalsReadableByteStreamControllerShouldCallPullCode =
    "(function (controller)\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "    const stream = controller.@controlledReadableStream;\n" \
    "    if (stream.@state !== @streamReadable)\n" \
    "        return false;\n" \
    "    if (controller.@closeRequested)\n" \
    "        return false;\n" \
    "    if (!controller.@started)\n" \
    "        return false;\n" \
    "    if (@readableStreamHasDefaultReader(stream) && stream.@reader.@readRequests.length > 0)\n" \
    "        return true;\n" \
    "    if (@readableStreamHasBYOBReader(stream) && stream.@reader.@readIntoRequests.length > 0)\n" \
    "        return true;\n" \
    "    if (@readableByteStreamControllerGetDesiredSize(controller) > 0)\n" \
    "        return true;\n" \
    "    return false;\n" \
    "})\n" \
;

const JSC::ConstructAbility s_readableByteStreamInternalsReadableByteStreamControllerCallPullIfNeededCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const int s_readableByteStreamInternalsReadableByteStreamControllerCallPullIfNeededCodeLength = 753;
static const JSC::Intrinsic s_readableByteStreamInternalsReadableByteStreamControllerCallPullIfNeededCodeIntrinsic = JSC::NoIntrinsic;
const char* s_readableByteStreamInternalsReadableByteStreamControllerCallPullIfNeededCode =
    "(function (controller)\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "    if (!@readableByteStreamControllerShouldCallPull(controller))\n" \
    "        return;\n" \
    "    if (controller.@pulling) {\n" \
    "        controller.@pullAgain = true;\n" \
    "        return;\n" \
    "    }\n" \
    "    @assert(!controller.@pullAgain);\n" \
    "    controller.@pulling = true;\n" \
    "    @promiseInvokeOrNoop(controller.@underlyingByteSource, \"pull\", [controller]).@then(() => {\n" \
    "        controller.@pulling = false;\n" \
    "        if (controller.@pullAgain) {\n" \
    "            controller.@pullAgain = false;\n" \
    "            @readableByteStreamControllerCallPullIfNeeded(controller);\n" \
    "        }\n" \
    "    }, (error) => {\n" \
    "        if (controller.@controlledReadableStream.@state === @streamReadable)\n" \
    "            @readableByteStreamControllerError(controller, error);\n" \
    "    });\n" \
    "})\n" \
;

const JSC::ConstructAbility s_readableByteStreamInternalsTransferBufferToCurrentRealmCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const int s_readableByteStreamInternalsTransferBufferToCurrentRealmCodeLength = 61;
static const JSC::Intrinsic s_readableByteStreamInternalsTransferBufferToCurrentRealmCodeIntrinsic = JSC::NoIntrinsic;
const char* s_readableByteStreamInternalsTransferBufferToCurrentRealmCode =
    "(function (buffer)\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "    return buffer;\n" \
    "})\n" \
;

const JSC::ConstructAbility s_readableByteStreamInternalsReadableByteStreamControllerEnqueueCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const int s_readableByteStreamInternalsReadableByteStreamControllerEnqueueCodeLength = 1261;
static const JSC::Intrinsic s_readableByteStreamInternalsReadableByteStreamControllerEnqueueCodeIntrinsic = JSC::NoIntrinsic;
const char* s_readableByteStreamInternalsReadableByteStreamControllerEnqueueCode =
    "(function (controller, chunk)\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "    const stream = controller.@controlledReadableStream;\n" \
    "    @assert(!controller.@closeRequested);\n" \
    "    @assert(stream.@state === @streamReadable);\n" \
    "    const buffer = chunk.buffer;\n" \
    "    const byteOffset = chunk.byteOffset;\n" \
    "    const byteLength = chunk.byteLength;\n" \
    "    const transferredBuffer = @transferBufferToCurrentRealm(buffer);\n" \
    "    if (@readableStreamHasDefaultReader(stream)) {\n" \
    "        if (!stream.@reader.@readRequests.length)\n" \
    "            @readableByteStreamControllerEnqueueChunk(controller, transferredBuffer, byteOffset, byteLength);\n" \
    "        else {\n" \
    "            @assert(!controller.@queue.length);\n" \
    "            let transferredView = new @Uint8Array(transferredBuffer, byteOffset, byteLength);\n" \
    "            @readableStreamFulfillReadRequest(stream, transferredView, false);\n" \
    "        }\n" \
    "        return;\n" \
    "    }\n" \
    "    if (@readableStreamHasBYOBReader(stream)) {\n" \
    "        @readableByteStreamControllerEnqueueChunk(controller, transferredBuffer, byteOffset, byteLength);\n" \
    "        @readableByteStreamControllerProcessPullDescriptors(controller);\n" \
    "        return;\n" \
    "    }\n" \
    "    @assert(!@isReadableStreamLocked(stream));\n" \
    "    @readableByteStreamControllerEnqueueChunk(controller, transferredBuffer, byteOffset, byteLength);\n" \
    "})\n" \
;

const JSC::ConstructAbility s_readableByteStreamInternalsReadableByteStreamControllerEnqueueChunkCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const int s_readableByteStreamInternalsReadableByteStreamControllerEnqueueChunkCodeLength = 251;
static const JSC::Intrinsic s_readableByteStreamInternalsReadableByteStreamControllerEnqueueChunkCodeIntrinsic = JSC::NoIntrinsic;
const char* s_readableByteStreamInternalsReadableByteStreamControllerEnqueueChunkCode =
    "(function (controller, buffer, byteOffset, byteLength)\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "    controller.@queue.@push({\n" \
    "        buffer: buffer,\n" \
    "        byteOffset: byteOffset,\n" \
    "        byteLength: byteLength\n" \
    "    });\n" \
    "    controller.@totalQueuedBytes += byteLength;\n" \
    "})\n" \
;

const JSC::ConstructAbility s_readableByteStreamInternalsReadableByteStreamControllerRespondWithNewViewCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const int s_readableByteStreamInternalsReadableByteStreamControllerRespondWithNewViewCodeLength = 554;
static const JSC::Intrinsic s_readableByteStreamInternalsReadableByteStreamControllerRespondWithNewViewCodeIntrinsic = JSC::NoIntrinsic;
const char* s_readableByteStreamInternalsReadableByteStreamControllerRespondWithNewViewCode =
    "(function (controller, view)\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "    @assert(controller.@pendingPullIntos.length > 0);\n" \
    "    let firstDescriptor = controller.@pendingPullIntos[0];\n" \
    "    if (firstDescriptor.byteOffset + firstDescriptor.bytesFilled !== view.byteOffset)\n" \
    "        @throwRangeError(\"Invalid value for view.byteOffset\");\n" \
    "    if (firstDescriptor.byteLength !== view.byteLength)\n" \
    "        @throwRangeError(\"Invalid value for view.byteLength\");\n" \
    "    firstDescriptor.buffer = view.buffer;\n" \
    "    @readableByteStreamControllerRespondInternal(controller, view.byteLength);\n" \
    "})\n" \
;

const JSC::ConstructAbility s_readableByteStreamInternalsReadableByteStreamControllerRespondCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const int s_readableByteStreamInternalsReadableByteStreamControllerRespondCodeLength = 396;
static const JSC::Intrinsic s_readableByteStreamInternalsReadableByteStreamControllerRespondCodeIntrinsic = JSC::NoIntrinsic;
const char* s_readableByteStreamInternalsReadableByteStreamControllerRespondCode =
    "(function (controller, bytesWritten)\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "    bytesWritten = @toNumber(bytesWritten);\n" \
    "    if (@isNaN(bytesWritten) || bytesWritten === @Number.POSITIVE_INFINITY || bytesWritten < 0 )\n" \
    "        @throwRangeError(\"bytesWritten has an incorrect value\");\n" \
    "    @assert(controller.@pendingPullIntos.length > 0);\n" \
    "    @readableByteStreamControllerRespondInternal(controller, bytesWritten);\n" \
    "})\n" \
;

const JSC::ConstructAbility s_readableByteStreamInternalsReadableByteStreamControllerRespondInternalCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const int s_readableByteStreamInternalsReadableByteStreamControllerRespondInternalCodeLength = 606;
static const JSC::Intrinsic s_readableByteStreamInternalsReadableByteStreamControllerRespondInternalCodeIntrinsic = JSC::NoIntrinsic;
const char* s_readableByteStreamInternalsReadableByteStreamControllerRespondInternalCode =
    "(function (controller, bytesWritten)\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "    let firstDescriptor = controller.@pendingPullIntos[0];\n" \
    "    let stream = controller.@controlledReadableStream;\n" \
    "    if (stream.@state === @streamClosed) {\n" \
    "        if (bytesWritten !== 0)\n" \
    "            @throwTypeError(\"bytesWritten is different from 0 even though stream is closed\");\n" \
    "        @readableByteStreamControllerRespondInClosedState(controller, firstDescriptor);\n" \
    "    } else {\n" \
    "        @assert(stream.@state === @streamReadable);\n" \
    "        @readableByteStreamControllerRespondInReadableState(controller, bytesWritten, firstDescriptor);\n" \
    "    }\n" \
    "})\n" \
;

const JSC::ConstructAbility s_readableByteStreamInternalsReadableByteStreamControllerRespondInReadableStateCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const int s_readableByteStreamInternalsReadableByteStreamControllerRespondInReadableStateCodeLength = 1358;
static const JSC::Intrinsic s_readableByteStreamInternalsReadableByteStreamControllerRespondInReadableStateCodeIntrinsic = JSC::NoIntrinsic;
const char* s_readableByteStreamInternalsReadableByteStreamControllerRespondInReadableStateCode =
    "(function (controller, bytesWritten, pullIntoDescriptor)\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "    if (pullIntoDescriptor.bytesFilled + bytesWritten > pullIntoDescriptor.byteLength)\n" \
    "        @throwRangeError(\"bytesWritten value is too great\");\n" \
    "    @assert(controller.@pendingPullIntos.length === 0 || controller.@pendingPullIntos[0] === pullIntoDescriptor);\n" \
    "    @readableByteStreamControllerInvalidateBYOBRequest(controller);\n" \
    "    pullIntoDescriptor.bytesFilled += bytesWritten;\n" \
    "    if (pullIntoDescriptor.bytesFilled < pullIntoDescriptor.elementSize)\n" \
    "        return;\n" \
    "    @readableByteStreamControllerShiftPendingDescriptor(controller);\n" \
    "    const remainderSize = pullIntoDescriptor.bytesFilled % pullIntoDescriptor.elementSize;\n" \
    "    if (remainderSize > 0) {\n" \
    "        const end = pullIntoDescriptor.byteOffset + pullIntoDescriptor.bytesFilled;\n" \
    "        const remainder = @cloneArrayBuffer(pullIntoDescriptor.buffer, end - remainderSize, remainderSize);\n" \
    "        @readableByteStreamControllerEnqueueChunk(controller, remainder, 0, remainder.byteLength);\n" \
    "    }\n" \
    "    pullIntoDescriptor.buffer = @transferBufferToCurrentRealm(pullIntoDescriptor.buffer);\n" \
    "    pullIntoDescriptor.bytesFilled -= remainderSize;\n" \
    "    @readableByteStreamControllerCommitDescriptor(controller.@controlledReadableStream, pullIntoDescriptor);\n" \
    "    @readableByteStreamControllerProcessPullDescriptors(controller);\n" \
    "})\n" \
;

const JSC::ConstructAbility s_readableByteStreamInternalsReadableByteStreamControllerRespondInClosedStateCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const int s_readableByteStreamInternalsReadableByteStreamControllerRespondInClosedStateCodeLength = 600;
static const JSC::Intrinsic s_readableByteStreamInternalsReadableByteStreamControllerRespondInClosedStateCodeIntrinsic = JSC::NoIntrinsic;
const char* s_readableByteStreamInternalsReadableByteStreamControllerRespondInClosedStateCode =
    "(function (controller, firstDescriptor)\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "    firstDescriptor.buffer = @transferBufferToCurrentRealm(firstDescriptor.buffer);\n" \
    "    @assert(firstDescriptor.bytesFilled === 0);\n" \
    "    if (@readableStreamHasBYOBReader(controller.@controlledReadableStream)) {\n" \
    "        while (controller.@controlledReadableStream.@reader.@readIntoRequests.length > 0) {\n" \
    "            let pullIntoDescriptor = @readableByteStreamControllerShiftPendingDescriptor(controller);\n" \
    "            @readableByteStreamControllerCommitDescriptor(controller.@controlledReadableStream, pullIntoDescriptor);\n" \
    "        }\n" \
    "    }\n" \
    "})\n" \
;

const JSC::ConstructAbility s_readableByteStreamInternalsReadableByteStreamControllerProcessPullDescriptorsCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const int s_readableByteStreamInternalsReadableByteStreamControllerProcessPullDescriptorsCodeLength = 586;
static const JSC::Intrinsic s_readableByteStreamInternalsReadableByteStreamControllerProcessPullDescriptorsCodeIntrinsic = JSC::NoIntrinsic;
const char* s_readableByteStreamInternalsReadableByteStreamControllerProcessPullDescriptorsCode =
    "(function (controller)\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "    @assert(!controller.@closeRequested);\n" \
    "    while (controller.@pendingPullIntos.length > 0) {\n" \
    "        if (controller.@totalQueuedBytes === 0)\n" \
    "            return;\n" \
    "        let pullIntoDescriptor = controller.@pendingPullIntos[0];\n" \
    "        if (@readableByteStreamControllerFillDescriptorFromQueue(controller, pullIntoDescriptor)) {\n" \
    "            @readableByteStreamControllerShiftPendingDescriptor(controller);\n" \
    "            @readableByteStreamControllerCommitDescriptor(controller.@controlledReadableStream, pullIntoDescriptor);\n" \
    "        }\n" \
    "    }\n" \
    "})\n" \
;

const JSC::ConstructAbility s_readableByteStreamInternalsReadableByteStreamControllerFillDescriptorFromQueueCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const int s_readableByteStreamInternalsReadableByteStreamControllerFillDescriptorFromQueueCodeLength = 2224;
static const JSC::Intrinsic s_readableByteStreamInternalsReadableByteStreamControllerFillDescriptorFromQueueCodeIntrinsic = JSC::NoIntrinsic;
const char* s_readableByteStreamInternalsReadableByteStreamControllerFillDescriptorFromQueueCode =
    "(function (controller, pullIntoDescriptor)\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "    const currentAlignedBytes = pullIntoDescriptor.bytesFilled - (pullIntoDescriptor.bytesFilled % pullIntoDescriptor.elementSize);\n" \
    "    const maxBytesToCopy = controller.@totalQueuedBytes < pullIntoDescriptor.byteLength - pullIntoDescriptor.bytesFilled ?\n" \
    "                controller.@totalQueuedBytes : pullIntoDescriptor.byteLength - pullIntoDescriptor.bytesFilled;\n" \
    "    const maxBytesFilled = pullIntoDescriptor.bytesFilled + maxBytesToCopy;\n" \
    "    const maxAlignedBytes = maxBytesFilled - (maxBytesFilled % pullIntoDescriptor.elementSize);\n" \
    "    let totalBytesToCopyRemaining = maxBytesToCopy;\n" \
    "    let ready = false;\n" \
    "    if (maxAlignedBytes > currentAlignedBytes) {\n" \
    "        totalBytesToCopyRemaining = maxAlignedBytes - pullIntoDescriptor.bytesFilled;\n" \
    "        ready = true;\n" \
    "    }\n" \
    "    while (totalBytesToCopyRemaining > 0) {\n" \
    "        let headOfQueue = controller.@queue[0];\n" \
    "        const bytesToCopy = totalBytesToCopyRemaining < headOfQueue.byteLength ? totalBytesToCopyRemaining : headOfQueue.byteLength;\n" \
    "        let fromIndex = pullIntoDescriptor.byteOffset + pullIntoDescriptor.bytesFilled;\n" \
    "        let count = bytesToCopy;\n" \
    "        let toIndex = headOfQueue.byteOffset;\n" \
    "        while (count > 0) {\n" \
    "            headOfQueue.buffer[toIndex] = pullIntoDescriptor.buffer[fromIndex];\n" \
    "            toIndex++;\n" \
    "            fromIndex++;\n" \
    "            count--;\n" \
    "        }\n" \
    "        if (headOfQueue.byteLength === bytesToCopy)\n" \
    "            controller.@queue.@shift();\n" \
    "        else {\n" \
    "            headOfQueue.byteOffset += bytesToCopy;\n" \
    "            headOfQueue.byteLength -= bytesToCopy;\n" \
    "        }\n" \
    "        controller.@totalQueuedBytes -= bytesToCopy;\n" \
    "        @assert(controller.@pendingPullIntos.length === 0 || controller.@pendingPullIntos[0] === pullIntoDescriptor);\n" \
    "        @readableByteStreamControllerInvalidateBYOBRequest(controller);\n" \
    "        pullIntoDescriptor.bytesFilled += bytesToCopy;\n" \
    "        totalBytesToCopyRemaining -= bytesToCopy;\n" \
    "    }\n" \
    "    if (!ready) {\n" \
    "        @assert(controller.@totalQueuedBytes === 0);\n" \
    "        @assert(pullIntoDescriptor.bytesFilled > 0);\n" \
    "        @assert(pullIntoDescriptor.bytesFilled < pullIntoDescriptor.elementSize);\n" \
    "    }\n" \
    "    return ready;\n" \
    "})\n" \
;

const JSC::ConstructAbility s_readableByteStreamInternalsReadableByteStreamControllerShiftPendingDescriptorCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const int s_readableByteStreamInternalsReadableByteStreamControllerShiftPendingDescriptorCodeLength = 197;
static const JSC::Intrinsic s_readableByteStreamInternalsReadableByteStreamControllerShiftPendingDescriptorCodeIntrinsic = JSC::NoIntrinsic;
const char* s_readableByteStreamInternalsReadableByteStreamControllerShiftPendingDescriptorCode =
    "(function (controller)\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "    let descriptor = controller.@pendingPullIntos.@shift();\n" \
    "    @readableByteStreamControllerInvalidateBYOBRequest(controller);\n" \
    "    return descriptor;\n" \
    "})\n" \
;

const JSC::ConstructAbility s_readableByteStreamInternalsReadableByteStreamControllerInvalidateBYOBRequestCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const int s_readableByteStreamInternalsReadableByteStreamControllerInvalidateBYOBRequestCodeLength = 282;
static const JSC::Intrinsic s_readableByteStreamInternalsReadableByteStreamControllerInvalidateBYOBRequestCodeIntrinsic = JSC::NoIntrinsic;
const char* s_readableByteStreamInternalsReadableByteStreamControllerInvalidateBYOBRequestCode =
    "(function (controller)\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "    if (controller.@byobRequest === @undefined)\n" \
    "        return;\n" \
    "    controller.@byobRequest.@associatedReadableByteStreamController = @undefined;\n" \
    "    controller.@byobRequest.@view = @undefined;\n" \
    "    controller.@byobRequest = @undefined;\n" \
    "})\n" \
;

const JSC::ConstructAbility s_readableByteStreamInternalsReadableByteStreamControllerCommitDescriptorCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const int s_readableByteStreamInternalsReadableByteStreamControllerCommitDescriptorCodeLength = 611;
static const JSC::Intrinsic s_readableByteStreamInternalsReadableByteStreamControllerCommitDescriptorCodeIntrinsic = JSC::NoIntrinsic;
const char* s_readableByteStreamInternalsReadableByteStreamControllerCommitDescriptorCode =
    "(function (stream, pullIntoDescriptor)\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "    @assert(stream.@state !== @streamErrored);\n" \
    "    let done = false;\n" \
    "    if (stream.@state === @streamClosed) {\n" \
    "        @assert(!pullIntoDescriptor.bytesFilled);\n" \
    "        done = true;\n" \
    "    }\n" \
    "    let filledView = @readableByteStreamControllerConvertDescriptor(pullIntoDescriptor);\n" \
    "    if (pullIntoDescriptor.readerType === \"default\")\n" \
    "        @readableStreamFulfillReadRequest(stream, filledView, done);\n" \
    "    else {\n" \
    "        @assert(pullIntoDescriptor.readerType === \"byob\");\n" \
    "        @readableStreamFulfillReadIntoRequest(stream, filledView, done);\n" \
    "    }\n" \
    "})\n" \
;

const JSC::ConstructAbility s_readableByteStreamInternalsReadableByteStreamControllerConvertDescriptorCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const int s_readableByteStreamInternalsReadableByteStreamControllerConvertDescriptorCodeLength = 379;
static const JSC::Intrinsic s_readableByteStreamInternalsReadableByteStreamControllerConvertDescriptorCodeIntrinsic = JSC::NoIntrinsic;
const char* s_readableByteStreamInternalsReadableByteStreamControllerConvertDescriptorCode =
    "(function (pullIntoDescriptor)\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "    @assert(pullIntoDescriptor.bytesFilled <= pullIntoDescriptor.byteLength);\n" \
    "    @assert(pullIntoDescriptor.bytesFilled % pullIntoDescriptor.elementSize === 0);\n" \
    "    return new pullIntoDescriptor.ctor(pullIntoDescriptor.buffer, pullIntoDescriptor.byteOffset, pullIntoDescriptor.bytesFilled / pullIntoDescriptor.elementSize);\n" \
    "})\n" \
;

const JSC::ConstructAbility s_readableByteStreamInternalsReadableStreamFulfillReadIntoRequestCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const int s_readableByteStreamInternalsReadableStreamFulfillReadIntoRequestCodeLength = 157;
static const JSC::Intrinsic s_readableByteStreamInternalsReadableStreamFulfillReadIntoRequestCodeIntrinsic = JSC::NoIntrinsic;
const char* s_readableByteStreamInternalsReadableStreamFulfillReadIntoRequestCode =
    "(function (stream, chunk, done)\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "    stream.@reader.@readIntoRequests.@shift().@resolve.@call(@undefined, {value: chunk, done: done});\n" \
    "})\n" \
;

const JSC::ConstructAbility s_readableByteStreamInternalsReadableStreamBYOBReaderReadCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const int s_readableByteStreamInternalsReadableStreamBYOBReaderReadCodeLength = 335;
static const JSC::Intrinsic s_readableByteStreamInternalsReadableStreamBYOBReaderReadCodeIntrinsic = JSC::NoIntrinsic;
const char* s_readableByteStreamInternalsReadableStreamBYOBReaderReadCode =
    "(function (reader, view)\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "    const stream = reader.@ownerReadableStream;\n" \
    "    @assert(!!stream);\n" \
    "    stream.@disturbed = true;\n" \
    "    if (stream.@state === @streamErrored)\n" \
    "        return @Promise.@reject(stream.@storedError);\n" \
    "    return @readableByteStreamControllerPullInto(stream.@readableStreamController, view);\n" \
    "})\n" \
;

const JSC::ConstructAbility s_readableByteStreamInternalsReadableByteStreamControllerPullIntoCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const int s_readableByteStreamInternalsReadableByteStreamControllerPullIntoCodeLength = 1904;
static const JSC::Intrinsic s_readableByteStreamInternalsReadableByteStreamControllerPullIntoCodeIntrinsic = JSC::NoIntrinsic;
const char* s_readableByteStreamInternalsReadableByteStreamControllerPullIntoCode =
    "(function (controller, view)\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "    const stream = controller.@controlledReadableStream;\n" \
    "    let elementSize = 1;\n" \
    "    if (view.BYTES_PER_ELEMENT !== @undefined)\n" \
    "        elementSize = view.BYTES_PER_ELEMENT;\n" \
    "    const ctor = view.constructor;\n" \
    "    const pullIntoDescriptor = {\n" \
    "        buffer: view.buffer,\n" \
    "        byteOffset: view.byteOffset,\n" \
    "        byteLength: view.byteLength,\n" \
    "        bytesFilled: 0,\n" \
    "        elementSize,\n" \
    "        ctor,\n" \
    "        readerType: 'byob'\n" \
    "    };\n" \
    "    if (controller.@pendingPullIntos.length) {\n" \
    "        pullIntoDescriptor.buffer = @transferBufferToCurrentRealm(pullIntoDescriptor.buffer);\n" \
    "        controller.@pendingPullIntos.@push(pullIntoDescriptor);\n" \
    "        return @readableStreamAddReadIntoRequest(stream);\n" \
    "    }\n" \
    "    if (stream.@state === @streamClosed) {\n" \
    "        const emptyView = new ctor(pullIntoDescriptor.buffer, pullIntoDescriptor.byteOffset, 0);\n" \
    "        return @Promise.@resolve({ value: emptyView, done: true });\n" \
    "    }\n" \
    "    if (controller.@totalQueuedBytes > 0) {\n" \
    "        if (@readableByteStreamControllerFillDescriptorFromQueue(controller, pullIntoDescriptor)) {\n" \
    "            const filledView = @readableByteStreamControllerConvertDescriptor(pullIntoDescriptor);\n" \
    "            @readableByteStreamControllerHandleQueueDrain(controller);\n" \
    "            return @Promise.@resolve({ value: filledView, done: false });\n" \
    "        }\n" \
    "        if (controller.@closeRequested) {\n" \
    "            const e = new @TypeError(\"Closing stream has been requested\");\n" \
    "            @readableByteStreamControllerError(controller, e);\n" \
    "            return @Promise.@reject(e);\n" \
    "        }\n" \
    "    }\n" \
    "    pullIntoDescriptor.buffer = @transferBufferToCurrentRealm(pullIntoDescriptor.buffer);\n" \
    "    controller.@pendingPullIntos.@push(pullIntoDescriptor);\n" \
    "    const promise = @readableStreamAddReadIntoRequest(stream);\n" \
    "    @readableByteStreamControllerCallPullIfNeeded(controller);\n" \
    "    return promise;\n" \
    "})\n" \
;

const JSC::ConstructAbility s_readableByteStreamInternalsReadableStreamAddReadIntoRequestCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const int s_readableByteStreamInternalsReadableStreamAddReadIntoRequestCodeLength = 330;
static const JSC::Intrinsic s_readableByteStreamInternalsReadableStreamAddReadIntoRequestCodeIntrinsic = JSC::NoIntrinsic;
const char* s_readableByteStreamInternalsReadableStreamAddReadIntoRequestCode =
    "(function (stream)\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "    @assert(@isReadableStreamBYOBReader(stream.@reader));\n" \
    "    @assert(stream.@state === @streamReadable || stream.@state === @streamClosed);\n" \
    "    const readRequest = @newPromiseCapability(@Promise);\n" \
    "    stream.@reader.@readIntoRequests.@push(readRequest);\n" \
    "    return readRequest.@promise;\n" \
    "})\n" \
;


#define DEFINE_BUILTIN_GENERATOR(codeName, functionName, argumentCount) \
JSC::FunctionExecutable* codeName##Generator(JSC::VM& vm) \
{\
    JSVMClientData* clientData = static_cast<JSVMClientData*>(vm.clientData); \
    return clientData->builtinFunctions().readableByteStreamInternalsBuiltins().codeName##Executable()->link(vm, clientData->builtinFunctions().readableByteStreamInternalsBuiltins().codeName##Source(), std::nullopt, s_##codeName##Intrinsic); \
}
WEBCORE_FOREACH_READABLEBYTESTREAMINTERNALS_BUILTIN_CODE(DEFINE_BUILTIN_GENERATOR)
#undef DEFINE_BUILTIN_GENERATOR


} // namespace WebCore

#endif // ENABLE(STREAMS_API)
